unit BoiteNoire;
{ gestion de la boite noire de sauvegarde des data }
{ les fichiers sont affichs separement. si le chemin n'existe pas : il est cree               }
{ On utilise des champs de la base de registre                                                 }
{ * "currentFile" : fichier de data en cours                                                   }
{ * "RepertoireManip": repertoire courant de la manip en cours                                 }
{ Ces champs sont stocks sous la clef "\PilotageManip"                                        }
{ Si ces champs n'existent pas dans la base de registre, on utilise                            }
{ "c:\boite" et "toto" par dfaut                                                              }
{ N.B. : il est donc toujours souhaitable de creer un rpertoire c:\boite                      }
{ A FAIRE                                                                                      }
{ cration automatique des entres dans la base de registre (a voir)                           }
{ MODIFICATIONS                                                                                }
{ 04.02.2000: modification de la gestion de l'ouverture des fichiers                           }
{             Bug mineur: le chemin complet du fichier de data s'affiche systmatiquement      }
{ 13/06/00: EDOUARD modification de la gestion de l'ouverture des fichier le chemin et le nom  }
{ dernire mise  jour le 31.10.2000                                                           }
{ 12.01.01: FO : spupression de la dclaration const sreg='PilotageManip' et passage dans Editdata }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, editdata, registry;

{ const
 sreg='\PilotageManip'; { clef de la base de registre ou sont stocks les informations des rpertoires }
{ sreg='\manips'; }

type
  TMyThread = class(TThread)
    protected
    procedure execute; override;
    end;

  Tboitnoir = class(TForm)
    WebButton: TPanel;
    Edit1: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    OpenFileBoiteNoire: TButton;
    Label3: TLabel;
    repertoiremanip: TEdit;
    Button1: TButton;
    Button3: TButton;
    RichEdit1: TMemo;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OpenFileBoiteNoireClick(Sender: TObject);
    procedure repertoiremanipKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
     {ajout alloul}
    procedure ouverture;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);

  private
    { Dclarations prives }
  filename:string;
  public
    regis:tregistry;
    currep:string;
    repseq:string;
    { Dclarations publiques }
    procedure receivetext(s:string);
    procedure newfile(s:string);
  end;

var
  boitnoir: Tboitnoir;
  defaultdir:tfilename;

implementation

uses dialogNewSpectrum, interpreteur;

{$R *.DFM}

procedure Tboitnoir.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then begin
receivetext(edit1.text);
edit1.clear;
end;
end;

{ creation des rpertoire par dfaut  parir de la base de registres }

procedure Tboitnoir.FormCreate(Sender: TObject);
var
s,s1,s2:string;
tf:boolean;
nomFichier,directory_NMR:string;
fich:textfile;
begin
regis:=tregistry.create;
tf:=regis.openkey(sreg,true);
if tf then
   begin
   {s:=regis.readstring('dir');
   s1:=regis.readstring('repseq');}
   s2:=regis.readstring('currentfile');
   repertoiremanip.text:=regis.readstring('RepertoireManip');
   {changement ajout Alloul, on met notre propre repertoire manip ici}
   {lit le fichier c:\newspectro\data\current.doc qui contient le nom du dernier directory utilis}
    nomFichier:='c:\newspectro\data\current.txt';
    assignfile(fich,nomFichier);
    reset(fich);
    read(fich,directory_NMR);
    closefile(fich);
    ChDir(directory_NMR); {specifie le directory de travail}
    repertoiremanip.text:=directory_NMR;
   {if length(s)<2 then
      begin
      regis.writestring('dir','c:\spe\');
      regis.writestring('repseq','c:\boite\');
      regis.writestring('currep','c:\boite\essai.txt');
      s:='c:\spe\';s1:='c:\boite';
      s2:='c:\boite\essai.txt';              regis.
      end;}
   end
else
    begin
    {s:='c:\spe\';s1:='c:\boite';
    s2:='c:\boite\essai.txt'; }
    repertoiremanip.text:='c:\boite';
    s2:='toto';
    end;

defaultdir:=s+s2;
repseq:=s1;
newfile(s2);
top:=0;
left:=600;
width:=380;
height:=350;
end;


procedure Tboitnoir.receivetext(s:string);
var
fich:textfile;nomNouvelleBoite,s1,s2:string;
directory_NMR:string;
begin
assignfile(fich,filename);
if fexis(filename) then append(fich) else rewrite(fich);
writeln(fich,s);
closefile(fich);
richedit1.selstart:=length(richedit1.text)-1;

richedit1.lines.add(s);
{ajout Alloul : si boite noire trop grande, on en ouvre une nouvelle
dans le directory de travail}
if (richedit1.Lines.Count)>1000 then
     begin
    {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
     assignfile(fich,'c:\NewSpectro\data\current.txt');
     reset(fich);
     readln(fich,directory_NMR);
     closefile(fich);
     ChDir(directory_NMR); {specifie le repertoire de travail}
     repertoiremanip.text:=directory_NMR;

     s:=' ';
     richedit1.lines.add(s);
     s:='FERMETURE BOITE NOIRE : '+datetostr(date)+' '+ timetostr(time);
     richedit1.lines.add(s);
     s:='**************************************************************';
     richedit1.lines.add(s);
     s1:=copy(datetostr(date),1,2)+'-'+copy(datetostr(date),4,2)+'-'+copy(datetostr(date),7,2);
     s2:=copy(timetostr(time),1,2)+'h'+copy(timetostr(time),4,2);
     nomNouvelleBoite:='Boite Noire '+s1+' '+s2;
     s:='PROCHAINE BOITE NOIRE : '+nomNouvelleBoite+'.txt';
     richedit1.lines.add(s);
     newfile(nomNouvelleBoite);
     end;

end;

{ ouverture d'un fichier pour la boite noire }
{ INPUT: le nom simple ex 'toto'            }
{ OUTPUT: le memo de la boite noire est mis a jour }
procedure Tboitnoir.newfile(s:string);
var fich:textfile;nomNouvelleBoite,s1,s2:string;
directory_NMR:string;
begin
richedit1.Clear;
{ancienne version Fermon:
repertoiremanip.text:=regis.readstring('RepertoireManip');}
assignfile(fich,'c:\NewSpectro\data\current.txt');
reset(fich);
readln(fich,directory_NMR);
closefile(fich);
ChDir(directory_NMR); {specifie le repertoire de travail}
repertoiremanip.text:=directory_NMR;

{$I-}
mkdir(repertoiremanip.text); {creation du repertoire}
{$I+}
IOResult;

filename:=repertoiremanip.text+'\'+s+'.txt';
regis.writestring('currentfile',s);
if fexis(filename) then
   richedit1.Lines.LoadfromFile(filename);
{ajout Alloul : on enleve les deux lignes qui suivent
pour que quand on ouvre une vieille boite noire trop grosse
il l'ouvre quand meme mais n'y ajoute rien}
{receivetext(datetostr(date)+'  '+timetostr(time));
receivetext('ouverture de '+filename);}
caption:=filename;
edit2.text:=s;
richedit1.selstart:=length(richedit1.text)-1;
end;

procedure Tboitnoir.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then newfile(edit2.text);


end;

procedure Tboitnoir.OpenFileBoiteNoireClick(Sender: TObject);
var  S: string;
     tampfile,tamppath:string;
    len,i,j:integer;
begin
opendialog1.initialDir:=RepertoireManip.text;
if OpenDialog1.Execute then  { Affichage de la bote de dialogue d'ouverture }
  begin
  s:=OpenDialog1.FileName;
  len:=length(s);
  tampfile:='';
  tamppath:='';
  i:=len+1;
  repeat
    i:=i-1;
  until s[i]='.'; {l'extension est enlevee}
  i:=i-1;
  repeat
    tampfile:=s[i]+tampfile;
    i:=i-1;
  until s[i]='\'; {tampfile=nom cour}
  for j:=1 to i-1 do
     tamppath:=tamppath+s[j];

  regis.writestring('RepertoireManip',tamppath);
  newfile(tampfile);{ Fichier slectionn dans la bote de dialogue }
  end;
end;

procedure Tboitnoir.repertoiremanipKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then
   begin
   {saisie du nom du fichier}
   enterdlg.editeur.text:=edit2.text;
   enterdlg.editeur.maxlength:=15;
   if enterdlg.showmodal=mrOK then
      if enterdlg.editeur.text<>'' then
         edit2.text:=enterdlg.editeur.text;

   regis.writestring('RepertoireManip',repertoiremanip.text);
   newfile(edit2.text);
   end;

end;

{ajout alloul}
procedure TBoitNoir.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
boitnoir.WindowState:=WsMinimized;
boitnoir.WindowState:=WsNormal;
end;

procedure TMyThread.execute;
var i:integer;
begin
{procedure que le thread execute}

end;


procedure Tboitnoir.Button2Click(Sender: TObject);
var process:tthread;
begin
{execution d'un thread en priorit basse}
process:=Tmythread.create(true);
process.priority:=tplowest;
process.resume;
end;

procedure Tboitnoir.Button1Click(Sender: TObject);
var process:tthread;
begin
    {execution d'un thread en priorit basse}
process:=Tmythread.create(true);
process.priority:=tpHighest;
process.resume;
end;

procedure Tboitnoir.Button3Click(Sender: TObject);
{creates a ascii 'update.txt' file with update of parameters}
var chaine:string;drapeau2:boolean;i:integer;
begin
end;

procedure Tboitnoir.Button4Click(Sender: TObject);
var process:tthread;
begin
process:=Tmythread.create(true);
process.priority:=tplowest;
process.resume;

end;

end.
