unit DrapeauAlloulUnit;
{unit qui contient juste des drapeaux et un tableau
que d'autres applications peuvent alors partager en commun,
notament utile pour les acquisitions avec gestgage pour contourner le probleme de gestgage
qui disparait en tant que pointeur de fenetre acquisparam des que l'on utilise setboard ou
d'autres instructions gage}
interface
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,StdCtrls, ComCtrls, Spin, Buttons, ToolWin, math,FileCtrl;


type
  TUneLigne=array[1..10] of extended;
  TTableau=array[1..20000] of TUneLigne;  {TTableau[ligne][colonne]}
const
  nomFichierParametresRMN='c:\newspectro\Parametres RMN.txt';
  CaractereRAppelOrdrePrecedent='*';
  
{au depart, par defaut, les drapeaux sont  false}
var
    DrapeauAcquisitionNMRencours:boolean; { TRUE si acquisition RMN Alloul en cours}
    DrapeauGAGEdejaInitialise:boolean; { TRUE si carte GAGE deja initialisee par gestgage}
    SEQUENCEURCARACTERE:string;
    DrapeauParametreGAGEaeteChange:boolean;{ true si un parametre dans gestgage a t chang}
    NbCoupsAFaireNMR:integer;{nb coups  faire par acquisition}
    NbCoupsDejaFaitNMR:integer;{nb coups  faire par acquisition}
    DrapeauModeAcquisitionCyclop,DrapeauModeAcquisition1pulse,DrapeauModeAcquisition2pulses,DrapeauModeAcquisition16pulses,DrapeauModeAcquisition4pulses:boolean; {TRUE si acquisition RMN Alloul alterne
    une fois en + une fois en -}
totototo:extended;
    DrapeauSansRafraichissement:boolean;   {activ  TRUE dans la fentre editeur de squence}
    GraphArray:TTableau;
    LabelGraphArray:array[1..10] of string;
    LastLineArray:integer; {numero de la derniere ligne du tableau GraphArray}
    GainCarteGageB,GainCarteGageA:extended; {valeurs en volt des gains sur carte GAGE des deux voies}
    positionMarkerSeq,MarkerLengthSeq:extended;
    DrapeauIterationMarkerSeq:boolean;
    DrapeauCarteGAGE14100,DrapeauCarteGAGE1450,DrapeauCarteGAGE1012:boolean;
    NbPointsParChannel:integer;
    DrapeauAcquisitionVientDeFinir:boolean;
    TimePerChannel:extended;
    RangeVoltA,RangeVoltB:extended;
    NMRRadioFrequency,GeneRadioFrequency {NMRRadioFrequency+210},NMRdBMLevel:extended;
    DrapeauGPIBconnection,DrapeauInTuning:boolean;
    DrapeauSpectroHomodyne,DrapeauSpectroOldHetero:boolean;
    DrapeauAcquisition4pulses,DrapeauAcquisition2pulses,DrapeauSequenceur16VoiesRecognitionStep:boolean;
    TempsRepetition:double; {temps de repetition en msec}
    NbreNombres,NbreChaines,NbreVariables,nbreArgumentsTotal:integer;
    TableauNombres:array[1..40] of extended;
    TableauChaines:array[1..40] of string;
    TableauIndicesVariables:array[1..40] of integer;
    TableauValeursVariables:array[1..40] of extended;
    TableauNomsVariables:array[1..40] of string;
    TableauNombresEtValeursVariables:array[1..40] of extended;
    par:array[1..40] of extended;
    pars:array[1..40] of  string;
    Intervalle:boolean;
    TimeSwitch:double;
    ChampStable:boolean;
    DrapeauSequenceurTimeCheck:boolean;RepetitionTime:double;
    DrapeauSoftSubstraction,GageRecognition16channels:boolean;
    ChampInitial,ChampFinal:extended;
    DrapeauChampSMSDejaInitialise,DrapeauKeithleyDejaInitialise,
    DrapeauSpectroHetero2005,DrapeauSeq16ChannelsLibre,DrapeauSeqParHasBeenChanged:boolean;
    drapeauITC4,drapeauITC5,drapeauConductus:boolean;
    DrapeauSoustraitBackground,DrapeauNormalizeData:boolean;
    DrapeauInterpreteurTimer1Enabled:boolean;
    InstructionInterpreteur:array[1..20] of string;
    NumeroInstructionPrecedente:integer;
    drapeauStartAgainSequence:boolean;
    TableauSignesReceptionNMR:array[1..2] of array[1..16] of integer;
    NombreStepsPourReception:integer;
    DrapeauRFGenerateurRohdeSchwarz,DrapeauRFGenerateurMarconi2023,DrapeauRFGenerateurMarconi2022D,DrapeauFieldSweep:boolean;
    DrapeauStopPourTuning,DrapeauSpectroHetero2003:boolean;
    alphaParks,gammaParks:extended;
    ITC5LastReadTemperature,ITC4LastReadTemperature,conductus1LastReadTemperature,conductus2LastReadTemperature:extended;
    DrapeauDataNegatifExiste:boolean;
    ModeAcquisition4pulse,DrapeauT1InifiniteLoop:boolean;
    MomentOuOnAFermeLaSequence:extended;
    { Dclarations publiques }
     function LitDansParametresRMN(NomParametre:string):string;
     procedure EcritDansParametresRMN(NomParametre,ValeurParametre:string);
     procedure TestExistenceParametresRMN;
     function ExtraitNomDirectory(Dir:string):string;
     function ExtraitNombreApresChaine(souschaine,chaine:string):extended;
     
implementation

procedure TestExistenceParametresRMN;
var nomFichier,chaine:string;fich:textfile;
{envoie un message si parametres rmn.txt n'existe pas ou est vide
et le cree dans ce cas}
begin
nomFichier:=nomFichierParametresRMN;

if not(fileexists(nomFichier)) then
 begin
 chaine:='The file '+nomFichier+' does not exist. A new one is created with new defaut values. Please check all your parameters (GAGE, reception, pulses...)';
 MessageDlg(chaine, mtWarning, [mbOk], 0);
 {creation de parametres RMN.txt}
 assignfile(fich,nomFichier);
 rewrite(fich);
 writeln(fich,'Parameters of the last NMR experiment :');
 writeln(fich,'***************************************');
writeln(fich,'Acquisition GAGE Parameters for GAGE 1012 and GAGE 1450');
writeln(fich,'***************************************');
writeln(fich,'Chanel A (+/-10V +/-5V +/-2V +/-1V +/-0.5V  +/-0.2V  +/-0.1V)');
writeln(fich,'+/-5V');
writeln(fich,'Chanel B (Volts)');
writeln(fich,'+/-5V');
writeln(fich,'Chanel A (Mode AC ou DC)');
writeln(fich,'DC');
writeln(fich,'Chanel B (Mode AC ou DC)');
writeln(fich,'DC');
writeln(fich,'Nb Points (16 32 64 128 256 512 1024 2048 4096 8192)');
writeln(fich,'4096');
writeln(fich,'Digit Freq (10 MHz 5 MHz 4 MHz 2 MHz 1 MHz 500 KHz 200 KHz 100 KHz 50 KHz  20 KHz  10 KHz 5 KHz 2 KHz  1 KHz EXTERNE)');
writeln(fich,'1 MHz');
writeln(fich,'Trigger (POSITIF/NEGATIF)');
writeln(fich,'POSITIF');
writeln(fich,'Trigger (VOIE A/VOIE B/VOIE A et B/EXTERNE/SOFT)');
writeln(fich,'EXTERNE');
writeln(fich,'Trigger (niveau)');
writeln(fich,'3.00');
writeln(fich,'Trigger (DC/AC)');
writeln(fich,'DC');
writeln(fich,'***************************************');
writeln(fich,'New Heterodyne Spectrometer 2003 :');
writeln(fich,'***************************************');
writeln(fich,'Gain HF new hetero');
writeln(fich,'150');
writeln(fich,'Gain BF0 new hetero');
writeln(fich,'100');
writeln(fich,'Gain BF90 new hetero');
writeln(fich,'100');
writeln(fich,'Offset 0 new hetero');
writeln(fich,'32768');
writeln(fich,'Offset 90 new hetero');
writeln(fich,'32768');
writeln(fich,'Additional phase new hetero');
writeln(fich,'0');
writeln(fich,'Quadrature correction new hetero');
writeln(fich,'58000');
writeln(fich,'***************************************');
writeln(fich,'Old Heterodyne Spectrometer :');
writeln(fich,'***************************************');
writeln(fich,'Reception Amplifiers');
writeln(fich,'Gain HF1 old hetero');
writeln(fich,'140');
writeln(fich,'Gain HF2 old hetero');
writeln(fich,'160');
writeln(fich,'Gain Lo0 old hetero');
writeln(fich,'180');
writeln(fich,'Gain Lo90 old hetero');
writeln(fich,'180');
writeln(fich,'Gain BF0 old hetero');
writeln(fich,'170');
writeln(fich,'Gain BF90 old hetero');
writeln(fich,'170');
writeln(fich,'Phase F+Lo1 old hetero');
writeln(fich,'200');
writeln(fich,'Phase F+Lo2 old hetero');
writeln(fich,'200');
writeln(fich,'Frequence Lo = 15*F old hetero');
writeln(fich,'14000000');
writeln(fich,'******************************');
writeln(fich,'Last Pulse Sequence (exple : nom.seq (found in sequenceRMN) )');
writeln(fich,'C:\newspectro\SequenceRMN\echoAlterne.seq');
writeln(fich,'***************************************');
writeln(fich,'Data Manipulation');
writeln(fich,'***************************************');
writeln(fich,'Automatic Background Substraction (YES/NO)');
writeln(fich,'YES');
writeln(fich,'Normalization of data when acquisition (YES/NO)');
writeln(fich,'NO');
writeln(fich,'***************************************');
writeln(fich,'Last File of Parameters for Fourier Transform :');
writeln(fich,'no file saved');
writeln(fich,'***************************************');
writeln(fich,'***************************************');
closefile(fich);
end;
end;




function LitDansParametresRMN(NomParametre:string):string;
{lit dans Parametres RMN.txt : une ligne ou il y a NomParametre,
il renvoit la ligne suivante
Si il n'y a pas cette ligne, il renvoit ''}
var nomFichier:string;chaine,chaine2:string;fich:textfile;
i:integer;

begin
nomFichier:=nomFichierParametresRMN;
chaine2:='';
if fileexists(nomFichier) then
 begin
  assignfile(fich,nomFichier);
  reset(fich);

  while not eof(Fich) do
      begin
      readln(Fich,chaine);
      if pos(NomParametre,chaine)>0 then
                readln(Fich,chaine2);
      end;
  closefile(fich);
 end;
 LitDansParametresRMN:=chaine2;
end;

procedure EcritDansParametresRMN(NomParametre,ValeurParametre:string);
{ecrit dans Parametres RMN.txt  la ligne qui suit la ligne contenant NomParametre
une ligne ou il y a valeurParametre
Si cette ligne n'existe pas, la cree a la fin de parametresrmn.txt}
var nomFichier:string;chaine,chaine2:string;
    tableauChaine:array[1..200] of string;fich:textfile;
    i,j:integer;drapeau:boolean;

begin
nomFichier:=nomFichierParametresRMN;
chaine2:='';
if fileexists(nomFichier) then
 begin
  assignfile(fich,nomFichier);
  reset(fich);
  i:=0;
  while not eof(Fich) do
      begin
      i:=i+1;
      readln(Fich,tableauchaine[i]);
      end;
  closefile(fich);
  drapeau:=false;
  for j:=1 to (i-2) do
      begin
          if (pos(NomParametre,TableauChaine[j])>0) and (drapeau=false) then
             begin
             drapeau:=true;
             TableauChaine[j+1]:=ValeurParametre;
             end;
      end;
  assignfile(fich,nomFichier);
  rewrite(fich);
  for j:=1 to (i) do writeln(fich,tableauchaine[j]);
  if (drapeau=false) then
                     begin
                     writeln(fich,NomParametre);
                     writeln(fich,ValeurParametre);
                     end;
  closefile(fich);
 end;

end;


function ExtraitNomDirectory(Dir:string):string;
{extrait "directory" de c:\apfojipaeofj\afmeoomj\jafz\pjafe\directory)}
var i:integer;
begin
     i:=-1;
     repeat
      i:=i+1;
     until ((copy(Dir,length(Dir)-i,1)='\')) or (i=length(Dir));
     if i<>length(Dir) then ExtraitNomDirectory:=copy(Dir,length(Dir)-i+1,i)
                       else ExtraitNomDirectory:='';

end;


function ExtraitNombreApresChaine(souschaine,chaine:string):extended;
{extrait un nombre dans une chaine : si souschaine="X = " et chaine="X = 16.398 TITI", il renvoit 16.398
Si il ne trouve rien, il renvoit -999}

var i,j:integer;
    s1,s2:string;
    resultat,nombre:extended;err:integer;
begin
resultat:=-999;
if (pos(souschaine,chaine)>0) then
  begin
     s1:=copy(chaine,pos(souschaine,chaine)+length(souschaine),length(chaine)-pos(souschaine,chaine)+length(souschaine));
     for i:=1 to length(s1) do
         begin
         s2:=copy(s1,1,i);
         val(s2,nombre,err);
         if err=0 then resultat:=nombre;
         end;
  end;
ExtraitNombreApresChaine:=resultat;

end;

end.
