unit GAGE_Gainter;

interface

uses Windows,Controls,GAGE_drv,GAGE_sta1012;


const
     INTERPOLATE_TRIGGER_DISABLE = 32;
     boards_in_system=1;
     BLF            = 260;
     TRIG_TIMEOUT   = 10;
     BUSY_TIMEOUT   = 10;
     seg=$D000;
     ind=$200;
     interpolate_trigger_channel= INTERPOLATE_TRIGGER_DISABLE;
var
    board_info:             gage_driver_info_type;
     gage_board_location:    gage_b_l_array;
     interpolate_trigger:         int16;
     {interpolate_trigger_channel: int16;
      To disable the interpolated trigger use:
          interpolate_trigger_channel := INTERPOLATE_TRIGGER_DISABLE;
       otherwise use
          interpolate_trigger_channel := "low level channel number."    }
    buffer:                 array[0..BLF] of char;


      procedure init_chan_memory_pointers (board, chan, operation_mode: int16; tbs: single; var trig: int32;
                var start: int32; var endaddr: int32);
      procedure init_memory_pointers (board, operation_mode: int16; tbs: single; var trig: address;
                 var start: address; var endaddr: address);
      procedure   Timing (point1msec: word);
      function InitBoard(hwindow:hwnd): integer;
      procedure InitMemPtrs;
      procedure SetBoard(hwindow:hwnd);
      procedure AcquireStart;

implementation

function InitBoard(hwindow:hwnd): integer;
var cfgfn: pchar;
begin
     {gage_set_records(gage_board_location, 0, seg, ind, 0, 0);}

     cfgfn:='c:\windows\gagescop.inc';
      gage_read_config_file(cfgfn,gage_board_location);

     {gage_board_location[0]:=seg;
     gage_board_location[1]:=ind;  }
     if gage_driver_initialize(gage_board_location, GAGE_MEMORY_SIZE_TEST) = 0 then
     begin
          MessageBox(HWindow, 'No Compuscope boards found', 'Error', mb_ok);
     end;
     gage_initialize_start_capture(1);
     Timing (100); { Let the relays settle. }
end;





procedure init_interpolate_trigger (board, trigger_source, operation_mode, trigger_level, trigger_slope: int16);
begin
      gage_reset_interpolate_trigger (0, GAGE_CHAN_A, 0, 0, 0); {Disable interpolated trigger.}
end;


procedure init_chan_memory_pointers (board, chan, operation_mode: int16; tbs: single; var trig: int32;
                                    var start: int32; var endaddr: int32);
begin
    gage_select_board (board);
    gage_calculate_addresses (chan AND 1, operation_mode, tbs, trig, start, endaddr);
{    gage_get_interpolate_trigger(0,chan and 1,trig,start,endaddr);}
end;


procedure init_memory_pointers (board, operation_mode: int16; tbs: single; var trig: address;
                               var start: address; var endaddr: address);
var
    i:int16;
    trigr,startr,endaddrr:int32;
begin
     if interpolate_trigger_channel<interpolate_trigger_disable then begin
    gage_select_board (board);
    gage_calculate_addresses (interpolate_trigger_channel AND 1, operation_mode, tbs, trigr, startr, endaddrr);
{    gage_get_interpolate_trigger(0,interpolate_trigger_channel and 1,trigr,startr,endaddrr);}
     end;
     FOR i:=0 to 1 do  begin
         init_chan_memory_pointers (1, i, operation_mode, tbs, trig[i], start[i], endaddr[i]);
      end;
end;

procedure Timing (point1msec: word);
begin
     { CX: Loop Counter }
     { Pascal takes care of the stack for your. }
     asm
        mov  cx,point1msec
        jcxz @t2_fast_return   { Routine required no timeout. }

     @t2_init_timer_2:

        mov  al,10110110B      { Init T/C 2, 2 bytes, Mode 3, Binary count.}
        out  43h,al

        mov  ax,1193           { Timing constant = approximately 1,000 Hz.}
        mov  ax,119            { Timing constant = approximately 10,000 Hz.}
        out  42h,al            { Loat Timer #2. }
        mov  al,ah
        out  42h,al

        in   al,61h            { Get Current 8255 port 1 value. }
        and  al,0fch           { Clear last two bits of port. }
        or   al,1              { Turn Timer #2 GATE on. }
        out  61h,al

     @t2_wait_expire_time:

     @t2_low_to_high:

        in   al,61h            { Get timer 2 status. Use 61h because it's not an PC/XT. }
        test al,20h            { Test the Timer channel 2 bit. }
        jnz  @t2_low_to_high   { Loop until it is low. }

     @t2_wait_high:

        in   al,61h            { Get timer 2 status. }
        test al,20h            { Test the bit again. }
        jz   @t2_wait_high     { Loop until it goes high. }
        loop @t2_wait_expire_time    { Loop CX times. }

     @t2_return:
        in   al,61h            { Get current port values. }
        and  al,0fch           { Clear speaker bit. }

     @t2_fast_return:
   end;
end;

procedure InitMemPtrs;
begin
init_memory_pointers (1, optionGAGE^.opmode, gage^.srtable[optionGAGE^.srindex].sr_calc, gage^.trigger_address,
                          gage^.starting_address,gage^.ending_address);
end;

procedure SetBoard(hwindow:hwnd);
var
     i: int16;
     error_code: int16;
     tempstr: string[8];
     error_str: array[0..7] of char;
     j:integer;
begin
     gage_select_board(1);  {Select master}
     gage_capture_mode(optionGAGE^.opmode,gage^.srtable[optionGAGE^.srindex].rate,gage^.srtable[optionGAGE^.srindex].mult);
     gage_input_control(GAGE_CHAN_A, GAGE_INPUT_ENABLE, optionGAGE^.couple_a, optionGAGE^.range_a);
     if optionGAGE^.opmode = GAGE_SINGLE_CHAN then
          gage_input_control(GAGE_CHAN_B, GAGE_INPUT_ENABLE, optionGAGE^.couple_a, optionGAGE^.range_a)
     else
          gage_input_control(GAGE_CHAN_B, GAGE_INPUT_ENABLE, optionGAGE^.couple_b, optionGAGE^.range_b);
     gage_get_driver_info(board_info);
     j:=round(exp(optionGAGE^.depth*ln(2)));
     gage_trigger_control(optionGAGE^.source, optionGAGE^.couple_e, optionGAGE^.range_e,optionGAGE^.slope, optionGAGE^.level,j);
      {gage_multiple_record(1);}
       gage^.buffer_size := board_info.max_available_memory;
       gage^.buffer_mask := gage^.buffer_size - 1;
end;

procedure AcquireStart;
var
    auto_trigger: int16;
begin
     if optionGAGE^.source = GAGE_SOFTWARE then
         auto_trigger := 1 else auto_trigger := 0;
     asm {gestion interuptions}
     mov dx,0200h
     mov al,04
     out dx,al
     mov al,10100100b
     inc dx
     out dx,al
     end;
     gage_start_capture(auto_trigger);
     end;

end.
