unit Seq16Channels;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, Buttons,ExtCtrls, xyGraph,  ComCtrls, Spin,  ToolWin,
  math, EditReal,editdata,DrapeauAlloulUnit, Comrs232;


const
  ntemps=20;
  nampli=10;
  nphase=10;

type
  TSeq16ChannelsForm = class(TForm)
    listseqpar: TStringGrid;
    EditSeq: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Stop: TBitBtn;
    Start: TButton;
    Status: TLabel;
    ModeAcquisition2pulses: TCheckBox;
    SansRafraichissement: TCheckBox;
    ModeAcquisitionStandard: TCheckBox;
    NomSequenceRMN: TLabel;
    openbutton: TButton;
    saveButton: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    PositionMarkerBox: TEdit;
    MarkerLengthBox: TEdit;
    CommPortDriverPulse1: TCommPortDriver;
    GAGErecognitionBox: TCheckBox;
    TempsRepetitionBox: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Button4: TButton;
    Label2: TLabel;
    Timer1: TTimer;
    Label7: TLabel;
    sauverSimple: TButton;
    procedure ouverture;
    procedure initialisation;
    procedure Sauver1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure StartSequenceur;
    procedure Close(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ModeAcquisition2pulsesClick(Sender: TObject);
    procedure SansRafraichissementClick(Sender: TObject);
    procedure ModeAcquisitionStandardClick(Sender: TObject);
    procedure OpenSerialPort;
    procedure CloseSerialPort;
    procedure StartClick(Sender: TObject);
    procedure LitBuffer0123(var Caractere:char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonPulseRecep2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TempsRepetitionBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GAGErecognitionBoxClick(Sender: TObject);
    procedure chargefichier(filename:string);
    procedure Button4Click(Sender: TObject);
    procedure sauverSimpleClick(Sender: TObject);
    {procedure ecriture(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure autorisation(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);}


  private
      FTempInBuffer2              : pointer;

    { Dclarations prives}
  public
    procedure ChangeParametreSequence(nomParam:string;Valeur:real);

    { Dclarations publiques}
end;

var
  Seq16ChannelsForm: TSeq16ChannelsForm;
  TempsTotalUneSequence:extended; {temps total en nanosecondes pour une sequence}
implementation

{$R *.DFM}

procedure TSeq16ChannelsForm.ouverture;
var result:boolean;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
Seq16ChannelsForm.WindowState:=WsMinimized;
Seq16ChannelsForm.WindowState:=WsNormal;

end;

procedure TSeq16ChannelsForm.initialisation;
var i:integer;
    s:string;
begin
      {initial directory for NMR pulse sequences}
      OpenDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\Sequenceur16Channels';
      SaveDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\Sequenceur16Channels';

      GAGErecognitionBox.visible:=true;
      label7.visible:=true;tempsrepetitionbox.visible:=true;
      DrapeauSequenceur16VoiesRecognitionStep:=false;
      listseqpar.Cells[0,0]:='Variable';
      listseqpar.Cells[1,0]:='Delay (msec)';
      listseqpar.ColCount:=2;

      editseq.left:=200;
      for i:=1 to ntemps do Seq16ChannelsForm.listseqpar.cells[0,i]:=chr(64+i);


      {initialisation de la connexion RS232 necessaire ensuite}
      CommPortDriverPulse1.ComPort:=pnCOM1; // Choose pnCOM1 or pnCOM2
      CommPortDriverPulse1.ComPortSpeed:= br57600; //9600 Bauds
      CommPortDriverPulse1.ComPortDataBits           := db8BITS; // 8 data bits
      CommPortDriverPulse1.ComPortStopBits           := sb1BITS; // 1 stop bit
      CommPortDriverPulse1.ComPortParity             := ptNONE;  // no parity
      CommPortDriverPulse1.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
      CommPortDriverPulse1.ComPortSwHandshaking      := shNONE;
      label3.visible:=false;label4.visible:=false;label5.visible:=false;
      MarkerLengthBox.visible:=false;PositionMarkerBox.visible:=false;
     {RESET DU SEQUENCEUR}
      Seq16ChannelsForm.openSerialPort;
      s:='ZR'+#13; {ordre de reset du sequenceur}
      CommPortDriverPulse1.SendData( pchar(s),length(s));
      Seq16ChannelsForm.closeSerialPort;
end;



procedure TSeq16ChannelsForm.ChangeParametreSequence(nomParam:string;Valeur:real);
    { mets Valeur dans la case de nomParam : appel
    depuis interpreteur}
var i,numColonne,numLigne:integer;

begin
   numLigne:=0;   numColonne:=0;
   {on repere la colonne}
   {on repere le numero de ligne correspondant a la lettre : A,B,C...}
   for i:=1 to 26 do if chr(64+i)=copy(nomParam,2,1) then numLigne:=i;
   {on change seulement si c'est bien crit}
   if numLigne<>0 then
   begin
     if copy(nomParam,1,1)='T' then listseqpar.Cells[1,numLigne]:=floattostr(valeur);
     if pos(',',listseqpar.Cells[1,numLigne])>0 then
          listseqpar.Cells[1,numLigne]:=copy(listseqpar.Cells[1,numLigne],1,
                  pos(',',listseqpar.Cells[1,numLigne])-1)
                  +'.'+
                  copy(listseqpar.Cells[1,numLigne],
                  pos(',',listseqpar.Cells[1,numLigne])+1,
                  length(listseqpar.Cells[1,numLigne])-pos(',',listseqpar.Cells[1,numLigne]));

{     affiche_parametre;}
   end;

   if (numLigne=0) then MessageDlg('Erreur in the command of type TA, PA...', mtWarning, [mbOk], 0);
  if (copy(nomParam,1,1)<>'T' ) and (copy(nomParam,1,1)<>'A' ) and (copy(nomParam,1,1)<>'P' )
      then MessageDlg('Erreur in the command of type TA', mtWarning, [mbOk], 0);
end;

procedure TSeq16ChannelsForm.Sauver1Click(Sender: TObject);
var nomFichier:string; filepara:string;
    fich2:textfile;i:integer;
begin
    If Savedialog1.execute then
    begin
      nomFichier:=SaveDialog1.Filename;
      if (copy(nomFichier,length(nomFichier)-3,4)<>'.seq') then nomFichier:=nomFichier+'.seq';
      assignfile(fich2,nomfichier);
      rewrite(fich2);
      writeln(fich2,'Sequenceur16Channels');
      writeln(fich2,'DELAYS');
      for i:=1 to ntemps do
          begin
          if Seq16ChannelsForm.listseqpar.cells[1,i]='' then
          Seq16ChannelsForm.listseqpar.cells[1,i]:='0';
          writeln(fich2,Seq16ChannelsForm.listseqpar.cells[1,i]);
          end;
      writeln(fich2,'SEQUENCE');
      for i:=0 to editseq.Lines.Count-1 do
          writeln(fich2,editseq.lines[i]);

      writeln(fich2,'MODE ACQUISITION :');
      if ModeACquisitionStandard.State=cbChecked then writeln(fich2,'1 step')
         else
         begin
         if modeacquisition2pulses.state=cbchecked then
                                                   begin
                                                   writeln(fich2,'2 steps');
                                                   writeln(fich2,'Rep Time Between 2 gage triggers for recognition:');
                                                   writeln(fich2,TempsRepetitionBox.text);
                                                   end
                                                   else
                                                   writeln(fich2,'unknown');
         end;
      closefile(fich2);


      Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
    end;
end;


procedure TSeq16ChannelsForm.Ouvrir1Click(Sender: TObject);
var filepara:string;
    fich2:textfile;
    i:integer;nomFichier:string;
       chaineTableau:array[0..100] of string;
begin
  if OpenDialog1.execute then
           ChargeFichier(Opendialog1.Filename);
end;

procedure TSeq16ChannelsForm.ChargeFichier(Filename:string);
var filepara:string;
    fich2:textfile;
    err,i:integer;nomFichier:string;
    chaine:string;nombre:extended;
    drapeau:boolean;
   chaineTableau:array[0..100] of string;
begin
    if FExis(Filename) then
       begin
           {verifie si bon format}
           nomFichier:=Filename;
           assignfile(fich2,nomfichier);
           reset(fich2);
           readln(fich2,chaine);
           if (chaine='NewHeteroSpectrometer') or
                 (chaine='OldHeteroSpectrometer') or
                 (chaine='Sequenceur16Channels') then
                 begin
                   if (chaine<>'Sequenceur16Channels') then drapeau:=false
                                                       else drapeau:=true;
                 end
                 else
                 begin
                 drapeau:=true;
                 closefile(fich2);
                 assignfile(fich2,nomfichier);
                 reset(fich2);
                 end;
           if drapeau=true then
           begin
           i:=0;
           nomFichier:=Filename;
           readln(fich2,chaine);
           i:=0;
           {lecture des delais}
                repeat
                 i:=i+1;
                 readln(fich2,chaine);
                 val(chaine,nombre,err);
                 if (err=0) then Seq16ChannelsForm.listseqpar.cells[1,i]:=chaine;
                until (chaine='SEQUENCE') or (i>50);

            editseq.Clear;
           {lecture des instructions}
               while not eof(fich2) and (chaine<>'MODE ACQUISITION :') do
                 begin
                 readln(Fich2,chaine);
                 if (chaine<>'MODE ACQUISITION :') then editseq.lines.Add(chaine);
                 end;

           {lecture du mode d'acquisition}
           readln(fich2,chaine);
           if (chaine='1 step') then
              begin
              modeacquisitionstandard.state:=cbchecked;
              end
              else
              begin
              if (chaine='2 steps') then
                                 begin
                                 modeacquisition2pulses.state:=cbchecked;
                                 readln(fich2,chaine);
                                 readln(fich2,chaine);
                                 TempsREpetitionBox.text:=chaine;TempsRepetitionBox.refresh;
                                 end
                                 else
                                 MessageDlg('Type of sequence (1 step or 2 steps) not recognized, please check manually', mtWarning, [mbOk], 0);
              end;
            closefile(fich2);

            Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
            {sauve le nom de la sequence dans Parametres RMN.txt}
            EcritDansParametresRMN('Last Pulse Sequence',nomFichier)
            end;

       end;
end;

procedure TSeq16ChannelsForm.StopClick(Sender: TObject);
var s:string;AttentePourFinSequence,starttime:integer;timeout:boolean;
begin
      {On s'arrete}
       Seq16ChannelsForm.openSerialPort;
       s:='C'+#13;
       CommPortDriverPulse1.SendData( pchar(s),length(s));
       AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
       startTime:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - startTime) > AttentePourFinSequence);
       UNTIL timeout;

       Seq16ChannelsForm.closeSerialPort;
       Status.caption:='Sequence stopped';
end;




procedure TSeq16ChannelsForm.Close(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caNone;
  Seq16ChannelsForm.WindowState:=wsMinimized;
{On ne ferme pas la fentre sequenceur pour viter de slectionner par erreur deux sequences
mais on la reduit. On peut la reafficher via le menu}
end;

procedure TSeq16ChannelsForm.FormCreate(Sender: TObject);
var nomFichier:string;chaineTableau:array[0..100] of string;fich2:textfile;
i:integer;
begin
   DrapeauSeq16ChannelsLibre:=true;
   Initialisation;
  {relit la derniere sequence sauve dont le nom est dans Parametres RMN.txt}
   nomfichier:=LitDansParametresRMN('Last Pulse Sequence');
   if fexis(nomfichier) then
               begin
                chargefichier(nomFichier);
               end;

end;

procedure TSeq16ChannelsForm.ModeAcquisition2pulsesClick(Sender: TObject);
begin
   if ModeAcquisition2pulses.State=cbChecked then
         begin
         DrapeauModeAcquisition2pulses:=true;
         DrapeauModeAcquisition1pulse:=false;
         ModeAcquisitionStandard.State:=cbUnchecked;
         DrapeauSequenceur16VoiesRecognitionStep:=true;
         GageRecognitionBox.state:=cbChecked;
         tempsrepetitionbox.visible:=true;
         NombreStepsPourReception:=2;
         end
         else DrapeauModeAcquisition2pulses:=false;

end;


procedure TSeq16ChannelsForm.SansRafraichissementClick(Sender: TObject);
begin
   if SansRafraichissement.State=cbChecked then
         begin
         DrapeauSansRafraichissement:=true;
         end
   else DrapeauSansRafraichissement:=false;
end;

procedure TSeq16ChannelsForm.ModeAcquisitionStandardClick(Sender: TObject);
begin
  if ModeAcquisitionStandard.State=cbChecked then
         begin
         DrapeauModeAcquisition1pulse:=false;
         DrapeauSequenceur16VoiesRecognitionStep:=false;
         ModeAcquisition2pulses.State:=cbUnchecked;
         DrapeauSequenceur16VoiesRecognitionStep:=false;
         GageRecognitionBox.state:=cbUnChecked;
         Label7.visible:=false;
         TempsRepetitionBox.visible:=false;
         NombreStepsPourReception:=1;
         end;
end;

procedure TSeq16ChannelsForm.OpenSerialPort;
begin
  GetMem( FTempInBuffer2,10);
  CommPortDriverPulse1.connect;
  CommPortDriverPulse1.FlushBuffers(true,true);
end;

procedure TSeq16ChannelsForm.CloseSerialPort;
begin
  commportdriverPulse1.Disconnect;
  FreeMem( FTempInBuffer2,10);
end;

procedure TSeq16ChannelsForm.StartClick(Sender: TObject);
begin
{ne pas sauver le fichier  chaque fois qu'on relance, c'est
trs problematique car ca fait perdre du temps}
Seq16ChannelsForm.StartSequenceur;
end;

procedure TSeq16ChannelsForm.StartSequenceur;
{compilation et execution de la sequence si c'est le spectro sous RS232  16 voies
fait par J-P Cromieres en dec.2002}

type TMatrice = array[1..1000] of array[1..16] of boolean;
var TableauONOFF:TMatrice;
    Instructions:array[1..1000] of string;
    TableauDelay:array[1..1000] of extended;  {les differents temps}
    numero,AttentePourFinSequence,NumeroLettre,temps,err,err2,NbSteps,i,j,nb,nb2:integer;
    s,s2,s3,sTemps:string;
    DrapeauErreur,TimeOut:boolean;
    Caractere:char;
    StartTime,TempsBis:extended;
    numero2:integer;chaine,chaine1,chaine2:string;
    temps1,temps2:extended;

{1ere colonne : la duree en nanosecondes, puis les 16 colonnes qui suivent:
booleens qui disent si c'est ouvert (true) ou ferm (false)}

begin

{on cree le tableau donnant les ON/OFF des 16 voies et les temps correspondants}
DrapeauErreur:=false;
{initialisation tableau}
NbSteps:=0;
for i:=1 to 1000 do
    begin
    TableauDelay[i]:=0;
    for j:=1 to 16 do
        begin
        TableauONOFF[i][j]:=false;
        end;
    end;
{on lit chaque instruction de EditSeq du type
T0.05,C1,C5,C7; (aprs le ; on ne regarde rien, c'est du commentaire)
(ici 0.05 est msec ainsi que TA,TB.. sont en msec)
ou
TA,C1,C5,C7; (ou TB, TC, TD...)}
DrapeauErreur:=false;
for i:=0 to (EditSeq.Lines.Count-1) do
    begin
    s:=EditSeq.Lines[i];
    {on vire les commentaires apres le ; mais on laisse le ;}
    if pos(';',s)>0 then s:=copy(s,1,pos(';',s));
    {traitement des instructions slt qd ligne commence par T}
    if copy(s,1,1)='T' then
       begin
         NbSteps:=NbSteps+1;
         val(copy(s,2,1),tempsbis,err);
         {cas de T0.05}
         if err=0 then begin
                       if pos(',',s)>0 then  s2:=copy(s,2,pos(',',s)-2)
                                       else s2:=copy(s,2,pos(';',s)-2);
                       val(s2,tempsbis,err2);
                       if err2<>0 then DrapeauErreur:=true;
                       {on convertit la valeur de msec en nanosec}
                       if err2=0 then TableauDelay[NbSteps]:=round(tempsbis*1e6);
                       end;

         {cas de TA,TB,TC...}
         if err<>0 then begin
                        s2:=copy(s,2,1);
                        if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                        if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                        if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                        if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                        if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                        if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                        if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                        if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                        val(listseqpar.Cells[1,nb],tempsBis,err2);
                        if err2<>0 then DrapeauErreur:=true
                                   else TableauDelay[NbSteps]:=round(tempsBis*1e6);{on convertit la valeur des msec en nanosec}
                        end;
       end;
       {traitement des instructions de type C1,C2,C4... et C5;}
       for j:=1 to 16 do
             begin
             s2:='C'+inttostr(j)+',';
             if pos(s2,s)>0 then TableauONOFF[NbSteps][j]:=true;
             s2:='C'+inttostr(j)+';';
             if pos(s2,s)>0 then TableauONOFF[NbSteps][j]:=true;
             end;
    end;
    {fin boucle sur cq ligne d'instructions}

{conversion tableau-instructions pour sequenceur}
{syntaxe du sequenceur :}
{ 'A6E3R0B1' :  met la voie 1 ON pdt 6e3 nsec
  on met pour les voies 0 : tout est off
 et si on veut mettre plusieurs voies  ON, on les aditionne en puissance de 2.
 exple : voie 1 et 3 et 6 on : A6E3R0B  car 2^(1-1)+2^(3-1)+2^(6-1)=1+4+32=37}
  TempsTotalUneSequence:=0;
  for i:=1 to NbSteps do
      begin
      {on convertit le temps : 1 sec = 1e9; 517.3 microsec= 5173e2}
      str(TableauDelay[i]:15:0,s);
      for j:=1 to 15 do if copy(s,1,1)=' ' then s:=copy(s,2,length(s)-1);
      nb:=0;
      for j:=1 to (length(s)-1) do
          if copy(s,length(s),1)='0' then begin nb:=nb+1;s:=copy(s,1,length(s)-1);end;
      {on decide quelles voies mettre  ON}
      nb2:=0;
      for j:=1 to 16 do
          begin
          if TableauONOFF[i][j]=true then nb2:=nb2+round(power(2,(j-1)));
          end;

      Instructions[i]:='A'+s+'E'+inttostr(nb)+'R0B'+inttostr(nb2)+#13;
      TempsTotalUneSequence:=TempsTotalUneSequence+TableauDelay[i];
      end;

  {envoi au RS232}
  if DrapeauErreur=false then
    begin {reset the previous sequence }
    Seq16ChannelsForm.openSerialPort;
    s:='ZR'+#13; {ordre de reset du sequenceur}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    Seq16ChannelsForm.closeSerialPort;

    {envoi des chaines}
    Seq16ChannelsForm.openSerialPort;
{    s:='C'+#13; stop sequence precedente
    CommPortDriverPulse1.SendData( pchar(s),length(s));}
    {avant de lancer l'ordre, il doit avoir finit la derniere etape de la
    sequence precedente donc on attend le temps de cette sequence + 50msec}
    {pas sur que je doive enlever la ligne suivante}
    {    AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
    startTime:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - startTime) > AttentePourFinSequence);
       UNTIL timeout;
 }   {lancement des differents ordres}
    for j:=1 to NbSteps do
        begin
        CommPortDriverPulse1.SendData( pchar(Instructions[j]),length(Instructions[j]));
        label1.caption:=instructions[j];
        end;
    {ordre de bouclage  la fin de la squence}
    s:='A1E1R1B0'+#13; {le temps n'est pas pris en compte, juste le R1}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    {start the sequence}
    s:='B'+#13;
    CommPortDriverPulse1.SendData( pchar(s),length(s));

    Seq16ChannelsForm.closeSerialPort;
    {Sauver ici la sequence !}

    end
    else
    MessageDlg('Error in the sequence writing - Not sent to the sequenceur', mtWarning, [mbOk], 0);

    if DrapeauErreur=true then MessageDlg('error in the writing of your sequence', mtWarning, [mbOk], 0);

    {rapatriement du temps de repetition}
    if Seq16ChannelsForm.TempsRepetitionBox.visible=true then
      begin
      val(Seq16ChannelsForm.TempsRepetitionBox.text,TempsRepetition,err);
      if err<>0 then
                   TempsRepetition:=0;
                   if pos('+',tempsrepetitionbox.text)=0 then
                   begin
                   {cas de TA,TB....}
                   if pos('TA',TempsREpetitionBox.text)>0 then numero:=1;
                   if pos('TB',TempsREpetitionBox.text)>0 then numero:=2;
                   if pos('TC',TempsREpetitionBox.text)>0 then numero:=3;
                   if pos('TD',TempsREpetitionBox.text)>0 then numero:=4;
                   if pos('TE',TempsREpetitionBox.text)>0 then numero:=5;
                   if pos('TF',TempsREpetitionBox.text)>0 then numero:=6;
                   if pos('TG',TempsREpetitionBox.text)>0 then numero:=7;
                   if pos('TH',TempsREpetitionBox.text)>0 then numero:=8;
                   if pos('TI',TempsREpetitionBox.text)>0 then numero:=9;
                   if pos('TJ',TempsREpetitionBox.text)>0 then numero:=10;
                   if pos('TK',TempsREpetitionBox.text)>0 then numero:=11;
                   if pos('TL',TempsREpetitionBox.text)>0 then numero:=12;
                   if pos('TM',TempsREpetitionBox.text)>0 then numero:=13;
                   if pos('TN',TempsREpetitionBox.text)>0 then numero:=14;
                   if pos('TO',TempsREpetitionBox.text)>0 then numero:=15;
                   if pos('TP',TempsREpetitionBox.text)>0 then numero:=16;
                   if pos('TQ',TempsREpetitionBox.text)>0 then numero:=17;
                   if pos('TR',TempsREpetitionBox.text)>0 then numero:=18;
                   if pos('TS',TempsREpetitionBox.text)>0 then numero:=19;
                   if pos('TT',TempsREpetitionBox.text)>0 then numero:=20;
                   if pos('TU',TempsREpetitionBox.text)>0 then numero:=21;
                   if pos('TV',TempsREpetitionBox.text)>0 then numero:=22;
                   if pos('TW',TempsREpetitionBox.text)>0 then numero:=23;
                   if pos('TX',TempsREpetitionBox.text)>0 then numero:=24;
                   if pos('TY',TempsREpetitionBox.text)>0 then numero:=25;
                   if pos('TZ',TempsREpetitionBox.text)>0 then numero:=26;
                   val(ListSeqPar.cells[1,numero],TempsREpetition,err);
                   if err<>0 then MessageDlg('PROBLEM with the delay between 2 trigger box', mtWarning, [mbOk], 0);
                   end;

                   if pos('+',tempsrepetitionbox.text)>0 then
                   begin
                   chaine1:=copy(tempsrepetitionbox.text,1,
                                  pos('+',tempsrepetitionbox.text)-1);
                   chaine2:=copy(tempsrepetitionbox.text,pos('+',tempsrepetitionbox.text)+1,
                                     length(tempsrepetitionbox.text)-pos('+',tempsrepetitionbox.text));
                                      if pos('TA',TempsREpetitionBox.text)>0 then numero:=1;
                   if pos('TA',chaine1)>0 then numero:=1;
                   if pos('TB',chaine1)>0 then numero:=2;
                   if pos('TC',chaine1)>0 then numero:=3;
                   if pos('TD',chaine1)>0 then numero:=4;
                   if pos('TE',chaine1)>0 then numero:=5;
                   if pos('TF',chaine1)>0 then numero:=6;
                   if pos('TG',chaine1)>0 then numero:=7;
                   if pos('TH',chaine1)>0 then numero:=8;
                   if pos('TI',chaine1)>0 then numero:=9;
                   if pos('TJ',chaine1)>0 then numero:=10;
                   if pos('TK',chaine1)>0 then numero:=11;
                   if pos('TL',chaine1)>0 then numero:=12;
                   if pos('TM',chaine1)>0 then numero:=13;
                   if pos('TN',chaine1)>0 then numero:=14;
                   if pos('TO',chaine1)>0 then numero:=15;
                   if pos('TP',chaine1)>0 then numero:=16;
                   if pos('TQ',chaine1)>0 then numero:=17;
                   if pos('TR',chaine1)>0 then numero:=18;
                   if pos('TS',chaine1)>0 then numero:=19;
                   if pos('TT',chaine1)>0 then numero:=20;
                   if pos('TU',chaine1)>0 then numero:=21;
                   if pos('TV',chaine1)>0 then numero:=22;
                   if pos('TW',chaine1)>0 then numero:=23;
                   if pos('TX',chaine1)>0 then numero:=24;
                   if pos('TY',chaine1)>0 then numero:=25;
                   if pos('TZ',chaine1)>0 then numero:=26;

                   if pos('TA',chaine2)>0 then numero2:=1;
                   if pos('TB',chaine2)>0 then numero2:=2;
                   if pos('TC',chaine2)>0 then numero2:=3;
                   if pos('TD',chaine2)>0 then numero2:=4;
                   if pos('TE',chaine2)>0 then numero2:=5;
                   if pos('TF',chaine2)>0 then numero2:=6;
                   if pos('TG',chaine2)>0 then numero2:=7;
                   if pos('TH',chaine2)>0 then numero2:=8;
                   if pos('TI',chaine2)>0 then numero2:=9;
                   if pos('TJ',chaine2)>0 then numero2:=10;
                   if pos('TK',chaine2)>0 then numero2:=11;
                   if pos('TL',chaine2)>0 then numero2:=12;
                   if pos('TM',chaine2)>0 then numero2:=13;
                   if pos('TN',chaine2)>0 then numero2:=14;
                   if pos('TO',chaine2)>0 then numero2:=15;
                   if pos('TP',chaine2)>0 then numero2:=16;
                   if pos('TQ',chaine2)>0 then numero2:=17;
                   if pos('TR',chaine2)>0 then numero2:=18;
                   if pos('TS',chaine2)>0 then numero2:=19;
                   if pos('TT',chaine2)>0 then numero2:=20;
                   if pos('TU',chaine2)>0 then numero2:=21;
                   if pos('TV',chaine2)>0 then numero2:=22;
                   if pos('TW',chaine2)>0 then numero2:=23;
                   if pos('TX',chaine2)>0 then numero2:=24;
                   if pos('TY',chaine2)>0 then numero2:=25;
                   if pos('TZ',chaine2)>0 then numero2:=26;

                   val(ListSeqPar.cells[1,numero],Temps1,err);
                   val(ListSeqPar.cells[1,numero2],Temps2,err2);
                   if (err=0) and (err2=0) then TempsRepetition:=Temps1+Temps2
                                           else MessageDlg('PROBLEM with the delay between 2 trigger box', mtWarning, [mbOk], 0);
                   end;

      end;

end;


procedure TSeq16ChannelsForm.LitBuffer0123(var Caractere:char);
{va lire au buffer si caractere est '0' '1' '2' ou '3'}
var
u:integer;s1:char;
u1:double;s:string[1];
begin
  { lecture du caractere recu }
  u1:=time; { 0.00001 = 1 sec est le timeout }
  s:=' ';
  repeat
     u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then s:=strpas(Ftempinbuffer2);
  until (u1+0.00001>time) or (s='0') or (s='1') or (s='2') or (s='3');
 Caractere:=s[1];
 CommPortDriverPulse1.FlushBuffers(true,true);
 {on vire ce qu'il y a dans le buffer
 pour la lecture suivante : essentiel si on laisse le port serie ouvert}

end;

procedure TSeq16ChannelsForm.Button1Click(Sender: TObject);
var nomFichier:string;
begin
{single pulse automatic programming}
Seq16ChannelsForm.NomSequenceRMN.caption:='Single pulse';
   EditSeq.Lines.Clear;
EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
end;

procedure TSeq16ChannelsForm.Button2Click(Sender: TObject);
begin
{pi/2-pi}
Seq16ChannelsForm.NomSequenceRMN.caption:='pi/2 - pi';
   EditSeq.Lines.Clear;
   EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse pi/2 on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TC; wait during TC');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1 during TB (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
end;

procedure TSeq16ChannelsForm.ButtonPulseRecep2Click(Sender: TObject);
begin
{pi/2-pi}
Seq16ChannelsForm.NomSequenceRMN.caption:='pi/2 - pi Turning reception';

   EditSeq.Lines.Add('NOT POSSIBLE WITH THIS 16 CHANNELS SETUP');

end;

procedure TSeq16ChannelsForm.Button3Click(Sender: TObject);
begin
{pi/2-pi}
Seq16ChannelsForm.NomSequenceRMN.caption:='pi/2 - pi Recognition With RS232';
   EditSeq.Lines.Clear;
   EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse pi/2 on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TC; wait during TC');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1 during TB (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
   EditSeq.Lines.Add('T0.005,C16; trigger for GAGE card (chanel 16) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C2,C3; pulse pi/2 on channel 2 (you have to inverse it with a gate)');
   EditSeq.Lines.Add('TC;');
   EditSeq.Lines.Add('T0.003,C3;');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1');
   EditSeq.Lines.Add('TR; reception will be substracted from previous one');
end;


procedure TSeq16ChannelsForm.TempsRepetitionBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var err:integer;
begin
if key=13 then
   begin
   val(TempsRepetitionBox.text,RepetitionTime,err);
   end;
end;

procedure TSeq16ChannelsForm.GAGErecognitionBoxClick(Sender: TObject);
begin
if gagerecognitionbox.State=cbChecked then GageRecognition16channels:=true
                                      else GageRecognition16channels:=false;
end;

procedure TSeq16ChannelsForm.Button4Click(Sender: TObject);
var s:string;
begin
    Seq16ChannelsForm.openSerialPort;
    s:='ZR'+#13; {ordre de reset du sequenceur}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    Seq16ChannelsForm.closeSerialPort;
    {Sauver ici la sequence !}

end;

procedure TSeq16ChannelsForm.sauverSimpleClick(Sender: TObject);
var nomFichier:string; filepara:string;
    fich2:textfile;i:integer;
begin
    nomFichier:=nomsequencermn.Caption;
    if fexis(nomFichier) then
    begin
      assignfile(fich2,nomfichier);
      rewrite(fich2);
      writeln(fich2,'Sequenceur16Channels');
      writeln(fich2,'DELAYS');
      for i:=1 to ntemps do
          begin
          if Seq16ChannelsForm.listseqpar.cells[1,i]='' then
          Seq16ChannelsForm.listseqpar.cells[1,i]:='0';
          writeln(fich2,Seq16ChannelsForm.listseqpar.cells[1,i]);
          end;
      writeln(fich2,'SEQUENCE');
      for i:=0 to editseq.Lines.Count-1 do
          writeln(fich2,editseq.lines[i]);

      writeln(fich2,'MODE ACQUISITION :');
      if ModeACquisitionStandard.State=cbChecked then writeln(fich2,'1 step')
         else
         begin
         if modeacquisition2pulses.state=cbchecked then
                                                   begin
                                                   writeln(fich2,'2 steps');
                                                   writeln(fich2,'Rep Time Between 2 gage triggers for recognition:');
                                                   writeln(fich2,TempsRepetitionBox.text);
                                                   end
                                                   else
                                                   writeln(fich2,'unknown');
         end;
      closefile(fich2);
    Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
    end
    else
    Seq16ChannelsForm.Sauver1Click(sender);



end;

end.
