unit T1AnalysisUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids,editdata,TFRMN;

type
  TT1Analysis = class(TForm)
    DATAGrille: TStringGrid;
    Label1: TLabel;
    IntegralGrille: TStringGrid;
    Label2: TLabel;
    SaveToAsciiButton: TButton;
    DoesTFButton: TButton;
    DoesIntegrals: TButton;
    SaturationDelayBox: TEdit;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDataButton: TButton;
    LoadIntegralButton: TButton;
    SaveIntegralButton: TButton;
    OnlyImPartCheckBox: TCheckBox;
    ASCIInotNBCheckBox: TCheckBox;
    NormalizeIntegralsCheckBox: TCheckBox;
    MsatIntegralesCheckBox: TCheckBox;
    TFAsciiSingleFileCheckBox: TCheckBox;
    Memo1: TMemo;
    SingleAsciiTFBox: TEdit;
    Label4: TLabel;
    AdditionalTextBox: TEdit;
    AdditionalTextCheckBox: TCheckBox;
    firstECHOnumberbox: TEdit;
    Label5: TLabel;
    lastECHOnumberbox: TEdit;
    normalizedlabel: TLabel;
    Label6: TLabel;
    firstTFnumberbox: TEdit;
    Label7: TLabel;
    lastTFnumberbox: TEdit;
    Label8: TLabel;
    Button1: TButton;
    Label9: TLabel;
    Label10: TLabel;
      procedure ouverture;
    procedure FormCreate(Sender: TObject);
    procedure OpenDataButtonClick(Sender: TObject);
    procedure SaveDataArrayClick(Sender: TObject);
    procedure LoadIntegralButtonClick(Sender: TObject);
    procedure SaveIntegralButtonClick(Sender: TObject);
    procedure DoesTFButtonClick(Sender: TObject);
    procedure SaveToAsciiButtonClick(Sender: TObject);
    procedure DoesIntegralsClick(Sender: TObject);
    procedure FaireIntegrales(drapeauTypeDeFichier:boolean);
    procedure StartFileNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StartFileNameExit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
   procedure RafraichitDataGrille;
   procedure RafraichitIntegralGrille;

  end;

var
  T1Analysis: TT1Analysis;

implementation

uses interpreteur, AcquisitionRMN;

{$R *.DFM}

procedure TT1Analysis.ouverture;
{on affiche la fenetre qui est juste reduite en la maximisant}
begin
T1Analysis.WindowState:=WsMinimized;
T1Analysis.WindowState:=WsNormal;
end;


procedure TT1Analysis.FormCreate(Sender: TObject);
var i:integer;
begin

  {initialisation de la fenetre DataGrille}
  DataGrille.cells[1,0]:='Delay';
  DataGrille.cells[2,0]:='ECHO';
  DataGrille.cells[3,0]:='TF';
  DataGrille.cells[4,0]:='NB';
  for i:=1 to 50 do DataGrille.cells[0,i]:='DATA '+inttostr(i);

  {initialisation de la fenetre IntegralGrille}
  IntegralGrille.cells[1,0]:='Left_Freq';
  IntegralGrille.cells[2,0]:='Right_Freq';
  IntegralGrille.cells[3,0]:='Left_Bgd_Freq';
  IntegralGrille.cells[4,0]:='Right_Bgd_Freq';


  for i:=1 to 50 do IntegralGrille.cells[0,i]:='RANGE '+inttostr(i);



end;

procedure TT1Analysis.OpenDataButtonClick(Sender: TObject);
var filepara:string;
    fich:textfile;
    i:integer;nomFichier,chaine:string;
    chaine1,chaine2,chaine3,chaine4:string;

begin
       rafraichitDataGRille;
end;

procedure TT1Analysis.SaveDataArrayClick(Sender: TObject);
var fich:textfile;
    err,i,j:integer;nomFichier,chaine:string;
    nombre:array[1..4] of extended;

begin
     RafraichitDataGrille;
     openDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if openDialog1.Execute then
         begin
            {sauve le fichier}
            nomFichier:=OpenDialog1.Filename;
            if copy(nomFichier,length(nomfichier)-3,1)<>'.' then nomFichier:=nomFichier+'.dat';
            assignfile(fich,nomfichier);
            rewrite(fich);
            {ecrit le nom des colonnes en premiere ligne}
            writeln(fich,DataGrille.cells[1,0],' ',DataGrille.cells[2,0],' ',DataGrille.cells[3,0],' ',DataGrille.cells[4,0]);

            RafraichitDataGrille;

            for i:=1 to 50 do
                begin
                if (DataGrille.cells[1,i]<>'') then
                        begin
           writeln(fich,DataGrille.cells[1,i],' ',DataGrille.cells[2,i],' ',DataGrille.cells[3,i],' ',DataGrille.cells[4,i]);
                        end;
                end;
            closefile(fich);
            RafraichitDataGrille;
         end;
end;

procedure TT1Analysis.RafraichitDataGrille;
{reactualise la grille des datas : les rappelle tous,
et met les bonnes valeurs de NB et de delais et de TF associs}
var i,j,err,err2,firstfile,lastfile:integer;nombre:extended;chaine:string;
    nomFichier:string;
    fich:textfile;
    directory_NMR:string;
    numeroVariable,pile_NMR:integer;valeurVariable:extended;ChaineVariable:string;

begin
{actualisation eventuelle des ECHOS}
nombre:=0;
val(firstECHOnumberbox.text,nombre,err);
firstfile:=round(nombre);
val(lastECHOnumberbox.text,nombre,err2);
lastfile:=round(nombre);
if (err=0) and (err2=0) then
 begin
 {rappel des fichiers ECHO}
 for i:=firstfile to lastfile do
  begin
  DataGrille.cells[2,(i-firstfile+1)]:=inttostr(i);
  interpreteurform.recallnmr(inttostr(i));
  {on recupere les NB et on les met dans colonne}
   if pos('NB=',und.spect[1].comment)<=0 then begin
               MessageDlg('files dont have the NB of points done in their comment - analysis impossible', mtInformation, [mbOk], 0);
               exit;
               end;
  chaine:=copy(und.spect[1].comment,pos('NB=',und.spect[1].comment)+3,
             length(und.spect[1].comment)-pos('NB=',und.spect[1].comment)-2);
  val(chaine,nombre,err);
  if err<>0 then
                    begin
                    repeat
                    chaine:=copy(chaine,1,length(chaine)-1);
                    val(chaine,nombre,err);
                    until (err=0) or (length(chaine)=0);
                    end;
  str(round(nombre),chaine);
  DataGrille.cells[4,(i-firstfile+1)]:=chaine;

  {on regarde si datas normaliss et on affiche NORMALISE ou pas sur panneau avant}
  if pos('normali',und.spect[1].comment)>0 then begin
                                                normalizedlabel.caption:='DATAS NORMALIZED BY NB OF POINTS';
                                                DataGrille.cells[4,0]:='NB norm';
                                                end
                                           else begin
                                                normalizedlabel.caption:='DATAS NOT NORMALIZED BY NB OF POINTS';
                                                DataGrille.cells[4,0]:='NB not norm';
                                                end;

  {on recupere les delais dans le comment}
  if pos('DELAY=',und.spect[1].comment)<=0 then begin
               MessageDlg('files dont have the delay in their comment - analysis impossible', mtInformation, [mbOk], 0);
               exit;
               end;
  chaine:=copy(und.spect[1].comment,pos('DELAY=',und.spect[1].comment)+6,
             length(und.spect[1].comment)-pos('DELAY=',und.spect[1].comment)-5);
  val(chaine,nombre,err);
  if err<>0 then
                    begin
                    repeat
                    chaine:=copy(chaine,1,length(chaine)-1);
                    val(chaine,nombre,err);
                    until (err=0) or (length(chaine)=0);
                    end;
  str(nombre:8:3,chaine);
  DataGrille.cells[1,(i-firstfile+1)]:=chaine;
  end;
 end;
{actualisation eventuelle des TFs}
nombre:=0;
val(firstTFnumberbox.text,nombre,err);
firstfile:=round(nombre);
val(lastTFnumberbox.text,nombre,err2);
lastfile:=round(nombre);
if (err=0) and (err2=0) then
 begin
 {rappel des fichiers TF}
 for i:=firstfile to lastfile do
  begin
  DataGrille.cells[3,(i-firstfile+1)]:=inttostr(i);
  interpreteurform.recallnmr(inttostr(i));
  {on recupere les NB et on les met dans colonne}
   if pos('NB=',und.spect[1].comment)<=0 then begin
               MessageDlg('files dont have the NB of points done in their comment - analysis impossible', mtInformation, [mbOk], 0);
               exit;
               end;
  chaine:=copy(und.spect[1].comment,pos('NB=',und.spect[1].comment)+3,
             length(und.spect[1].comment)-pos('NB=',und.spect[1].comment)-2);
  val(chaine,nombre,err);
  if err<>0 then
                    begin
                    repeat
                    chaine:=copy(chaine,1,length(chaine)-1);
                    val(chaine,nombre,err);
                    until (err=0) or (length(chaine)=0);
                    end;
  str(round(nombre),chaine);
  DataGrille.cells[4,(i-firstfile+1)]:=chaine;

  {on regarde si datas normaliss et on affiche NORMALISE ou pas sur panneau avant}
  if pos('normali',und.spect[1].comment)>0 then normalizedlabel.caption:='DATAS NORMALIZED BY NB OF POINTS'
                                           else normalizedlabel.caption:='DATAS NOT NORMALIZED BY NB OF POINTS';
  {on recupere les delais dans le comment}
  if pos('DELAY=',und.spect[1].comment)<=0 then begin
               MessageDlg('files dont have the delay in their comment - analysis impossible', mtInformation, [mbOk], 0);
               exit;
               end;
  chaine:=copy(und.spect[1].comment,pos('DELAY=',und.spect[1].comment)+6,
             length(und.spect[1].comment)-pos('DELAY=',und.spect[1].comment)-5);
  val(chaine,nombre,err);
  if err<>0 then
                    begin
                    repeat
                    chaine:=copy(chaine,1,length(chaine)-1);
                    val(chaine,nombre,err);
                    until (err=0) or (length(chaine)=0);
                    end;
  str(nombre:8:3,chaine);
  DataGrille.cells[1,(i-firstfile+1)]:=chaine;
  {on recupere le numero de l'echo correspondant  cette TF dans le comment}
  if pos('ECHO',und.spect[1].comment)>0 then
     begin
     chaine:=copy(und.spect[1].comment,pos('ECHO',und.spect[1].comment)+4,
             length(und.spect[1].comment)-pos('ECHO',und.spect[1].comment)-3);
     val(chaine,nombre,err);
     if err<>0 then
                    begin
                    repeat
                    chaine:=copy(chaine,1,length(chaine)-1);
                    val(chaine,nombre,err);
                    until (err=0) or (length(chaine)=0);
                    end;
     str(round(nombre),chaine);
     DataGrille.cells[2,(i-firstfile+1)]:=chaine;
     end;
  end;
 end;



end;

procedure TT1Analysis.RafraichitIntegralGrille;
{met des zeros dans les cases vides, sauf pour BGD ou il met les valeurs de la premiere ligne
si il y a qq chose sur la premiere ligne
met un nom automatique si rien de specifie dans la derniere colonne}
var i,j,err:integer;nombre,nombre2:extended;
begin

   for i:=1 to 50 do
         begin
         if (T1Analysis.IntegralGrille.cells[1,i]<>'') or (T1Analysis.IntegralGrille.cells[2,i]<>'')
            or (T1Analysis.IntegralGrille.cells[3,i]<>'') or (T1Analysis.IntegralGrille.cells[4,i]<>'') then
               begin
                for j:=1 to 4 do
                    begin
                    if (T1Analysis.IntegralGrille.cells[j,i]='') then T1Analysis.IntegralGrille.cells[j,i]:='0';
                    val(T1Analysis.IntegralGrille.cells[j,i],nombre,err);
                    if err<>0 then T1Analysis.IntegralGrille.cells[j,i]:='0';
                    end;
                val(T1Analysis.IntegralGrille.cells[4,i],nombre,err);
                val(T1Analysis.IntegralGrille.cells[3,i],nombre2,err);
                if (nombre=0) and (nombre2=0)
                   then
                    begin
                    val(T1Analysis.IntegralGrille.cells[4,1],nombre,err);
                    val(T1Analysis.IntegralGrille.cells[3,1],nombre2,err);
                    if (nombre<>0) or (nombre2<>0) then
                                   begin
                                   T1Analysis.IntegralGrille.cells[4,i]:=T1Analysis.IntegralGrille.cells[4,1];
                                   T1Analysis.IntegralGrille.cells[3,i]:=T1Analysis.IntegralGrille.cells[3,1];
                                   end;
                    end;
                if (T1Analysis.IntegralGrille.cells[5,i]='') then
                    T1Analysis.IntegralGrille.cells[5,i]:='Integrals_'+T1Analysis.IntegralGrille.cells[1,i]+'_to_'+T1Analysis.IntegralGrille.cells[2,i]+'.dat';


                end;
         end;



end;


procedure TT1Analysis.LoadIntegralButtonClick(Sender: TObject);
var filepara:string;
    fich:textfile;
    i,j:integer;nomFichier,chaine:string;
    nombre1,nombre2,nombre3,nombre4:extended;

begin
for i:=1 to IntegralGrille.colcount do
    for j:=1 to IntegralGrille.rowcount do   integralgrille.cells[j,i]:='';
    
     openDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if openDialog1.Execute then
         begin
         if FileExists(OpenDialog1.Filename) then
            begin
            {lit le fichier}
            nomFichier:=OpenDialog1.Filename;

            assignfile(fich,nomfichier);
            reset(fich);
            {lit la premiere ligne pour rien}
            readln(fich,chaine);
            i:=0;
            while not eof(fich) do
                  begin
                  i:=i+1;
                  readln(fich,nombre1,nombre2,nombre3,nombre4);
                  IntegralGrille.cells[1,i]:=floattostr(nombre1);
                  if Pos(',',IntegralGrille.cells[1,i])>0 then
                   begin
                   chaine:=copy(IntegralGrille.cells[1,i],1,Pos(',',IntegralGrille.cells[1,i])-1)+'.'+
                            copy(IntegralGrille.cells[1,i],Pos(',',IntegralGrille.cells[1,i])+1,length(IntegralGrille.cells[1,i])-Pos(',',IntegralGrille.cells[1,i]));
                   IntegralGrille.cells[1,i]:=chaine;
                   end;
                  IntegralGrille.cells[2,i]:=floattostr(nombre2);
                  if Pos(',',IntegralGrille.cells[2,i])>0 then
                   begin
                   chaine:=copy(IntegralGrille.cells[2,i],1,Pos(',',IntegralGrille.cells[2,i])-1)+'.'+
                            copy(IntegralGrille.cells[2,i],Pos(',',IntegralGrille.cells[2,i])+1,length(IntegralGrille.cells[2,i])-Pos(',',IntegralGrille.cells[2,i]));
                   IntegralGrille.cells[2,i]:=chaine;
                   end;
                  IntegralGrille.cells[3,i]:=floattostr(nombre3);
                  if Pos(',',IntegralGrille.cells[3,i])>0 then
                   begin
                   chaine:=copy(IntegralGrille.cells[3,i],1,Pos(',',IntegralGrille.cells[3,i])-1)+'.'+
                            copy(IntegralGrille.cells[3,i],Pos(',',IntegralGrille.cells[3,i])+1,length(IntegralGrille.cells[3,i])-Pos(',',IntegralGrille.cells[3,i]));
                   IntegralGrille.cells[3,i]:=chaine;
                   end;
                  IntegralGrille.cells[4,i]:=floattostr(nombre4);
                  if Pos(',',IntegralGrille.cells[4,i])>0 then
                   begin
                   chaine:=copy(IntegralGrille.cells[4,i],1,Pos(',',IntegralGrille.cells[4,i])-1)+'.'+
                            copy(IntegralGrille.cells[4,i],Pos(',',IntegralGrille.cells[4,i])+1,length(IntegralGrille.cells[4,i])-Pos(',',IntegralGrille.cells[4,i]));
                   IntegralGrille.cells[4,i]:=chaine;
                   end;

                  end;
            closefile(fich);
            end;
         end;

    RafraichitIntegralGrille;
end;

procedure TT1Analysis.SaveIntegralButtonClick(Sender: TObject);
var fich:textfile;
    err,i,j:integer;nomFichier,chaine:string;
    nombre:array[1..4] of extended;

begin
     openDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if openDialog1.Execute then
         begin
            {sauve le fichier}
            nomFichier:=OpenDialog1.Filename;
            if copy(nomFichier,length(nomfichier)-3,1)<>'.' then nomFichier:=nomFichier+'.dat';
            assignfile(fich,nomfichier);
            rewrite(fich);
            {ecrit le nom des colonnes en premiere ligne}
            writeln(fich,IntegralGrille.cells[1,0],' ',IntegralGrille.cells[2,0],' ',IntegralGrille.cells[3,0],' ',IntegralGrille.cells[4,0]);

            RafraichitIntegralGrille;

            for i:=1 to 50 do
                begin
                if (IntegralGrille.cells[1,i]<>'') then
                        begin
                        for j:=1 to 4 do val(IntegralGrille.cells[j,i],nombre[j],err);
                        writeln(fich,nombre[1],nombre[2],nombre[3],nombre[4]);
                        end;
                end;
            closefile(fich);
         end;

end;

procedure TT1Analysis.DoesTFButtonClick(Sender: TObject);
{performs TF of all the echos and puts the TF number into the TF column}
var j,i,nbEchos,err:integer;tabFichierSomme:array[1..51] of integer;nombre:extended;
    chaine:string;tabNomFichier:array[1..51] of string;
begin
  RafraichitDataGrille;
  {on recupere les numeros des differents ECHOS}
  nbEchos:=0;
  for i:=1 to 50 do
      begin
      chaine:=DataGrille.cells[2,i];
      {cas ou il ya un echo donn par un nombre}
      val(DataGrille.cells[2,i],nombre,err);
      if (err=0) and (nombre>0) then
                 begin
                 nbEchos:=nbEchos+1;
                 tabNomFichier[nbEchos]:=inttostr(round(nombre));
                 end;
      {cas d'une chaine ou de plusieurs nombres}
      if (err<>0) then
        begin
        {cas o il y a plusieurs echos pour un delay, separ par des virgules ou tiraits:
        il les sommes et remplace les numeros par celui de la somme et sauve aussi
        le nombre de points NB}
        if (pos(',',chaine)>0) or (pos('-',chaine)>0) then
                 begin
                 {on fait la somme des differents fichiers}
                 chaine:='add('+chaine+')';
                 interpreteurform.traitstring(chaine,1);
                 TFNMRForm.cocourbe1.text:='SOMME';
                 interpreteurform.sauveFormatNMR('SOMME');
                 NMRForm.RafraichissementPileEtDirectoryNMR;
                 {on met le numero du fichier sauv dans la colonne 2}
                 DataGrille.cells[2,i]:=TFNMRForm.PileBox.caption;
                 val(DataGrille.cells[2,i],nombre,err);
                 nbEchos:=nbEchos+1;
                 tabNomFichier[nbEchos]:=inttostr(round(nombre));
                 end
                 else
                 begin
                 {cas ou il ya un echo donn par un nom}
                 if (DataGrille.Cells[2,i]<>'') then
                    begin
                    nbEchos:=nbEchos+1;
                    tabNomFichier[nbEchos]:=DataGrille.Cells[2,i];
                    end;
                 end;
        end;
      end;
  {TF en serie sur tous les echos}
  for i:=1 to nbEchos do
            begin
               if pos('NOT FOUND',TabNomFichier[i])=0 then
                 begin
                 interpreteurform.recallNMR(TabNomFichier[i]);
                 TFNMRForm.doTF(und.spect[1].nom);
                 {si echo pas un nombre alors on sauve TF avec
                 meme nom que echo et TF a la fin
                 et on met le numero du fichier sauv ou son nom dans la colonne 3}
                 val(TabNomFichier[i],nombre,err);
                 if err<>0 then
                           begin
                           interpreteurform.sauveFormatStandard('TF',TabNomFichier[i]+'TF',true);
                           DataGrille.cells[3,i]:=TabNomFichier[i]+'TF';
                           end
                           else
                           begin
                           interpreteurform.sauveFormatNMR('TF');
                           NMRForm.RafraichissementPileEtDirectoryNMR;
                           DataGrille.cells[3,i]:=TFNMRForm.PileBox.caption;
                           end;

                 end
                 else
                 DataGrille.cells[3,i]:='NOT FOUND';
            end;

  RafraichitDataGrille;

end;

procedure TT1Analysis.SaveToAsciiButtonClick(Sender: TObject);
{saves to ascii all the TF files}
var i,nbTF,err:integer;tabFichier:array[1..51] of integer;nombre:extended;
    chaine,chaine2:string;
{a faire : TFAsciiSingleFileCheckBox : pouvoir sauver en ascii plusieurs TF avec une seule
colonne X}

begin
  RafraichitDataGrille;
  {on recupere les numeros des differentes TF}
  nbTF:=0;
  for i:=1 to 50 do
      begin
      val(DataGrille.cells[3,i],nombre,err);
      if (err=0) and (nombre>0) then
                 begin
                 nbTF:=nbTF+1;
                 tabFichier[nbTF]:=round(nombre);
                 end;
      end;

  {on sauve en ascii}
  if TFAsciiSingleFileCheckBox.checked=false then
       begin
       {on sauve chaque fichier separement}
       {la sauve en ascii sous le nom chaine de la forme
       TF18_delay34_5-NB30000.dat ou TF18_delay=34_5.dat
       On ne met pas NB si c'est normalis}
       {on remplace . par , dans les nombres  decimales du delay}
       for i:=1 to nbTF do
          begin
          if Pos('.',DataGrille.cells[1,i])>0 then
                   chaine2:=copy(DataGrille.cells[1,i],1,Pos('.',DataGrille.cells[1,i])-1)+'_'+
                            copy(DataGrille.cells[1,i],Pos('.',DataGrille.cells[1,i])+1,length(DataGrille.cells[1,i])-Pos('.',DataGrille.cells[1,i]))
                                                     else
                   chaine2:=DataGrille.cells[1,i];
              if (DataGrille.cells[4,i]<>'0') and (ASCIInotNBCheckBox.Checked=false)
                  then chaine:='TF'+inttostr(tabFichier[i])+'_delay'+chaine2+'-NB'+DataGrille.cells[4,i]
                  else chaine:='TF'+inttostr(tabFichier[i])+'_delay'+chaine2;

          if OnlyImPartCheckBox.Checked=true then chaine2:='ascs('+inttostr(tabFichier[i])+','+chaine+',A)'
                                             else chaine2:='ascs('+inttostr(tabFichier[i])+','+chaine+')';
          interpreteurform.traitstring(chaine2,1);
          end;
       end;
    if TFAsciiSingleFileCheckBox.checked=true then
       begin
       chaine2:='ascs(';
       for i:=1 to nbTF do chaine2:=chaine2+inttostr(tabFichier[i])+',';
       chaine2:=chaine2+SingleAsciiTFBox.text;
       if OnlyImPartCheckBox.Checked=true then chaine2:=chaine2+',A)'
                                          else chaine2:=chaine2+')';
       interpreteurform.traitstring(chaine2,1);
       end;

end;

procedure TT1Analysis.DoesIntegralsClick(Sender: TObject);
begin
FaireIntegrales(true);
end;



procedure TT1Analysis.FaireIntegrales(drapeauTypeDeFichier:boolean);
{drapeautypedefichier : true si on fait les TFs, false si on fait les ECHOS}
var NumSaturation,i,j,nbDeFichiersAIntegrer,nbIntegrales,err,err2:integer;tabNomFichier:array[1..51] of string;
    nombre,nombre2:extended;
    chainePlus,nomFichier,chaine,nom:string;fich:textfile;
    maximum,start,finish,bgdstart,bgdfinish,integrale,integraleSaturation:extended;
    tabIntegrales:array[1..50,1..50] of extended;

begin
   RafraichitIntegralGrille;
  {on cherche le nb d'integrales  faire}
  nbIntegrales:=0;
  for i:=1 to 50 do
      begin
      val(IntegralGrille.cells[1,i],nombre,err);
      val(IntegralGrille.cells[2,i],nombre2,err2);
      if (err=0) and (nombre2<>nombre) and (err2=0) then nbIntegrales:=nbIntegrales+1;
      end;
  {on recupere les numeros des differentes TF ou ECHOS ou leurs noms}
  nbDeFichiersAIntegrer:=0;
  for i:=1 to 50 do
      begin
      if drapeauTypeDeFichier=true then nom:=DataGrille.cells[3,i]
                                   else nom:=DataGrille.cells[2,i];
      if (nom<>'') and (nom<>'0')
           and (pos('NOT FOUND',nom)=0) then
                 begin
                 nbDeFichiersAIntegrer:=nbDeFichiersAIntegrer+1;
                 tabNomFichier[nbDeFichiersAIntegrer]:=nom;
                 end;
      end;

    if AdditionalTextCheckBox.checked=true then
                                    begin
                                    chainePlus:=AdditionalTextBox.text;
                                    for i:=1 to length(chainePlus) do
                                    if copy(chainePlus,i,1)=' ' then
                                      chainePlus:=copy(chainePlus,1,i-1)+'_'+copy(chainePlus,i+1,length(chainePlus)-i);
                                    end;

    {on ouvre le fichier ou sauver les resultats}
     openDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if openDialog1.Execute then
         begin
         nomFichier:=OpenDialog1.Filename;
         if copy(nomFichier,length(nomfichier)-3,1)<>'.' then nomFichier:=nomFichier+'.dat';
         assignfile(fich,nomfichier);
         rewrite(fich);
         {ecrit le nom des colonnes en premiere ligne}
         chaine:='delay';
         for j:=1 to nbIntegrales do
             begin
             chaine:=chaine+' Freq'+IntegralGrille.cells[1,j]+'-'+IntegralGrille.cells[2,j];
             if AdditionalTextCheckBox.checked=true then chaine:=chaine+'/'+chainePlus;
             end;
         writeln(fich,chaine);

        {on rappelle chaque fichier sur laquelle on fera toutes les integrales}
         for i:=1 to nbDeFichiersAIntegrer do
            begin
                {rapelle la TF ou l'ECHO}
                interpreteurform.recallNMR(tabNomFichier[i]);
                {on fait toutes les integrales sur cette TF qu'on sauve dans le fichier ASCII}
                if (MsatIntegralesCheckBox.checked=false) then write(fich,DataGrille.Cells[1,i]);
                for j:=1 to nbIntegrales do
                    begin
                    val(IntegralGrille.Cells[1,j],Start,err);
                    val(IntegralGrille.Cells[2,j],Finish,err);
                    val(IntegralGrille.Cells[3,j],bgdStart,err);
                    val(IntegralGrille.Cells[4,j],bgdFinish,err);
                    Integrale:=interpreteurform.IntegEcho(und.spect[1].nom,Start,Finish,bgdStart,bgdFinish,0);
                    {on normalise eventuellement par NB si TFs ou ECHOS pas deja normalisees}
                    if (NormalizeIntegralsCheckBox.checked=true) and (pos('DATAS NOT NORMALIZED',normalizedlabel.caption)>0) then
                       begin
                       val(DataGrille.cells[4,i],nombre,err);
                       if (err=0) and (round(nombre)>0) then Integrale:=Integrale/nombre;
                       end;
                     tabIntegrales[i,j]:=Integrale;
                    {on ecrit l'integrale dans le fichier sauf si format 1-M/Msat}
                    if (MsatIntegralesCheckBox.checked=false) then write(fich,' ',Integrale);
                    end;
                    if (MsatIntegralesCheckBox.checked=false) then writeln(fich,' ');
            end;

         if (MsatIntegralesCheckBox.checked=true) then
            begin
            numSaturation:=0;
            for i:=1 to 50 do if SaturationDelayBox.text=DataGrille.Cells[1,i] then NumSaturation:=i;
            if numSaturation=0 then
               begin
               maximum:=0;
               {recherche du delay max}
               for i:=1 to 50 do
                   begin
                   nombre:=0;
                   val(DataGrille.Cells[1,i],nombre,err);
                   if nombre>maximum then begin maximum:=nombre;NumSaturation:=i;end;
                   end;
               if NumSaturation>0 then SaturationDelayBox.text:=DataGrille.Cells[1,NumSaturation]
                                  else SaturationDelayBox.text:='PROBLEM';
               end;

            if numSaturation>0 then
               begin
               for i:=1 to nbDeFichiersAIntegrer do
                  begin
                  write(fich,DataGrille.Cells[1,i]);
                  for j:=1 to nbIntegrales do
                     begin
                     IntegraleSaturation:=tabIntegrales[NumSaturation,j];
                     if (tabIntegrales[i,j]<>-999) and (IntegraleSaturation<>-999)
                               then Integrale:=1-tabIntegrales[i,j]/IntegraleSaturation
                               else Integrale:=-999;
                         write(fich,' ',Integrale);
                      end;
                  writeln(fich,' ');
                  end;
               end;
            end;

         closefile(fich);
         end;
end;

procedure TT1Analysis.StartFileNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then RafraichitDataGrille;
end;

procedure TT1Analysis.StartFileNameExit(Sender: TObject);
begin
RafraichitDataGrille;
end;

procedure TT1Analysis.Button1Click(Sender: TObject);
begin
FaireIntegrales(false);
end;


end.
