unit conductus;
{For using a GPIB IEEE interface : install first the gpib
programs from the disk. Then, go to the program cbconf.exe
choose Edit GPIB1 Board Options,
then chang Board is installed to Board is not installed
Then specify an adress at Primary GPIB adress,
the same that you will specify in the device which will be interfaced.
Finally, fo to DEV1 or DEV2 or... menu, and
specify in one of them the name of the device (for example : GENERF)
Then go back to main menu, and Save Current Configuration. Then quit CBCONF32.

Then, in this delphi unit, put in the definition of the constants
at the begining a lien which specifies the name again : like
const
    DEV_NAME = 'CONDUCTUS';

Finally, make sure that the unit you use for your interface has in 'uses' the
unit 'gpib' specified

*******************************************************************
*******************************************************************
IMPORTANT : BE SURE WHEN YOU CHANGE OF COMPUTER TO CHECK AGAIN THE OPTIONS
OF THE CBCONF.EXE AND THAT ALL THE NAMES OF THE DEVICE TO BE USED ARE
WELL SPECIFIED !!!
*************************************************************************
*************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gpib, StdCtrls, ExtCtrls,DrapeauAlloulUnit;

type
  TconductusForm = class(TForm)
    Label4: TLabel;
    Label7: TLabel;
    GPIBStatusBox: TLabel;
    ErrBox: TMemo;
    ReadTempButton: TButton;
    Label8: TLabel;
    SensorBox: TEdit;
    temperaturebox1: TLabel;
    unitebox1: TLabel;
    Label1: TLabel;
    SetTemperatureBox: TEdit;
    LastAskedTemperatureLabel: TLabel;
    temperaturebox2: TLabel;
    unitebox2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpenDevice;
    procedure ouverture;
    procedure WriteCommand (CommandStr:string);
    procedure ReadIDString ;
    procedure ReadValue (var ReadStr:string);
    procedure PrntErrs (ErrMsg:string);
    procedure Connect;
    procedure StopConnection;
    procedure Commande(Commande:string);
    procedure ReadTempButtonClick(Sender: TObject); {change la freq en MHz}
    procedure readtemperature(Senseur:integer;var valeur:extended;var unite:string);
    procedure settemperature(valeur:string;senseur:integer);
    procedure readsenseur(senseur:integer;var valeur:extended;var unite:string);
    procedure ReadAllTemperatures;
    procedure SetTemperatureBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
    MaxLen = 80;                 { Size of IBRD/IBWRT strings  }
    DEV_NAME = 'CONDUCTUS';      { Name for device as specified in CBCONF }
    RESET_CMD = '*RST';          { "Reset" command }
    ID_CMD = '*IDN?';            { "Identify Myself" command }

var
  conductusForm: TconductusForm;
  DevHandle:Integer;
  GPIBCallInProgress:Boolean;

implementation

{$R *.DFM}

procedure TconductusForm.FormCreate(Sender: TObject);
var valeur:extended;err:integer;reponse:string;
begin

   DrapeauGPIBconnection:=false; {dit si GPIB marche ou pas}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   if (DrapeauGPIBconnection=true) then
     begin
     WriteCommand (ID_CMD);
     ReadValue (REPONSE);
     ErrBox.lines.add (reponse);
     readsenseur(1,valeur,reponse);
     end;
end;


procedure TconductusForm.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
conductusform.WindowState:=WsMinimized;
conductusform.WindowState:=WsNormal;
end;
{************************************************************************}
{                                                                        }
{  Name:         OpenDevice                                            }
{  Returns:      Handle of opened GPIB device                }
{  Description:  Opens the GPIB device (Fluke45) and resets it
{                                                                        }
{************************************************************************}

procedure TconductusForm.OpenDevice;
var
  DevName:PChar;IDString:string;

begin
   If (DevHandle > 0) then Exit;
   DevName := StrAlloc (length (DEV_NAME) + 1);
   StrPCopy (DevName, DEV_NAME);

   DevHandle := ibfind (DevName);        { Open the device }
   if (DevHandle < 0) and (iberr=EDVR) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      ErrBox.lines.add ('IBFIND Couldn''t find device ' +dev_name);
      ErrBox.lines.add ('   Make sure that you have assigned the name '+ dev_name);
      ErrBox.lines.add ('   to the meter with the CBCONF.EXE program.  Make sure that');
      ErrBox.lines.add ('   the meter is configured for the address that you specified');
      ErrBox.lines.add ('   with CBCONF.EXE.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end

   else if (DevHandle < 0) and (iberr=ECFG) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'   ;
      ErrBox.lines.add ('Board type is incorrect');
      ErrBox.lines.add ('   The board type specified in GPIB.CFG does not match the installed');
      ErrBox.lines.add ('   board.  Run CBCONF.EXE and check the board type that is set there.');
      ErrBox.lines.add ('   Make sure that it matches the type of board that is installed in');
      ErrBox.lines.add ('   your system.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end
   else
       begin
       GPIBStatusBox.caption:='WORKING OK';
       ibtmo (DevHandle,T3s);         { Set timeout to 3 seconds }
       DrapeauGPIBconnection:=true;
       {       WriteCommand (RESET_CMD);      { Reset the device }
       end;

end;

{************************************************************************}
{                                                                        }
{  Name:         WriteCommand                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                CommandStr - command string to write to device          }
{  Description:  Writes a string to a GPIB device and checks for errors  }
{                                                                        }
{************************************************************************}

procedure TconductusForm.WriteCommand (CommandStr:string);

var
  StrLen,i:integer;
  CommandP:PChar;

begin

   CommandP := StrAlloc (length (CommandStr) + 1);
   StrPCopy (CommandP, CommandStr);

 StrLen := length (CommandStr);              { Copy from string to buffer }
 ibwrt (DevHandle, CommandP, StrLen);          { Write to GPIB }
   if (ibcnt<>StrLen) or (ibsta and ERR <> 0) then  { Check for errors }
      PrntErrs ('IBWRT failed while writing ' +CommandStr);
end;





{************************************************************************}
{                                                                        }
{  Name:         ReadValue                                               }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                buffer - buffer to read data into                       }
{                bufsize - size of buffer                                }
{  Description:  Reads from a GPIB device                                }
{                                                                        }
{************************************************************************}


procedure TconductusForm.ReadValue (var ReadStr:string);

const
     READ_BUF_SIZE = 200;
var
  ReadBuf: array[0..READ_BUF_SIZE] of Char;

begin
   if (DevHandle = 0) then
      begin
      ErrBox.lines.add('---');
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      end
   else
       begin;
       ibrd (DevHandle, ReadBuf, READ_BUF_SIZE);     { Read from GPIB }
       if (ibcnt = 0) or (ibsta and ERR <> 0) then { Check for errors }
          begin;
          ErrBox.lines.add('---');
          PrntErrs ('IBRD failed');
          GPIBStatusBox.caption:='NOT WORKING WELL'  ;
          {timer1.Enabled := False;}
          end
       else
           ReadBuf[ibcnt] := #0;
           ReadStr := StrPas (ReadBuf);
           ErrBox.lines.add ( 'ANSWER = '+readStr);
       end;

end;



{************************************************************************}
{                                                                        }
{  Name:         ReadIDString                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{  Description:  This procedure asks the voltmeter for it's ID string.   }
{                It reads the string that is returned and prints it.     }
{                                                                        }
{************************************************************************}

procedure TconductusForm.ReadIDString;

var
   IDString:string;

begin
   WriteCommand (ID_CMD);
   ReadValue (IDString);
   ErrBox.lines.Add ('Device Identification = ' +IDString);
end;


{************************************************************************}
{                                                                        }
{  Name:         PrintErrors                                             }
{  Description:  This procedure prints an error message followed by the  }
{                values of the global staus variables - IBSTA, IBERR,    }
{                and IBCNT.  For IBSTA it prints the name of every bit   }
{                that is set.  For IBERR it prints the mnemonic for the  }
{                error code.                                             }
{                                                                        }
{************************************************************************}

procedure TconductusForm.PrntErrs (ErrMsg:string);

var
   ErrStr: String;
   HexStr: String;

begin
   ErrBox.lines.Add (ErrMsg);

   ErrStr := '   IBSTA=';              { Print IBSTA value }

   if ibsta and ERR  <> 0 then ErrStr := ErrStr + ' ERR';
   if ibsta and TIMO <> 0 then ErrStr := ErrStr + ' TMO';
   if ibsta and EEND <> 0 then ErrStr := ErrStr + ' END';
   if ibsta and SRQI <> 0 then ErrStr := ErrStr + ' SRQI';
   if ibsta and RQS  <> 0 then ErrStr := ErrStr + ' RQS';;
   if ibsta and SPOLL <> 0 then ErrStr := ErrStr + ' SPOLL';
   if ibsta and EVENT <> 0 then ErrStr := ErrStr + ' EVENT';
   if ibsta and CMPL <> 0 then ErrStr := ErrStr + ' CMPL';
   if ibsta and LOK  <> 0 then ErrStr := ErrStr + ' LOK';
   if ibsta and REM  <> 0 then ErrStr := ErrStr + ' REM';
   if ibsta and CIC  <> 0 then ErrStr := ErrStr + ' CIC';
   if ibsta and ATN  <> 0 then ErrStr := ErrStr + ' ATN';
   if ibsta and TACS <> 0 then ErrStr := ErrStr + ' TACS';
   if ibsta and LACS <> 0 then ErrStr := ErrStr + ' LACS';
   if ibsta and DTAS <> 0 then ErrStr := ErrStr + ' DTAS';
   if ibsta and DCAS <> 0 then ErrStr := ErrStr + ' DCAS';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBERR=';
   if iberr = EDVR then ErrStr := ErrStr + ' EDVR <DOS Error>';
   if iberr = ECIC then ErrStr := ErrStr + ' ECIC <Not CIC>';
   if iberr = ENOL then ErrStr := ErrStr + ' ENOL <No Listener>';
   if iberr = EADR then ErrStr := ErrStr + ' EADR <Address Error>';
   if iberr = EARG then ErrStr := ErrStr + ' EARG <Invalid Arguments>';
   if iberr = ESAC then ErrStr := ErrStr + ' ESAC <Not System Controller>';
   if iberr = EABO then ErrStr := ErrStr + ' EABO <Operation aborted>';
   if iberr = ENEB then ErrStr := ErrStr + ' ENEB <No GPIB board>';
   if iberr = EOIP then ErrStr := ErrStr + ' EOIP <Async I/I in progress>';
   if iberr = ECAP then ErrStr := ErrStr + ' ECAP <No Capability>';
   if iberr = EFSO then ErrStr := ErrStr + ' EFSO <File Error>';
   if iberr = EBUS then ErrStr := ErrStr + ' EBUS <Command error>';
   if iberr = ESTB then ErrStr := ErrStr + ' ESTB <Status byte lost>';
   if iberr = ESRQ then ErrStr := ErrStr + ' ESRQ <SRQ Stuck On>';
   if iberr = ETAB then ErrStr := ErrStr + ' ETAB <Table Overflow>';
   if iberr = ECFG then ErrStr := ErrStr + ' ECFG <Incorrect board>';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBCNT=';
   ErrBox.lines.add (ErrStr);
end;

procedure TconductusForm.Connect;
begin
   OpenDevice;                         { Open the GPIB device }
{   timer1.Enabled := True;}
end;

procedure TconductusForm.Commande(Commande:string);

var
   CmdStr: string;
   i,start: Integer;

begin
{   if DevHandle<>0 then StopConnection;}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;

   {if DevHandle = 0 Then OpenDevice;}

   CmdStr:=Commande;
    {exple : '*IDN?' 'CFRQ:VALUE 15MHZ' 'RFLV:VALUE 9DBM'}

    if GPIBCallInProgress = FALSE then
       begin;
       GPIBCallInProgress := TRUE;
       {temps d'attente de 100 msec avant de passer la commande}
{       start:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - start) > 100);
       UNTIL timeout;}
       WriteCommand (CmdStr);
       GPIBCallInProgress := FALSE;
       ErrBox.lines.Add(Commande); {on affiche la commande}
       end;

{   StopConnection;}
end;

procedure TconductusForm.StopConnection;
begin
{ timer1.Enabled := False;}
{ ErrBox.Clear;}
 If GPIBCallInProgress = FALSE Then
    begin;
    GPIBCallInProgress := TRUE;
    ibclr(DevHandle);
    ibloc(DevHandle);
    GPIBCallInProgress := FALSE;
    end;

end;



procedure TconductusForm.ReadTempButtonClick(Sender: TObject);
begin
   readAllTemperatures;
end;

procedure TconductusForm.ReadAllTemperatures;
var valeur:extended;unite,chaine:string;
begin
   readtemperature(1,valeur,unite);
   str(valeur:8:3,chaine);
   temperaturebox1.caption:=chaine;
   unitebox1.caption:=unite;
   readtemperature(2,valeur,unite);
   str(valeur:8:3,chaine);
   temperaturebox2.caption:=chaine;
   unitebox2.caption:=unite;
end;

procedure Tconductusform.readtemperature(Senseur:integer;var valeur:extended;var unite:string);
var valeur2:extended;chaine:string;
begin
   if senseur=2 then readsenseur(2,valeur,unite)
      else readsenseur(1,valeur,unite);
end;

procedure Tconductusform.settemperature(valeur:string;senseur:integer);
var chaine,chaine2:string;err:integer;nombre:extended;
begin
  if pos(',',valeur)>0 then
     begin
     valeur:=copy(valeur,1,pos(',',valeur)-1)+'.'+
             copy(valeur,pos(',',valeur)+1,length(valeur)-pos(',',valeur));
     end;
  val(valeur,nombre,err);
  if (err=0) and (nombre>0) and (nombre<700) and (senseur<=2) and (senseur>=1) then
    begin
     if senseur=1 then WriteCommand('SOSEN1,1;');
     if senseur=2 then WriteCommand('SOSEN1,2;');
     chaine2:='SETP1,'+valeur+';';
     WriteCommand(chaine2);
     WriteCommand('SCONT;');
     LastAskedTemperatureLabel.caption:=chaine+' K at '+TimeToStr(Time)+','+DateToStr(Date);
     LastAskedTemperatureLabel.refresh;
    end;
end;

procedure Tconductusform.readSenseur(senseur:integer;var valeur:extended;var unite:string);
var err:integer;chaine,reponse:string;nombre:extended;
begin
     if senseur=1 then WriteCommand ('QSAMP?<1=Sensor 1>;');
     if senseur=2 then WriteCommand ('QSAMP?<2=Sensor 2>;');
     ReadValue(REPONSE);
     ErrBox.lines.add (reponse);
     chaine:=reponse;
     if pos('K',reponse)>0 then unite:='K';
     if pos('O',reponse)>0 then unite:='O';
     err:=2;
     nombre:=0;
     repeat
       val(chaine,nombre,err);
       chaine:=copy(chaine,1,length(chaine)-1);
     until (err=0) or (length(chaine)=0);
     valeur:=nombre;
end;

procedure TconductusForm.SetTemperatureBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var valeur,valeur2:extended;err,err2:integer;
begin
if key=13 then
   begin
   valeur2:=0;
   val(sensorbox.text,valeur2,err2);
   if (round(valeur2)<>1) and (round(valeur2)<>2) then err2:=1;
   val(SettemperatureBox.text,valeur,err);
   if (err=0) and (valeur>0) and (valeur<700) and (err2=0) then SetTemperature(SettemperatureBox.text,round(valeur2))
      else MessageDlg('error in the typing of temperature or sensor box', mtInformation, [mbOk], 0);
   SettemperatureBox.text:='';
   end;

end;

end.

