unit geneRF_gpib;
{For using a GPIB IEEE interface : install first the gpib
programs from the disk. Then, go to the program cbconf.exe
choose Edit GPIB1 Board Options,
then chang Board is installed to Board is not installed
Then specify an adress at Primary GPIB adress,
the same that you will specify in the device which will be interfaced.
Finally, fo to DEV1 or DEV2 or... menu, and
specify in one of them the name of the device (for example : GENERF)
Then go back to main menu, and Save Current Configuration. Then quit CBCONF32.

Then, in this delphi unit, put in the definition of the constants
at the begining a lien which specifies the name again : like
const
    DEV_NAME = 'GENERF';

Finally, make sure that the unit you use for your interface has in 'uses' the
unit 'gpib' specified

*******************************************************************
*******************************************************************
IMPORTANT : BE SURE WHEN YOU CHANGE OF COMPUTER TO CHECK AGAIN THE OPTIONS
OF THE CBCONF.EXE AND THAT ALL THE NAMES OF THE DEVICE TO BE USED ARE
WELL SPECIFIED !!!
*************************************************************************
*************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gpib, StdCtrls, ExtCtrls,DrapeauAlloulUnit;

type
  TgeneRF = class(TForm)
    nmrRFfreqBox: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    RFlevelDBM: TEdit;
    Label5: TLabel;
    Label7: TLabel;
    GPIBStatusBox: TLabel;
    GeneRFFreqBox: TEdit;
    ErrBox: TMemo;
    TuningButton: TButton;
    AttenueButton: TButton;
    SwitchManualButton: TButton;
    Label3: TLabel;
    Label6: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure OpenDevice;
    procedure ouverture;
    procedure WriteCommand (CommandStr:string);
    procedure ReadIDString ;
    procedure ReadValue (var ReadStr:string);
    procedure PrntErrs (ErrMsg:string);
    procedure Connect;
    procedure StopConnection;
    procedure Commande(Commande:string);
    procedure nmrRFfreqBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ChangeFrequenceGeneRF(frequence:extended);{change la frequence MHZ}
    procedure ChangeRFLevel(rfLevelDB:extended); {change le rf level dBM}
    procedure AfficheRFLevel;
    procedure AfficheFrequence(var FrequenceRMN:extended);
    procedure GeneRFFreqBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RFlevelDBMKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TuningButtonClick(Sender: TObject);
    procedure AttenueButtonClick(Sender: TObject);
    procedure SwitchManualButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
    MaxLen = 80;                 { Size of IBRD/IBWRT strings  }
    DEV_NAME = 'GENERF';        { Name for device as specified in CBCONF }
    RESET_CMD = '*RST';          { "Reset" command }
    ID_CMD = '*IDN?';            { "Identify Myself" command }

var
  geneRF: TgeneRF;
  DevHandle:Integer;
  GPIBCallInProgress:Boolean;

implementation

uses ParSeq, Seq16Channels, SeqNewHetero;

{$R *.DFM}

procedure TgeneRF.FormCreate(Sender: TObject);
var valeur:extended;err:integer;
begin
   DrapeauStopPourTuning:=false;
   if drapeauRFgenerateurMARCONI2023=true then generf.caption:='Marconi RadioFrequency Generator 2023';
   if drapeauRFgenerateurMARCONI2022D=true then generf.caption:='Marconi RadioFrequency Generator 2022D';
{cas vieux hetero : frequence de travail = freq RMN + 210}
   if drapeauspectrooldhetero=true then
      begin
      label3.caption:='Spectro Old Heterodyne : rf freq = NMR rf + 210 MHz ; rf level = 9 dBm';
      label2.Caption:='RF gene = NMR freq + 210 MHz =';
      label5.caption:='rf level (dBm) (=9 normally)';
      nmrRFFreqBox.visible:=true;
      label1.visible:=true;
      tuningbutton.visible:=true;
      end;
   if drapeauspectronewhetero=true then
      begin
      label3.caption:='Spectro New Heterodyne : rf freq = NMR rf + 280 MHz ; rf level = 9 dBm';
      label2.Caption:='RF gene = NMR freq + 280 MHz =';
      label5.caption:='rf level (dBm) (=9 normally)';
      nmrRFFreqBox.visible:=true;
      label1.visible:=true;
      tuningbutton.visible:=true;
      end;
   if (drapeauspectrooldhetero=false) and (drapeauspectronewhetero=false) then
      begin
      label3.caption:='Spectro Homodyne : rf level = 13 dBm';
      label2.Caption:='RF frequency =';
      label5.caption:='rf level (dBm) (=13 normally)';
      nmrRFFreqBox.visible:=false;
      label1.visible:=false;
      tuningbutton.visible:=false;
      end;

   SwitchManualButton.caption:='switch rf GENERATOR to MANUAL';
   if drapeauRFgenerateurMARCONI2022D=true then begin
                                           label6.visible:=true;
                                           SwitchManualButton.visible:=false;
                                           end
                                           else
                                           label6.visible:=false;

   DrapeauGPIBconnection:=false; {dit si GPIB marche ou pas}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   if (DrapeauGPIBconnection=true) then
     begin
     ReadIDString;
     AfficheFrequence(valeur); {lit et affiche la nouvelle valeur de frequence}
     val(GeneRFFreqBox.text,valeur,err);
     AfficheRFLevel; {lit et affiche la nouvelle valeur de frequence}
     val(RFLEVELDBM.text,valeur,err);
     if (drapeauspectronewhetero=true) or (drapeauspectrooldhetero=true) then
        begin
        if (valeur<>9)  then AttenueButton.caption:='Press for 9 dbM'
                  else AttenueButton.caption:='Press for -10dbM';
        end
        else
        begin
        if (valeur<>13)  then AttenueButton.caption:='Press for 13 dbM'
                  else AttenueButton.caption:='Press for -10dbM';
        end;

     end;
end;


procedure TgeneRF.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
geneRF.WindowState:=WsMinimized;
geneRF.WindowState:=WsNormal;
end;
{************************************************************************}
{                                                                        }
{  Name:         OpenDevice                                            }
{  Returns:      Handle of opened GPIB device                }
{  Description:  Opens the GPIB device (Fluke45) and resets it
{                                                                        }
{************************************************************************}

procedure TGeneRF.OpenDevice;
var
  DevName:PChar;IDString:string;

begin
   If (DevHandle > 0) then Exit;
   DevName := StrAlloc (length (DEV_NAME) + 1);
   StrPCopy (DevName, DEV_NAME);

   DevHandle := ibfind (DevName);        { Open the device }
   if (DevHandle < 0) and (iberr=EDVR) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      ErrBox.lines.add ('IBFIND Couldn''t find device ' +dev_name);
      ErrBox.lines.add ('   Make sure that you have assigned the name '+ dev_name);
      ErrBox.lines.add ('   to the meter with the CBCONF.EXE program.  Make sure that');
      ErrBox.lines.add ('   the meter is configured for the address that you specified');
      ErrBox.lines.add ('   with CBCONF.EXE.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end

   else if (DevHandle < 0) and (iberr=ECFG) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'   ;
      ErrBox.lines.add ('Board type is incorrect');
      ErrBox.lines.add ('   The board type specified in GPIB.CFG does not match the installed');
      ErrBox.lines.add ('   board.  Run CBCONF.EXE and check the board type that is set there.');
      ErrBox.lines.add ('   Make sure that it matches the type of board that is installed in');
      ErrBox.lines.add ('   your system.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end
   else
       begin
       GPIBStatusBox.caption:='WORKING OK';
       ibtmo (DevHandle,T3s);         { Set timeout to 3 seconds }
       DrapeauGPIBconnection:=true;
       {       WriteCommand (RESET_CMD);      { Reset the device }
       end;

end;

{************************************************************************}
{                                                                        }
{  Name:         WriteCommand                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                CommandStr - command string to write to device          }
{  Description:  Writes a string to a GPIB device and checks for errors  }
{                                                                        }
{************************************************************************}

procedure TGeneRF.WriteCommand (CommandStr:string);

var
  StrLen,i:integer;
  CommandP:PChar;

begin

   CommandP := StrAlloc (length (CommandStr) + 1);
   StrPCopy (CommandP, CommandStr);

 StrLen := length (CommandStr);              { Copy from string to buffer }
 ibwrt (DevHandle, CommandP, StrLen);          { Write to GPIB }
   if (ibcnt<>StrLen) or (ibsta and ERR <> 0) then  { Check for errors }
      PrntErrs ('IBWRT failed while writing ' +CommandStr);
end;





{************************************************************************}
{                                                                        }
{  Name:         ReadValue                                               }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                buffer - buffer to read data into                       }
{                bufsize - size of buffer                                }
{  Description:  Reads from a GPIB device                                }
{                                                                        }
{************************************************************************}


procedure TGeneRF.ReadValue (var ReadStr:string);

const
     READ_BUF_SIZE = 200;
var
  ReadBuf: array[0..READ_BUF_SIZE] of Char;

begin
   if (DevHandle = 0) then
      begin
      ErrBox.lines.add('---');
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      end
   else
       begin;
       ibrd (DevHandle, ReadBuf, READ_BUF_SIZE);     { Read from GPIB }
       if (ibcnt = 0) or (ibsta and ERR <> 0) then { Check for errors }
          begin;
          ErrBox.lines.add('---');
          PrntErrs ('IBRD failed');
          GPIBStatusBox.caption:='NOT WORKING WELL'  ;
          {timer1.Enabled := False;}
          end
       else
           ReadBuf[ibcnt] := #0;
           ReadStr := StrPas (ReadBuf);
           ErrBox.lines.add ( 'ANSWER = '+readStr);
       end;

end;



{************************************************************************}
{                                                                        }
{  Name:         ReadIDString                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{  Description:  This procedure asks the voltmeter for it's ID string.   }
{                It reads the string that is returned and prints it.     }
{                                                                        }
{************************************************************************}

procedure TGeneRF.ReadIDString;

var
   IDString:string;

begin
   WriteCommand (ID_CMD);
   ReadValue (IDString);
   ErrBox.lines.Add ('Device Identification = ' +IDString);
end;


{************************************************************************}
{                                                                        }
{  Name:         PrintErrors                                             }
{  Description:  This procedure prints an error message followed by the  }
{                values of the global staus variables - IBSTA, IBERR,    }
{                and IBCNT.  For IBSTA it prints the name of every bit   }
{                that is set.  For IBERR it prints the mnemonic for the  }
{                error code.                                             }
{                                                                        }
{************************************************************************}

procedure TGeneRF.PrntErrs (ErrMsg:string);

var
   ErrStr: String;
   HexStr: String;

begin
   ErrBox.lines.Add (ErrMsg);

   ErrStr := '   IBSTA=';              { Print IBSTA value }

   if ibsta and ERR  <> 0 then ErrStr := ErrStr + ' ERR';
   if ibsta and TIMO <> 0 then ErrStr := ErrStr + ' TMO';
   if ibsta and EEND <> 0 then ErrStr := ErrStr + ' END';
   if ibsta and SRQI <> 0 then ErrStr := ErrStr + ' SRQI';
   if ibsta and RQS  <> 0 then ErrStr := ErrStr + ' RQS';;
   if ibsta and SPOLL <> 0 then ErrStr := ErrStr + ' SPOLL';
   if ibsta and EVENT <> 0 then ErrStr := ErrStr + ' EVENT';
   if ibsta and CMPL <> 0 then ErrStr := ErrStr + ' CMPL';
   if ibsta and LOK  <> 0 then ErrStr := ErrStr + ' LOK';
   if ibsta and REM  <> 0 then ErrStr := ErrStr + ' REM';
   if ibsta and CIC  <> 0 then ErrStr := ErrStr + ' CIC';
   if ibsta and ATN  <> 0 then ErrStr := ErrStr + ' ATN';
   if ibsta and TACS <> 0 then ErrStr := ErrStr + ' TACS';
   if ibsta and LACS <> 0 then ErrStr := ErrStr + ' LACS';
   if ibsta and DTAS <> 0 then ErrStr := ErrStr + ' DTAS';
   if ibsta and DCAS <> 0 then ErrStr := ErrStr + ' DCAS';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBERR=';
   if iberr = EDVR then ErrStr := ErrStr + ' EDVR <DOS Error>';
   if iberr = ECIC then ErrStr := ErrStr + ' ECIC <Not CIC>';
   if iberr = ENOL then ErrStr := ErrStr + ' ENOL <No Listener>';
   if iberr = EADR then ErrStr := ErrStr + ' EADR <Address Error>';
   if iberr = EARG then ErrStr := ErrStr + ' EARG <Invalid Arguments>';
   if iberr = ESAC then ErrStr := ErrStr + ' ESAC <Not System Controller>';
   if iberr = EABO then ErrStr := ErrStr + ' EABO <Operation aborted>';
   if iberr = ENEB then ErrStr := ErrStr + ' ENEB <No GPIB board>';
   if iberr = EOIP then ErrStr := ErrStr + ' EOIP <Async I/I in progress>';
   if iberr = ECAP then ErrStr := ErrStr + ' ECAP <No Capability>';
   if iberr = EFSO then ErrStr := ErrStr + ' EFSO <File Error>';
   if iberr = EBUS then ErrStr := ErrStr + ' EBUS <Command error>';
   if iberr = ESTB then ErrStr := ErrStr + ' ESTB <Status byte lost>';
   if iberr = ESRQ then ErrStr := ErrStr + ' ESRQ <SRQ Stuck On>';
   if iberr = ETAB then ErrStr := ErrStr + ' ETAB <Table Overflow>';
   if iberr = ECFG then ErrStr := ErrStr + ' ECFG <Incorrect board>';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBCNT=';
   ErrBox.lines.add (ErrStr);
end;

procedure TGeneRF.Connect;
begin
   OpenDevice;                         { Open the GPIB device }
{   timer1.Enabled := True;}
end;

procedure TGeneRF.Commande(Commande:string);

var
   CmdStr: string;
   i,start: Integer;

begin
{   if DevHandle<>0 then StopConnection;}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;

   {if DevHandle = 0 Then OpenDevice;}

   CmdStr:=Commande;
    {exple : '*IDN?' 'CFRQ:VALUE 15MHZ' 'RFLV:VALUE 9DBM'}

    if GPIBCallInProgress = FALSE then
       begin;
       GPIBCallInProgress := TRUE;
       {temps d'attente de 100 msec avant de passer la commande}
{       start:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - start) > 100);
       UNTIL timeout;}
       WriteCommand (CmdStr);
       GPIBCallInProgress := FALSE;
       ErrBox.lines.Add(Commande); {on affiche la commande}
       end;

{   StopConnection;}
end;

procedure TGeneRF.StopConnection;
begin
{ timer1.Enabled := False;}
{ ErrBox.Clear;}
 If GPIBCallInProgress = FALSE Then
    begin;
    GPIBCallInProgress := TRUE;
    ibclr(DevHandle);
    ibloc(DevHandle);
    GPIBCallInProgress := FALSE;
    end;

end;


procedure TGeneRF.AfficheRFLevel;
var chaine,chaineCommande,REPONSE:string;
   i,err,err2:integer;
   valeur,valeur2:extended;
begin


if drapeauRFgenerateurMARCONI2023=true then ChaineCommande:='RFLV?';
if drapeauRFgenerateurMARCONI2022D=true then begin
      writecommand('LV');
      chainecommande:='QU';
      end;

   WriteCommand (ChaineCommande);
   ReadValue (REPONSE);

if drapeauRFgenerateurMARCONI2023=true then
   begin
   Valeur2:=0;Valeur:=-999;
   RFLEVELDBM.Text:=copy(REPONSE,pos('VALUE',REPONSE)+6,
                 pos(';INC',REPONSE)-pos('VALUE',REPONSE)-6);
   RFLEVELDBM.refresh;
   end;
if drapeauRFgenerateurMARCONI2022D=true then
   begin
   Valeur2:=0;Valeur:=-999;
   RFLEVELDBM.Text:=copy(REPONSE,pos('LV',REPONSE)+4,pos('DB',REPONSE)-pos('LV',REPONSE)-4);
   if copy(rfleveldbm.text,1,1)=' ' then rfleveldbm.text:=copy(rfleveldbm.text,2,length(rfleveldbm.text)-1);
   if pos('-',reponse)>0 then rfleveldbm.text:='-'+rfleveldbm.text;
   RFLEVELDBM.refresh;
   end;

end;

procedure TGeneRF.AfficheFrequence(var FrequenceRMN:extended);
var chaine,chaine2,chaineCommande,REPONSE:string;
   i,err,err2:integer;
   valeur,valeur2:extended;
begin
FrequenceRMN:=valeur;

   if drapeauRFgenerateurMARCONI2023=true then ChaineCommande:='CFRQ?';
   if drapeauRFgenerateurMARCONI2022D=true then begin
      writecommand('CF');
      chainecommande:='QU';
      end;

   WriteCommand (ChaineCommande);
   ReadValue (REPONSE);

  if drapeauRFgenerateurMarconi2023=true then
   begin
   Valeur2:=0;Valeur:=-999;
   GENERFFreqBox.text:=copy(REPONSE,pos('VALUE',REPONSE)+6,
                 pos(';INC',REPONSE)-pos('VALUE',REPONSE)-6);
   GENERFFreqBox.refresh;
   {conversion Hz --> MHZ}
   val(GENERFFreqBox.text,valeur,err);
   valeur:=valeur/1e6;
   str(valeur:10:6,chaine2);
   GENERFFreqBox.text:=chaine2;
   GeneRFFreqBox.refresh;
   end;
  if drapeauRFgenerateurMarconi2022D=true then
   begin
   Valeur2:=0;Valeur:=-999;
   GENERFFreqBox.Text:=copy(REPONSE,pos('CF',REPONSE)+3,pos('MZ',REPONSE)-pos('CF',REPONSE)-3);
   GENERFFreqBox.refresh;
   val(GENERFFreqBox.text,valeur,err);
   end;

  if drapeauspectrooldhetero=true then
     begin
     if valeur<210 then {mode tuning}
                   begin
                   nmrRFFreqBox.text:=GeneRFFreqBox.text;
                   TuningButton.caption:='(now:tuning) Press to go back to RUN MODE';
                   DrapeauInTuning:=true;
                   end
                   else
                   begin {mode normal}
                   TuningButton.caption:='Press to do TUNING';
                   valeur:=valeur-210;
                   str(valeur:10:6,chaine2);
                   NMRRFFreqBox.text:=chaine2;
                   DrapeauInTuning:=false;
                   FrequenceRMN:=valeur;
                   end;
     end;
  if drapeauspectronewhetero=true then
     begin
     if valeur<280 then {mode tuning}
                   begin
                   nmrRFFreqBox.text:=GeneRFFreqBox.text;
                   TuningButton.caption:='(now:tuning) Press to go back to RUN MODE';
                   DrapeauInTuning:=true;
                   end
                   else
                   begin {mode normal}
                   TuningButton.caption:='Press to do TUNING';
                   valeur:=valeur-280;
                   str(valeur:10:6,chaine2);
                   NMRRFFreqBox.text:=chaine2;
                   DrapeauInTuning:=false;
                   FrequenceRMN:=valeur;
                   end;
     end;
   if (drapeauspectronewhetero=false) and (drapeauspectrooldhetero=false) then
                 begin
                 FrequenceRMN:=valeur;
                 nmrRFFreqBox.text:=GeneRFFreqBox.text;
                 end;

{on enleve les espaces en trop}
   if length(nmrrffreqbox.text)>1 then
      repeat
      if copy(nmrrffreqbox.text,1,1)=' ' then
                nmrrffreqbox.text:=copy(nmrrffreqbox.text,2,length(nmrrffreqbox.text)-1);
      until copy(nmrrffreqbox.text,1,1)<>' ';
{on enleve les espaces en trop}
   if length(GENERFfreqbox.text)>1 then
      repeat
      if copy(GENERFfreqbox.text,1,1)=' ' then
                GENERFfreqbox.text:=copy(GENERFfreqbox.text,2,length(GENERFfreqbox.text)-1);
      until copy(GENERFfreqbox.text,1,1)<>' ';

   val(NMRRFFreqBox.text,NMRRadioFrequency,err);
   val(GENERFFreqBox.text,GeneRadioFrequency,err);

end;


procedure TGeneRF.ChangeRFLevel(rfLevelDB:extended); {change la freq en MHz}
var chaine,chaine2,chaineCommande:string;valeur:extended;err:integer;
begin
if (rfLevelDB<=13) and (rfLevelDB>=-140) then
   begin
   str(rfLevelDB:8:4,chaine);
if drapeauRFgenerateurMARCONI2023=true then ChaineCommande:='RFLV:VALUE '+chaine+'DBM';
if drapeauRFgenerateurMARCONI2022D=true then ChaineCommande:='LV '+chaine+' DB';
   commande(ChaineCommande);
   end;
AfficheRFLEVEL; {lit et affiche la nouvelle valeur du RFLEVEL}
chaine2:=RFLevelDBM.text;
val(chaine,valeur,err);
if valeur<>rfLevelDB then errBox.Lines.Add('ATTENTION, ERROR ON THE RF LEVEL COMMAND');

end;


procedure TGeneRF.ChangeFrequenceGeneRF(frequence:extended); {change la freq en MHz}
var chaine,chaineCommande:string;frequenceRMN:extended;
begin
if (frequence>0.1) and (frequence<500) then
   begin
   str(frequence:10:8,chaine);
if drapeauRFgenerateurMARCONI2023=true then ChaineCommande:='CFRQ:VALUE '+chaine+'MHZ';
if drapeauRFgenerateurMARCONI2022D=true then ChaineCommande:='CF '+chaine+' MZ';
   commande(ChaineCommande);
   end;
AfficheFrequence(frequenceRMN); {lit et affiche la nouvelle valeur de frequence}
end;

procedure TgeneRF.nmrRFfreqBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var rfFreq:real;err:integer;y:integer;chaine,ChaineCommande:string;
begin
{CHANGEMENT DE FREQUENCE RMN (ajouter 210)}
  if  Key=13 {si return} then
  begin
     val(nmrRFFreqBox.text,rfFreq,err);
     if err=0 then
       begin
       {demande de la valeur}
       if rfFreq>1000 then rfFreq:=rfFreq/1000 {passage en MHz si on est en kHz};
       if rfFreq>1000 then rfFreq:=rfFreq/1000 {passage en MHz si on est en Hz};
       if (rfFreq>0.1) and (rfFreq<500) then
          begin
          NMRRadioFrequency:=rfFreq;
       if DrapeauStopPourTuning=false then
         begin
         if drapeauSpectroOldHetero=true then GeneRadioFrequency:=rfFreq+210;
         if drapeauSpectroNewHetero=true then GeneRadioFrequency:=rfFreq+280;
         if (drapeauSpectroOldHetero=false) and (drapeauSpectroNewHetero=false) then GeneRadioFrequency:=rfFreq;
         end
         else
         begin
         if drapeauSpectroOldHetero=true then GeneRadioFrequency:=rfFreq;
         if drapeauSpectroNewHetero=true then GeneRadioFrequency:=rfFreq;
         if (drapeauSpectroOldHetero=false) and (drapeauSpectroNewHetero=false) then GeneRadioFrequency:=rfFreq;
         end;
         str(GeneRadioFrequency:10:6,chaine);
         GeneRFFreqBox.text:=chaine;GeneRFFreqBox.refresh;
         str(NMRRadioFrequency:10:6,chaine);
         nmrRFFreqBox.text:=chaine;nmrRFFreqBox.refresh;
         ChangeFrequenceGeneRF(GeneRadioFrequency);
         end;
       end;
   end;

end;


procedure TgeneRF.GeneRFFreqBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var rfFreq:real;err:integer;y:integer;chaine,ChaineCommande:string;
begin
{CHANGEMENT DE FREQUENCE DIRECTEMENT DU GENERF}
  if  Key=13 {si return} then
  begin
     val(GENERFFreqBox.text,rfFreq,err);
     if err=0 then
       begin
       {demande de la valeur}
       if rfFreq>1000 then rfFreq:=rfFreq/1000 {passage en MHz si on est en kHz};
       if rfFreq>1000 then rfFreq:=rfFreq/1000 {passage en MHz si on est en Hz};
       if drapeauSpectroOldHetero=true then NMRRadioFrequency:=rfFreq-210;
       if drapeauSpectroNewHetero=true then NMRRadioFrequency:=rfFreq-280;
       if (drapeauSpectroOldHetero=false) and (drapeauSpectroNewHetero=false) then NMRRadioFrequency:=rfFreq;
       GeneRadioFrequency:=rfFreq;
       str(GeneRadioFrequency:10:6,chaine);
       GeneRFFreqBox.text:=chaine;GeneRFFreqBox.refresh;
       str(NMRRadioFrequency:10:6,chaine);
       nmrRFFreqBox.text:=chaine;nmrRFFreqBox.refresh;
       ChangeFrequenceGeneRF(GeneRadioFrequency);
       end;
   end;

end;

procedure TgeneRF.RFlevelDBMKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var rfLevel:real;err:integer;y:integer;chaine,ChaineCommande:string;reponse:string;
begin
{CHANGEMENT DE RF LEVEL}
  if  Key=13 {si return} then
  begin
     val(RFLEVELDBM.text,rfLevel,err);
     if err=0 then
       begin
       {demande de la valeur}
       NMRdBMLevel:=rfLevel;
       ChangeRFLEVEL(rfLevel);
       end;
   end;

end;

procedure TgeneRF.TuningButtonClick(Sender: TObject);
var valeur:extended;err:integer;frequenceRMN:extended;
begin
{en mode tuning, on passe de 210+freqRF  freqRF sur le gene RF
en mode normal, on fait l'inverse}
    if TuningButton.caption='Press to do TUNING' then
          begin
          DrapeauInTuning:=true;
          TuningButton.caption:='(now:tuning) Press to go back to RUN MODE';
          {on stoppe la sequence de pulse}
          if DrapeauStopPourTuning=false then
            begin
            DrapeauStopPourTuning:=true;
            if DrapeauSequenceurSpectroHetero=true then Seqpar.StopClick(Sender);
            if DrapeauSequenceur16VoiesIndependant=true then Seq16ChannelsForm.StopClick(Sender);
            if DrapeauSequenceurNewHetero=true then SeqNewHeteroform.StopClick(Sender);
            end;
          AfficheFrequence(frequenceRMN);
          val(NMRRFFreqBox.Text,valeur,err);
          if err=0 then ChangeFrequenceGeneRF(valeur);
          end
                                              else
          begin
          DrapeauInTuning:=false;
          TuningButton.caption:='Press to do TUNING';
          val(NMRRFFreqBox.Text,valeur,err);
       if drapeauSpectroOldHetero=true then valeur:=valeur+210;
       if drapeauSpectroNewHetero=true then valeur:=valeur+280;
          ChangeFrequenceGeneRF(valeur);
          afficheFrequence(frequenceRMN);
                    {on stoppe la sequence de pulse}
          if DrapeauStopPourTuning=true then
            begin
            DrapeauStopPourTuning:=false;
            if DrapeauSequenceurSpectroHetero=true then Seqpar.StartSequenceur;
            if DrapeauSequenceur16VoiesIndependant=true then Seq16ChannelsForm.StartSequenceur;
            if DrapeauSequenceurNewHetero=true then SeqNewHeteroform.StartSequenceur;
            end;


          end;
end;

procedure TgeneRF.AttenueButtonClick(Sender: TObject);
begin
    if AttenueButton.caption='Press for -10 dbM' then
          begin
       if drapeauSpectroOldHetero=true then AttenueButton.caption:='Press for 9 dbM';
       if drapeauSpectroNewHetero=true then AttenueButton.caption:='Press for 9 dbM';
       if (drapeauSpectroOldHetero=false) and (drapeauSpectroNewHetero=false) then AttenueButton.caption:='Press for 13 dbM';
       ChangeRFLevel(-10);
          end
          else
          begin
          AttenueButton.caption:='Press for -10 dbM';
       if drapeauSpectroOldHetero=true then ChangeRFLevel(9);
       if drapeauSpectroNewHetero=true then ChangeRFLevel(9);
       if (drapeauSpectroOldHetero=false) and (drapeauSpectroNewHetero=false) then ChangeRFLevel(13);
          end;

end;

procedure TgeneRF.SwitchManualButtonClick(Sender: TObject);
begin
      DrapeauGPIBconnection:=false;
      StopConnection;

end;


procedure TgeneRF.Button1Click(Sender: TObject);
var frequenceRMN:extended;
begin
  afficherflevel;
  affichefrequence(frequenceRMN);
end;

end.

