unit graphiqueAlloul;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,DrapeauAlloulUnit, Grids, TeEngine, Series, TeeProcs,
  Chart, Buttons;

type
   TGraphAlloulForm = class(TForm)
    TableauGrille: TStringGrid;
    Label4: TLabel;
    Xlabel: TLabel;
    YLabel: TLabel;
    XLabelBox1: TEdit;
    YLabelBox1: TEdit;
    Xcursor: TLabel;
    YCursor: TLabel;
    LineAndSymbolsCheck: TCheckBox;
    LogScaleButtonY: TButton;
    ChartXY: TChart;
    LogScaleButtonX: TButton;
    AddDataToGraph: TButton;
    RemoveDataFromGraph: TButton;
    YLabelBox2: TEdit;
    YLabelBox3: TEdit;
    YLabelBox4: TEdit;
    YLabelBox5: TEdit;
    YLabelBox6: TEdit;
    XLabelBox2: TEdit;
    XLabelBox3: TEdit;
    XlabelBox4: TEdit;
    XlabelBox5: TEdit;
    XlabelBox6: TEdit;
    Series2: TPointSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    Series5: TPointSeries;
    Series6: TPointSeries;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button3: TButton;
    SpeedButton4: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    PrintDialog1: TPrintDialog;
    PrintButton: TBitBtn;
    Label5: TLabel;
    Series1: TPointSeries;

    procedure ouverture;
    procedure DrawArray;
    {Trace les points du tableau}
    procedure FormDblClick(Sender: TObject);
    procedure RafraichitGrille;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure rafraichitGraphe;
    procedure LogScaleButtonYClick(Sender: TObject);
    procedure LogScaleButtonXClick(Sender: TObject);
    procedure ChartXYMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AddDataToGraphClick(Sender: TObject);
    procedure RemoveDataFromGraphClick(Sender: TObject);
    procedure LineAndSymbolsCheckClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure YLabelBox2Change(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure ChartXYDblClick(Sender: TObject);
  private
    { Dclarations prives}
  public

    { Dclarations publiques}
  end;

var
  oldX,oldY:longint;GraphAlloulForm: TGraphAlloulForm;
  xmin,xmax,ymin,ymax,xmin2,xmax2,ymin2,ymax2 : extended; {bornes du graphique}
  OldnumColonneX,OldnumColonneY:integer;
  drapeaulogscale:boolean;
  NombreDatas:integer;
implementation

uses interpreteur;

{$R *.DFM}
procedure TGraphAlloulForm.ouverture;
var numeroX,numeroY:extended;err:integer;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
GraphAlloulForm.WindowState:=WsMinimized;
GraphAlloulForm.WindowState:=WsNormal;
rafraichitGraphe();

end;




procedure TGraphAlloulForm.DrawArray;
{ Trace les LastLineArray premiers points du tableau GraphArray dans le graphe en supposant
qu'il soit sous forme de deux colonnes X et Y}
var err,i,j,xPlot,yPlot,numcolonneX,numcolonneY:integer;drapeau:boolean;
    nomX,nomY:string;
begin

series1.clear;
series2.clear;
series3.clear;
series4.clear;
series5.clear;
series6.clear;

if lineandsymbolscheck.state=cbchecked then
   begin
   series1.DrawBetweenPoints:=true;
   series2.DrawBetweenPoints:=true;
   series3.DrawBetweenPoints:=true;
   series4.DrawBetweenPoints:=true;
   series5.DrawBetweenPoints:=true;
   series6.DrawBetweenPoints:=true;
   end
   else
   begin
   series1.DrawBetweenPoints:=false;
   series2.DrawBetweenPoints:=false;
   series3.DrawBetweenPoints:=false;
   series4.DrawBetweenPoints:=false;
   series5.DrawBetweenPoints:=false;
   series6.DrawBetweenPoints:=false;
   end;
series1.ShowInLegend:=false;
series2.ShowInLegend:=false;
series3.ShowInLegend:=false;
series4.ShowInLegend:=false;
series5.ShowInLegend:=false;
series6.ShowInLegend:=false;

if nombredatas>0 then
  begin
  val(XLabelBox1.text,numColonneX,err);
  val(YLabelBox1.text,numColonneY,err);
  if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series1.Title:=NomX+' - '+NomY;
  series1.ShowInLegend:=true;

  With Series1 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;
if nombredatas>1 then
  begin
  val(XLabelBox2.text,numColonneX,err);
  val(YLabelBox2.text,numColonneY,err);
  if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series2.Title:=NomX+' - '+NomY;
  series2.ShowInLegend:=true;

  With Series2 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;

if nombredatas>2 then
  begin
  series3.ShowInLegend:=true;
  val(XLabelBox3.text,numColonneX,err);
  val(YLabelBox3.text,numColonneY,err);
  if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series3.Title:=NomX+' - '+NomY;
  With Series3 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;
if nombredatas>3 then
  begin
  series4.ShowInLegend:=true;
  val(XLabelBox4.text,numColonneX,err);
  val(YLabelBox4.text,numColonneY,err);
  if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series4.Title:=NomX+' - '+NomY;

  With Series4 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;
if nombredatas>4 then
  begin
  val(XLabelBox5.text,numColonneX,err);
  val(YLabelBox5.text,numColonneY,err);
    if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series5.Title:=NomX+' - '+NomY;

  series5.ShowInLegend:=true;
  With Series5 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;
if nombredatas>5 then
  begin
  val(XLabelBox6.text,numColonneX,err);
  val(YLabelBox6.text,numColonneY,err);
    if labelGraphArray[numColonneX]<>'' then NomX:=labelGraphArray[numColonneX]
     else NomX:='Col '+inttostr(numColonneX);
  if labelGraphArray[numColonneY]<>'' then NomY:=labelGraphArray[numColonneY]
     else NomY:='Col '+inttostr(numColonneY);
  series6.Title:=NomX+' - '+NomY;

  series6.ShowInLegend:=true;
  With Series6 do
    Begin
      if (NumColonneX<10) and (numColonneY<10) then
      begin
        OldnumColonneX:=numColonneX;OldnumColonneY:=numcolonneY;
        for j:=1 to LastLineArray do
        begin
           AddXY(GraphArray[j][numColonneX],GraphArray[j][numColonneY],'',clTeeColor);
        end;
      end;
    end;
  end;

end;


procedure TGraphAlloulForm.FormDblClick(Sender: TObject);
var err:integer;numeroX,numeroY:extended;
begin
  if lastlineArray>0 then begin rafraichitGraphe;rafraichitGrille;end;

end;



procedure TGraphAlloulForm.RafraichitGrille;
var i,j,nbLignesMax:integer;
begin
nbLignesMax:=50;
for i:=1 to 10 do TableauGrille.Cells[i,0]:=LabelGraphArray[i];
{attention, Grille(colonne,ligne) et Tableau(ligne,colonne)}
if LastLineArray>0 then
   begin
      if LastLineArray<nbLignesMax then nbLignesMax:=LastLineArray;
      for i:=1 to nbLignesMax do TableauGrille.Cells[0,i]:=inttostr(i);
      for i:=1 to nbLignesMax do
           for j:=1 to 10 do
               TableauGrille.Cells[j,i]:=floattostr(GraphArray[i][j]);
   end
   else
   begin
      for i:=1 to 50 do
           for j:=1 to 10 do
               TableauGrille.Cells[j,i]:='';
   end
end;

procedure TGraphAlloulForm.rafraichitGraphe;
var err:integer;numeroX,numeroY:extended;
begin

  if lastlineArray>0 then
     begin
     DrawArray;
     end;

end;



procedure TGraphAlloulForm.FormCreate(Sender: TObject);
var numeroX,numeroY:extended;err:integer;
begin
   xmin:=0;xmax:=1;ymin:=0;ymax:=1;
   xmin2:=0;xmax2:=1;ymin2:=0;ymax2:=1;
   XlabelBox1.Text:='1';YLabelBox1.text:='2';
   NombreDatas:=1;
   rafraichitgraphe;
   RafraichitGrille;
end;

procedure TGraphAlloulForm.FormActivate(Sender: TObject);
var numeroX,numeroY:extended;err:integer;
begin
     DrawArray;
     RafraichitGrille;

end;

procedure TGraphAlloulForm.LogScaleButtonYClick(Sender: TObject);
begin

    if (logscalebuttonY.Caption='log Y') then
                             begin
                             logscalebuttonY.Caption:='linear Y';
                             ChartXY.LeftAxis.Automatic:=true;
                             ChartXY.LeftAxis.Logarithmic:=false;
                             ChartXY.LeftAxis.TickOnLabelsOnly:=false;
                             end
                             else
                             begin
                             logscalebuttonY.Caption:='log Y';
                             ChartXY.LeftAxis.Automatic:=true;
                             ChartXY.LeftAxis.Logarithmic:=true;
                             ChartXY.LeftAxis.TickOnLabelsOnly:=true;
                             end;


end;

procedure TGraphAlloulForm.LogScaleButtonXClick(Sender: TObject);
begin

    if (logscalebuttonX.Caption='log X') then
                           begin
                             logscalebuttonX.Caption:='linear X';
                             ChartXY.BottomAxis.Logarithmic:=false;
                             ChartXY.BottomAxis.TickOnLabelsOnly:=false;
                             ChartXY.BottomAxis.Automatic:=true;
                             end
                             else
                             begin
                             logscalebuttonX.Caption:='log X';
                             ChartXY.BottomAxis.Logarithmic:=true;
                             ChartXY.BottomAxis.TickOnLabelsOnly:=true;
                             ChartXY.BottomAxis.Automatic:=true;
                         end;


end;

procedure TGraphAlloulForm.ChartXYMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var tmpX,tmpY:Double;
begin
  if (OldX<>-1) then
  begin

    OldX:=-1;
  end;

  { check if mouse is inside Chart rectangle }
  if PtInRect( ChartXY.ChartRect, Point(X-ChartXY.Width3D,Y+ChartXY.Height3D)  ) then
  begin

    { store old position }
    OldX:=x;
    OldY:=y;
    { set label text }
    With Series1 do
    begin
      GetCursorValues(tmpX,tmpY);  { <-- get values under mouse cursor }
     Xcursor.caption:='X = '+GetHorizAxis.LabelValue(tmpX);
     Ycursor.caption:='Y = '+GetVertAxis.LabelValue(tmpX);
    end;
  end;

end;

procedure TGraphAlloulForm.AddDataToGraphClick(Sender: TObject);
begin
    if nombreDatas<6 then
       begin
       nombreDatas:=nombreDatas+1;
       if nombreDatas=2 then begin XlabelBox2.visible:=true;YlabelBox2.visible:=true;end;
       if nombreDatas=3 then begin XlabelBox3.visible:=true;YlabelBox3.visible:=true;end;
       if nombreDatas=4 then begin XlabelBox4.visible:=true;YlabelBox4.visible:=true;end;
       if nombreDatas=5 then begin XlabelBox5.visible:=true;YlabelBox5.visible:=true;end;
       if nombreDatas=6 then begin XlabelBox6.visible:=true;YlabelBox6.visible:=true;end;
       rafraichitgraphe;
            DrawArray;
       end;
end;

procedure TGraphAlloulForm.REmoveDataFromGraphClick(Sender: TObject);
begin
    if nombreDatas>1 then
       begin
       if nombreDatas=2 then begin XlabelBox2.visible:=false;YlabelBox2.visible:=false;end;
       if nombreDatas=3 then begin XlabelBox3.visible:=false;YlabelBox3.visible:=false;end;
       if nombreDatas=4 then begin XlabelBox4.visible:=false;YlabelBox4.visible:=false;end;
       if nombreDatas=5 then begin XlabelBox5.visible:=false;YlabelBox5.visible:=false;end;
       if nombreDatas=6 then begin XlabelBox6.visible:=false;YlabelBox6.visible:=false;end;
       nombreDatas:=nombreDatas-1;
       rafraichitgraphe;
       end;
end;

procedure TGraphAlloulForm.LineAndSymbolsCheckClick(Sender: TObject);
begin
     rafraichitGraphe;
end;



procedure TGraphAlloulForm.BitBtn1Click(Sender: TObject);
begin
  ChartXY.ZoomPercent(120);
end;

procedure TGraphAlloulForm.BitBtn2Click(Sender: TObject);
begin
  ChartXY.ZoomPercent(50);
end;

procedure TGraphAlloulForm.Button3Click(Sender: TObject);
begin
  ChartXY.UndoZoom;
end;

procedure TGraphAlloulForm.SpeedButton1Click(Sender: TObject);
var Amount:Double;
begin
  With Chartxy.TopAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/20));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
  With Chartxy.BottomAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/20));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
end;

procedure TGraphAlloulForm.SpeedButton2Click(Sender: TObject);
var Amount:Double;
begin
  With Chartxy.LeftAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(-20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
  With Chartxy.RightAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(-20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;

end;

procedure TGraphAlloulForm.SpeedButton3Click(Sender: TObject);
var Amount:Double;
begin
  With Chartxy.LeftAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
  With Chartxy.RightAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
end;

procedure TGraphAlloulForm.SpeedButton4Click(Sender: TObject);
var Amount:Double;
begin
  With Chartxy.TopAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(-20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
  With Chartxy.BottomAxis do
  begin
    Amount:=-((Maximum-Minimum)/(100.0/(-20)));
    SetMinMax(Minimum-Amount,Maximum-Amount);
  end;
end;

procedure TGraphAlloulForm.YLabelBox2Change(Sender: TObject);
begin
    rafraichitgraphe;
end;

procedure TGraphAlloulForm.PrintButtonClick(Sender: TObject);
begin
  if printdialog1.Execute then ChartXY.Print;
end;

procedure TGraphAlloulForm.ChartXYDblClick(Sender: TObject);
begin
  if lastlineArray>0 then begin rafraichitGraphe;rafraichitGrille;end;
end;

end.



