unit RMNacquisition;
{unit de prise du signal RMN et de son traitement pour combinaison avec le programme de pilotage PAPOL
fonctions hauts niveaux dans la gestion des cartes AT
traitement du signal et calcul de la polarisation
E.Leymarie 10/00
MODIFICATIONS :
17/11/00 : (edouard)
         Ajout d'une procdure RMNacqui.mesurepolar(n:integer;var polar,temps:real) pour liaison avec la fonction RMNlitpolar de l'interpreteur.
         Cration de la fonction RMNacqui.TestAcquis:boolean; pour tester la fin de l'acquisition RMN.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls,editdata,AT_AOMIO,GPIB_CEC,PilotageManipMainForm;
type
    brut512=array[1..512] of longint;
const
    wm_redessine=$403+wm_user;

type
  TRMNacqui = class(TForm)
    GroupBox4: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label15: TLabel;
    Label18: TLabel;
    fichierexistant: TLabel;
    run: TButton;
    moy: TSpinEdit;
    npassage: TSpinEdit;
    interval: TSpinEdit;
    choixspectresig: TComboBox;
    index: TSpinEdit;
    Mode: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    choixspectrebase: TComboBox;
    Label4: TLabel;
    repet: TSpinEdit;
    Label5: TLabel;
    Nbrspectres: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    duree: TEdit;
    base: TCheckBox;
    GroupBox1: TGroupBox;
    onsynthe: TButton;
    offsynthe: TButton;
    scansynthe: TButton;
    saturation: TButton;
    tsat: TEdit;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    Timeracqui: TTimer;
    Label9: TLabel;
    sigpol: TComboBox;
    basepol: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    spectrepol: TComboBox;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    freqg: TEdit;
    freqd: TEdit;
    calculpol: TButton;
    pol: TEdit;
    Label14: TLabel;
    stop: TButton;
    GroupBox5: TGroupBox;
    Label20: TLabel;
    transbase: TCheckBox;
    transini: TEdit;
    iteration: TSpinEdit;
    calpol: TCheckBox;
    affichespe: TCheckBox;
    Label21: TLabel;
    freqmod: TEdit;
    Label22: TLabel;

    procedure choixspectredropdown(Sender: TObject);
    procedure ModeChange(Sender: TObject);
    procedure calculfiche(Sender: TObject);

    procedure initacquisition(freq,amp,niv:real);
    procedure acqui_brut(moyennage:integer;var result:brut512;var t:real);
    procedure acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);

    function  initundRMN(nom:string;freq,amp:real):integer;
    procedure bruttospectre1D(result:brut512;ind:integer);

    procedure  simple(npass,nvisu,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
    procedure acquitemps(sender:Tobject);

    procedure formate(indsig,indbase,indresult:integer;trans:real);
    function calcul_aire(ind:integer;freqgauche,freqdroite:real):real;
    procedure errortrans(indsig,indbase:integer;freqgauche,freqdroite:real;trans:real;var valg,vald:real);
    procedure traitespectre(nomsig,nombase,nomresult:string; var polar:real);

    procedure scansyntheClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure onsyntheClick(Sender: TObject);
    procedure offsyntheClick(Sender: TObject);
    procedure saturationClick(Sender: TObject);
    procedure runClick(Sender: TObject);
    procedure calculpolClick(Sender: TObject);
    procedure mesurepolar(n:integer;var polar,temps:real);
    Function  TestAcquis:boolean;

  private
    { Dclarations prives}
    resultbrut:brut512; {stocke les data brutes}
    stopflag,acquisitionRunning:boolean;
    freqencours,ampencours:real; {donne les valeurs en cours}
    compteur:integer; {donne le nbre de spectres acquis en mode f(t)}
  public
    { Dclarations publiques}
  end;

const
     dbytemin=-4730; {determine la valeur min de l'escalier de commande du synth
                     ici -1.5V}
     inc=37;{determine la hauteur des marches de tension}

var
  RMNacqui: TRMNacqui;

implementation

uses RMNbases, Graph1D, visu_polarisation;

{$R *.DFM}
{*******************************************
procedures gnrales}
{*************************
}
procedure TRMNacqui.choixspectredropdown(Sender: TObject);
var i:integer;
begin
{reinitialisation des items des choixspectres a chaque ouverture du combo}
choixspectresig.items.clear;
choixspectrebase.items.clear;
sigpol.items.clear;
basepol.items.clear;
spectrepol.items.clear;

for i:=1 to totalspectre do
if und.spect[i]<>nil then
   begin
   choixspectresig.items.add(und.spect[i].nom);
   choixspectrebase.items.add(und.spect[i].nom);
   sigpol.items.add(und.spect[i].nom);
   basepol.items.add(und.spect[i].nom);
   spectrepol.items.add(und.spect[i].nom);
   end;
end;
{*************************
}
procedure TRMNacqui.ModeChange(Sender: TObject);
begin
if mode.text='Simple' then
   begin
   label4.visible:=false;
   repet.visible:=false;
   label6.visible:=false;
   nbrspectres.visible:=false;
   end
else
   begin
   label4.visible:=true;
   repet.visible:=true;
   label6.visible:=true;
   nbrspectres.visible:=true;
   end;
end;
{********************************************
calcul le temps necessaire  la mesure et la frequence du signal de balayage}
procedure TRMNacqui.calculfiche(Sender: TObject);
var T:real;
begin
t:=6.33*moy.value+1.2;
duree.text:=floattostr(npassage.value*t/1000);
freqmod.text:=floattostr(1000/t);
end;
{********************************************
*        procedures acquisition bas niveau
**********************************************}
{*********************************
initialise les cartes d'acquisitions et le synthe pour une acquisition}
procedure TRMNacqui.initacquisition(freq,amp,niv:real);
begin
stopflag:=false;
RMNbase.initchaine;
RMNbase.initsynthe(freq,amp,niv);
{RMNbase.syntheon;}
RMNbase.synthe_acquisition;
freqencours:=freq;
ampencours:=amp;
end;
{**************************
 ralise un passage avec le moyennage spcifi et donne le temps de
fin de comptage
INPUT moyennage: nombre d'acquisition par pas de frequence
OUPUT result: tableau 512*integer= donnes brutes
      t:temps en s }
procedure tRMNacqui.acqui_brut(moyennage:integer;
          var result:brut512;var t:real);

var  j:integer;
     dbyte:smallint;
     resultat:word;

begin

dbyte:=dbytemin;

for j:=1 to 256 do
         begin
           setdac1(dbyte);
           lecture(moyennage,resultat);
           dbyte:=dbyte+inc;
           result[j]:=resultat;
         end;

for j:=257 to 512 do
         begin
           dbyte:=dbyte-inc;
           setdac1(dbyte);
           lecture(moyennage,resultat);
           result[j]:=resultat;
         end;

t:=(time-int(time))*86400;  {temps en s}
end;
{***********************************************
realise un ensemble de npass passages avec au besoin la prise du spectre de base,
fait la conversion en mv et charge les spectres und
INPUT npass: nombre de passage a realiser
      moyennage : nombre d'acquisition par pas de frequence
      indsig,indbase : index des spectres recepteurs
      base : true si acquisition du signal de base}
procedure tRMNacqui.acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);
var  i:integer;
begin

{prise du signal}
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indsig].data[0,0].mon:=und.spect[indsig].data[0,0].mon+1;
      bruttospectre1D(resultbrut,indsig);
      i:=i+1;
      end;

{au besoin:prise du signal de base dans les meme conditions}
if base then
begin
RMNbase.sweepB('base');
{prise du signal de base}
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indbase].data[0,0].mon:=und.spect[indbase].data[0,0].mon+1;
      bruttospectre1D(resultbrut,indbase);
      i:=i+1;
      end;
RMNbase.sweepB('acquisition');
end;

end;
{********************************************
*        procedures acquisition haut niveau
**********************************************}
{************************************
acquisition simple = serie de  acqui_spectre  avec visualisation intermediaire
INPUT npass:nombre total de passage pour le spectre
      nvisu: nombre de passage entre chaque rafraichissement de la visu
      moyennage: moyennage de l'acquisition
      nomsig,nombase: nom des spectres recepteurs
      base: true si on veut faire l'acquisition du signal de base dans les meme conditions
OUTPUT temps: donne le temps de fin
       polar : donne la polar }
procedure  tRMNacqui.simple(npass,nvisu,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
var i,indsig,indbase:integer;

begin

{initialisation des spectres}
indsig:=initundRMN(nomsig,freqencours,ampencours);
if base then
   indbase:=initundRMN(nombase,freqencours,ampencours);

i:=1;
while (i<npass) and (stopflag=false) do
      begin
      acqui_spectre(nvisu,moyennage,indsig,indbase,base,temps);
      {traitement}
      if calpol.checked then
      traitespectre(nomsig,nombase,spectrepol.text,polar);
      {affichage}
      if affichespe.checked then
      {graph1d.redessiner;}
      sendmessage(principalform.handle,wm_redessine,0,0);

      i:=round(und.spect[indsig].data[0,0].mon);
      end;

{enregistrement}

end;
{************************************
acquisition f(t)
lance des simples rythms par le timer. l'ensemble des choix sont rinitialis  chaque fois}
procedure tRMNacqui.acquitemps(sender:Tobject);
var npass,nvisu,moyennage:integer;
    nomsig,nombase:string;
    temps,polar:real;
    
begin
timeracqui.enabled:=false;
timeracqui.interval:=repet.value;

compteur:=compteur+1;
npass:=npassage.value;
nvisu:=interval.value;
moyennage:=moy.value;
nomsig:=choixspectresig.text;
nombase:=choixspectrebase.text;

simple(npass,nvisu,moyennage,nomsig,nombase,base.checked,temps,polar);

if calpol.checked then
   visupol.ajoute(temps,polar);

{gestion fin d'acquisition}
if compteur<Nbrspectres.value then
   timeracqui.enabled:=true
else
   timeracqui.enabled:=false;

end;
{*************************************
stop tous les process}
procedure TRMNacqui.stopClick(Sender: TObject);
begin
stopflag:=true;
timeracqui.enabled:=false;
end;
{*****************************
*  partie transformation de rsultat
*
{*************************}
{*************************
verifie l'existance d'un spectre 1 D et l'initialise  pour une acquisition RMN
entre les frquences en fonction de freq et amp
INPUT nom:nom du spectre und
      freq:frequence centrale en MHz
      amp:amplitude de modulation en kHz}

function  tRMNacqui.initundRMN(nom:string;freq,amp:real):integer;
var ind,i:integer;
    deltaf:real;
begin
ind:=und.indexof(nom);
deltaf:=amp*1.02/1000; {conversion en MHz et correction de l'amplitude reel de balayage 2%}
{creation au besoin}
if ind=-1 then
   begin
   ind:=und.addspectre(nom,256,1);
   und.spect[ind].typex:='freq';
   und.spect[ind].typey:='single';
   end;
{initialisation}
und.spect[ind].clear;
und.spect[ind].data[0,0].mon:=0;    {designe le nbre de passages}
for i:=0 to 255 do
    und.spect[ind].data[i,0].x:=(freq-deltaf)+2*deltaf*i/255;
initundRMN:=ind;
end;
{********************************
effectue la conversion en mV, la superposition des parties montante et descendante,
et l'accumulation d'un signal brute dans un
spectre 1 D en fonction du nombre .mon de signal brute deja acquis}

procedure tRMNacqui.bruttospectre1D(result:brut512;ind:integer);

var i:integer;
    tampon,n:real;

begin
n:=und.spect[ind].data[0,0].mon; {nombre de spectres deja acquis}
for i:=0 to 255 do
    begin
    tampon:=(result[i+1]/(6.5536*RMNbase.gain)+result[512-i]/(6.5536*RMNbase.gain))/2; {conversion en mV et superposition}
    und.spect[ind].data[i,0].z:=(und.spect[ind].data[i,0].z*(n-1)+tampon)/n; {accumulation}
    end;
end;

{**************************

initialise les frequences de nomresult comme nomsig
ralise la soustraction du signal de base translat de trans (avec en gnral -1<trans<1)}
procedure tRMNacqui.formate(indsig,indbase,indresult:integer;trans:real);

var i:integer;
    tamp:real;

begin

{initialisation abscisse}
for i:=0 to 255 do
    und.spect[indresult].data[i,0].x:=und.spect[indsig].data[i,0].x;

{soustraction avec translation}
if trans<=0 then
   begin
   und.spect[indresult].data[0,0].z:=und.spect[indsig].data[0,0].z-und.spect[indbase].data[0,0].z;
   for i:=1 to 255 do
       begin
       tamp:=und.spect[indbase].data[i,0].z*(1+trans)-und.spect[indbase].data[i-1,0].z*trans;
       und.spect[indresult].data[i,0].z:=und.spect[indsig].data[i,0].z-tamp;
       end;
   end
else
   und.spect[indresult].data[0,0].z:=und.spect[indsig].data[255,0].z-und.spect[indbase].data[255,0].z;
   for i:=0 to 254 do
       begin
       tamp:=und.spect[indbase].data[i,0].z*(1-trans)+und.spect[indbase].data[i+1,0].z*trans;
       und.spect[indresult].data[i,0].z:=und.spect[indsig].data[i,0].z-tamp;
       end;



end;
{***********************
calcul l'aire d'un spectre en fonction des bornes choisies}
function tRMNacqui.calcul_aire(ind:integer;freqgauche,freqdroite:real):real;

var i,n:integer;
    tampon,resultat,ldb:real;


begin

tampon:=0;n:=0;
resultat:=0;

{calcul de la moyenne de la base  gauche et a droite du spectre}

for i:=0 to 255 do
    if (und.spect[ind].data[i,0].x<freqgauche) or (und.spect[ind].data[i,0].x>freqdroite) then
       begin
       tampon:=tampon+und.spect[ind].data[i,0].z;
       n:=n+1;
       end;

ldb:=tampon/n;

{calcul par les trapezes de l'air entre le signal et la moyenne calcule}

for i:=0 to 255 do
    if (und.spect[ind].data[i,0].x>freqgauche) and (und.spect[ind].data[i,0].x<freqdroite) then
       resultat:=resultat+(2*ldb-und.spect[ind].data[i,0].z-und.spect[ind].data[i+1,0].z)/2;

calcul_aire:=-resultat;

end;
{**********************************************
donne la moyenne des parties gauche et droite de la soustraction signal moins base
en fonction de la translation de la base}
procedure TRMNacqui.errortrans(indsig,indbase:integer;freqgauche,freqdroite:real;trans:real;var valg,vald:real);
var i,ng,nd:integer;

begin
valg:=und.spect[indsig].data[0,0].z-und.spect[indbase].data[0,0].z;
vald:=und.spect[indsig].data[255,0].z-und.spect[indbase].data[255,0].z;

ng:=1;nd:=1;
for i:=1 to 254 do
    begin
    if und.spect[indsig].data[i,0].x<freqgauche  then
       begin
       ng:=ng+1;
       if trans<= 0 then
          valg:=valg+und.spect[indsig].data[i,0].z-(und.spect[indbase].data[i,0].z*(1+trans)-und.spect[indbase].data[i-1,0].z*trans)
       else
          valg:=valg+und.spect[indsig].data[i,0].z-(und.spect[indbase].data[i,0].z*(1-trans)+und.spect[indbase].data[i+1,0].z*trans);
       end;

    if und.spect[indsig].data[i,0].x>freqdroite  then
       begin
       nd:=nd+1;
       if trans<= 0 then
          vald:=vald+und.spect[indsig].data[i,0].z-(und.spect[indbase].data[i,0].z*(1+trans)-und.spect[indbase].data[i-1,0].z*trans)
       else
          vald:=vald+und.spect[indsig].data[i,0].z-(und.spect[indbase].data[i,0].z*(1-trans)+und.spect[indbase].data[i+1,0].z*trans);
       end;
    end;
valg:=valg/ng;
vald:=vald/nd;
end;
{**********************************************
traite le signal: fournit le spectre et calcul la polar.
si l'option translation base et choisie la procedure cherche par dichotomie la translation
minimisant l'ecart entre la partie gauche et droite du spectre}
procedure tRMNacqui.traitespectre(nomsig,nombase,nomresult:string; var polar:real);
var decalg,decald,valg,vald,errg,errd,decalm,errm:real;
    freqgauche,freqdroite:real;
    i,indresult,indsig,indbase:integer;


begin
indsig:=und.indexof(nomsig);
indbase:=und.indexof(nombase);
indresult:=und.indexof(nomresult);

{creation au besoin}
if indresult=-1 then
   begin
   indresult:=und.addspectre(nomresult,256,1);
   und.spect[indresult].typex:='freq';
   und.spect[indresult].typey:='single';
   end;

freqgauche:=strtofloat(freqg.text);
freqdroite:=strtofloat(freqd.text);

if transbase.checked then
begin
{recherche par dichotomie de la meilleure translation}
decald:=strtofloat(transini.text);
decalg:=-decald;

errortrans(indsig,indbase,freqgauche,freqdroite,decalg,valg,vald);
errg:=valg-vald;
errortrans(indsig,indbase,freqgauche,freqdroite,decald,valg,vald);
errd:=valg-vald;

for i:=1 to iteration.value do
    begin
    decalm:=(decalg+decald)/2;
    errortrans(indsig,indbase,freqgauche,freqdroite,decalm,valg,vald);
    errm:=valg-vald;
    if errg*errm<0 then
       begin
       decald:=decalm;
       errd:=errm;
       end;
    if errd*errm<0 then
        begin
        decalg:=decalm;
        errg:=errm;
        end;
    end;
{soustraction signal moins base avec trans<>0}
formate(indsig,indbase,indresult,(decalg+decald)/2);
end
else
{soustraction signal moins base avec trans=0}
formate(indsig,indbase,indresult,0);

polar:=calcul_aire(indresult,freqgauche,freqdroite);

end;
{***************************
*     commande synthe}
{**************************************
realise un scan en frquence pour rglage}
procedure TRMNacqui.scansyntheClick(Sender: TObject);
var freq,amp,niv,temps:real;
    moyennage:integer;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);
moyennage:=moy.value;


initacquisition(freq,amp,niv);

while not(stopflag) do
    begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
    end;

end;
{***************************
}
procedure TRMNacqui.onsyntheClick(Sender: TObject);
var freq,amp,niv:real;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);

initacquisition(freq,amp,niv);

RMNbase.syntheon;
end;
{***************************
}
procedure TRMNacqui.offsyntheClick(Sender: TObject);
begin
RMNbase.syntheoff;
end;
{***************************
}
procedure TRMNacqui.saturationClick(Sender: TObject);
begin
RMNbase.synthe_sature(strtofloat(tsat.text));
end;
{***************************
                RUN}
procedure TRMNacqui.runClick(Sender: TObject);
var freq,amp,niv,temps,polar:real;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);
initacquisition(freq,amp,niv);

if mode.text='Simple' then
   begin
   simple(npassage.value,interval.value,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
   pol.text:=floattostr(polar);
   end;
if mode.text='f(t)' then
   begin
   compteur:=0;
   if calpol.checked then
      visupol.clearvisu;
   timeracqui.interval:=50;
   timeracqui.enabled:=true;
   end;
end;
{***************************
traite le signal et calcul la polar}
procedure TRMNacqui.calculpolClick(Sender: TObject);
var polar:real;
begin
traitespectre(sigpol.text,basepol.text,spectrepol.text,polar);
pol.text:=floattostr(polar);
end;

{***************************
petite procedure calculant la polar en fonction des choix de la fiche
l'initialisation de l'acquisition doit etre faite au prealable}
procedure TRMNacqui.mesurepolar(n:integer;var polar,temps:real);

begin
acquisitionRunning:=true;
stopflag:=false;
simple(n,n,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
pol.text:=floattostr(polar);
acquisitionRunning:=false;

end;
{ function qui renvoi true si une acquisition est en route }
{ et false sinon                                           }
Function TRMNacqui.TestAcquis:boolean;
begin
     result:=acquisitionRunning;
end;
end.
