unit Seq16Channels;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, Buttons,ExtCtrls, xyGraph,  ComCtrls, Spin,  ToolWin,
  math, EditReal,editdata,DrapeauAlloulUnit, Comrs232,pulsedialogue;


const
  ntemps=20;
  nampli=10;
  nphase=10;

type
  TSeq16ChannelsForm = class(TForm)
    listseqpar: TStringGrid;
    EditSeq: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Stop: TBitBtn;
    Start: TButton;
    Status: TLabel;
    ModeAcquisition2pulses: TCheckBox;
    SansRafraichissement: TCheckBox;
    ModeAcquisitionStandard: TCheckBox;
    NomSequenceRMN: TLabel;
    openbutton: TButton;
    saveButton: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    PositionMarkerBox: TEdit;
    MarkerLengthBox: TEdit;
    CommPortDriverPulse1: TCommPortDriver;
    GAGErecognitionBox: TCheckBox;
    Label1: TLabel;
    Button4: TButton;
    Timer1: TTimer;
    sauverSimple: TButton;
    TableauSignesReception: TStringGrid;
    ModeAcquisition4pulses: TCheckBox;
    Memo1: TMemo;
    editseqnoncompiled: TMemo;
    Sequences: TComboBox;
    Label2: TLabel;
    procedure ouverture;
    procedure initialisation;
    procedure Sauver1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure StartSequenceur;
    procedure Close(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ModeAcquisition2pulsesClick(Sender: TObject);
    procedure SansRafraichissementClick(Sender: TObject);
    procedure ModeAcquisitionStandardClick(Sender: TObject);
    procedure OpenSerialPort;
    procedure CloseSerialPort;
    procedure StartClick(Sender: TObject);
    procedure LitBuffer0123(var Caractere:char);

    procedure ButtonPulseRecep2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure GAGErecognitionBoxClick(Sender: TObject);
    procedure chargefichier(filename:string);
    procedure Button4Click(Sender: TObject);
    procedure sauverSimpleClick(Sender: TObject);
    procedure EraseTableauSignesReception;
    procedure TransfertSignesREceptionDansTableau;
    procedure ModeAcquisition4pulsesClick(Sender: TObject);
    procedure SequencesChange(Sender: TObject);
    procedure InitialiseSequence;

   procedure piSur2Simple;
   procedure piSur2PiSimple;
   procedure piSur2Pi2StepsOldPhase;
   procedure piSur2Pi2StepsNewPhase;
   procedure piSur2Pi4StepsNewPhase;
   procedure piSur2Pi16StepsNewPhase;
    {procedure ecriture(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure autorisation(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);}


  private
      FTempInBuffer2              : pointer;

    { Dclarations prives}
  public
    procedure ChangeParametreSequence(nomParam:string;Valeur:real);

    { Dclarations publiques}
end;

var
  Seq16ChannelsForm: TSeq16ChannelsForm;
  TempsTotalUneSequence:extended; {temps total en nanosecondes pour une sequence}
implementation

{$R *.DFM}

procedure TSeq16ChannelsForm.ouverture;
var result:boolean;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
Seq16ChannelsForm.WindowState:=WsMinimized;
Seq16ChannelsForm.WindowState:=WsNormal;

end;

procedure TSeq16ChannelsForm.initialisation;
var i:integer;
    s:string;
begin
      {initial directory for NMR pulse sequences}
      OpenDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\Sequenceur16Channels';
      SaveDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\Sequenceur16Channels';

      GAGErecognitionBox.visible:=true;

      DrapeauSequenceur16VoiesRecognitionStep:=false;
      listseqpar.Cells[0,0]:='Variable';
      listseqpar.Cells[1,0]:='Delay (msec)';
      listseqpar.ColCount:=2;

      editseq.left:=200;
      for i:=1 to ntemps do Seq16ChannelsForm.listseqpar.cells[0,i]:=chr(64+i);
      {on interdit la ligne de TF car instruction utilise pour la TF}
      Seq16ChannelsForm.listseqpar.cells[0,6]:='--';

      {initialisation de la connexion RS232 necessaire ensuite}
      CommPortDriverPulse1.ComPort:=pnCOM1; // Choose pnCOM1 or pnCOM2
      CommPortDriverPulse1.ComPortSpeed:= br57600; //9600 Bauds
      CommPortDriverPulse1.ComPortDataBits           := db8BITS; // 8 data bits
      CommPortDriverPulse1.ComPortStopBits           := sb1BITS; // 1 stop bit
      CommPortDriverPulse1.ComPortParity             := ptNONE;  // no parity
      CommPortDriverPulse1.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
      CommPortDriverPulse1.ComPortSwHandshaking      := shNONE;
      label3.visible:=false;label4.visible:=false;label5.visible:=false;
      MarkerLengthBox.visible:=false;PositionMarkerBox.visible:=false;
     {RESET DU SEQUENCEUR}
      Seq16ChannelsForm.openSerialPort;
      s:='ZR'+#13; {ordre de reset du sequenceur}
      CommPortDriverPulse1.SendData( pchar(s),length(s));
      Seq16ChannelsForm.closeSerialPort;
end;



procedure TSeq16ChannelsForm.ChangeParametreSequence(nomParam:string;Valeur:real);
    { mets Valeur dans la case de nomParam : appel
    depuis interpreteur}
var i,numColonne,numLigne:integer;

begin
   numLigne:=0;   numColonne:=0;
   {on repere la colonne}
   {on repere le numero de ligne correspondant a la lettre : A,B,C...}
   for i:=1 to 26 do if chr(64+i)=copy(nomParam,2,1) then numLigne:=i;
   {on change seulement si c'est bien crit}
   if numLigne<>0 then
   begin
     if copy(nomParam,1,1)='T' then listseqpar.Cells[1,numLigne]:=floattostr(valeur);
     if pos(',',listseqpar.Cells[1,numLigne])>0 then
          listseqpar.Cells[1,numLigne]:=copy(listseqpar.Cells[1,numLigne],1,
                  pos(',',listseqpar.Cells[1,numLigne])-1)
                  +'.'+
                  copy(listseqpar.Cells[1,numLigne],
                  pos(',',listseqpar.Cells[1,numLigne])+1,
                  length(listseqpar.Cells[1,numLigne])-pos(',',listseqpar.Cells[1,numLigne]));

{     affiche_parametre;}
   end;

   if (numLigne=0) then MessageDlg('Erreur in the command of type TA, PA...', mtWarning, [mbOk], 0);
  if (copy(nomParam,1,1)<>'T' ) and (copy(nomParam,1,1)<>'A' ) and (copy(nomParam,1,1)<>'P' )
      then MessageDlg('Erreur in the command of type TA', mtWarning, [mbOk], 0);
end;

procedure TSeq16ChannelsForm.Sauver1Click(Sender: TObject);
var nomFichier:string; filepara:string;
    fich2:textfile;i:integer;
begin
    If Savedialog1.execute then
    begin
      nomFichier:=SaveDialog1.Filename;
      if (copy(nomFichier,length(nomFichier)-3,4)<>'.seq') then nomFichier:=nomFichier+'.seq';
      Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
      sauverSimpleClick(Sender);
    end;
end;


procedure TSeq16ChannelsForm.Ouvrir1Click(Sender: TObject);
var filepara:string;
    fich2:textfile;
    i:integer;nomFichier:string;
       chaineTableau:array[0..100] of string;
begin
  if OpenDialog1.execute then
           ChargeFichier(Opendialog1.Filename);
end;

procedure TSeq16ChannelsForm.ChargeFichier(Filename:string);
var filepara:string;
    fich2:textfile;
    err,i:integer;nomFichier:string;
    chaine:string;nombre:extended;
    drapeau:boolean;
   chaineTableau:array[0..100] of string;
begin
    if FExis(Filename) then
       begin
           {verifie si bon format}
           nomFichier:=Filename;
           assignfile(fich2,nomfichier);
           reset(fich2);
           readln(fich2,chaine);
           if (chaine='NewHeteroSpectrometer') or
                 (chaine='OldHeteroSpectrometer') or
                 (chaine='Sequenceur16Channels') then
                 begin
                   if (chaine<>'Sequenceur16Channels') then drapeau:=false
                                                       else drapeau:=true;
                 end
                 else
                 begin
                 drapeau:=true;
                 closefile(fich2);
                 assignfile(fich2,nomfichier);
                 reset(fich2);
                 end;
           if drapeau=true then
           begin
           i:=0;
           nomFichier:=Filename;
           readln(fich2,chaine);
           i:=0;
           {lecture des delais}
                 repeat
                 i:=i+1;
                 readln(fich2,chaine);
                 val(chaine,nombre,err);
                 if (err=0) then Seq16ChannelsForm.listseqpar.cells[1,i]:=chaine;
                until (chaine='SEQUENCE') or (i>50);

            editseq.Clear;
            editseqnoncompiled.Clear;



           {lecture des instructions}
               while not eof(fich2) and (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') do
                 begin
                 readln(Fich2,chaine);
                 if (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') then editseqnoncompiled.lines.Add(chaine);
                 end;

           {lecture des aiguillages du mode d'acquisition}
           readln(fich2,chaine);{nombre d'aiguillages}
           nombre:=0;
           val(chaine,nombre,err);
           if nombre>0 then
              begin
              NombreStepsPourReception:=round(nombre);
              for i:=1 to round(Nombre) do
                       begin
                       readln(fich2,chaine);
                       readln(fich2,chaine);
                       TableauSignesReception.cells[1,i]:=chaine;
                       readln(fich2,chaine);
                       TableauSignesReception.cells[2,i]:=chaine;
                       end;
              end;
          readln(fich2,chaine);
          readln(fich2,chaine);
         if chaine='1 step' then ModeACquisitionStandard.State:=cbChecked ;
         if chaine='2 steps Old Dephaseur' then modeacquisition2pulses.state:=cbchecked;
         if chaine='multi steps New Dephaseur' then modeacquisition4pulses.state:=cbchecked;
        
          while not eof(fich2) do
                 begin
                 readln(fich2,chaine);
                 if pos('no refresh',chaine)>0 then
                                               begin
                                               SansRafraichissement.state:=cbChecked;
                                               DrapeauSansRafraichissement:=true;
                                               end;
                 end;

            closefile(fich2);

            Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
            {sauve le nom de la sequence dans Parametres RMN.txt}
            EcritDansParametresRMN('Last Pulse Sequence',nomFichier)
            end;

       end;
end;

procedure TSeq16ChannelsForm.StopClick(Sender: TObject);
var s:string;AttentePourFinSequence,starttime:integer;timeout:boolean;
begin
      {On s'arrete}
       Seq16ChannelsForm.openSerialPort;
       s:='C'+#13;
       CommPortDriverPulse1.SendData( pchar(s),length(s));
       AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
       startTime:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - startTime) > AttentePourFinSequence);
       UNTIL timeout;

       Seq16ChannelsForm.closeSerialPort;
       Status.caption:='Sequence stopped';
end;




procedure TSeq16ChannelsForm.Close(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caNone;
  Seq16ChannelsForm.WindowState:=wsMinimized;
{On ne ferme pas la fentre sequenceur pour viter de slectionner par erreur deux sequences
mais on la reduit. On peut la reafficher via le menu}
end;

procedure TSeq16ChannelsForm.FormCreate(Sender: TObject);
var nomFichier:string;chaineTableau:array[0..100] of string;fich2:textfile;
i:integer;
begin
      {TableauSigne : initialisation du tableau des signes de reception}
   TableauSignesReception.cells[1,0]:='0';
   TableauSignesReception.cells[2,0]:='90';
   TableauSignesReception.cells[0,0]:='step';
   for i:=1 to 16 do TableauSignesReception.cells[0,i]:=inttostr(i);
   TableauSignesReception.cells[1,1]:='+X';
   TableauSignesReception.cells[2,1]:='+Y';
   TransfertSignesREceptionDansTableau;

   DrapeauSeq16ChannelsLibre:=true;
   Initialisation;
  {relit la derniere sequence sauve dont le nom est dans Parametres RMN.txt}
   nomfichier:=LitDansParametresRMN('Last Pulse Sequence');
   if fexis(nomfichier) then
               begin
                chargefichier(nomFichier);
               end;

   Sequences.items.clear;

   Sequences.items.add('pi/2');
   Sequences.items.add('pi/2-pi simple');
   Sequences.items.add('pi/2-pi 2 steps Old Dephaseur homodyne');
   Sequences.items.add('pi/2-pi 2 steps New Dephaseur homodyne');
   Sequences.items.add('pi/2-pi 4 steps New Dephaseur homodyne');
      Sequences.items.add('pi/2-pi 16 steps New Dephaseur homodyne');
         Sequences.items.add('T1');
   Sequences.items.add('T1 2 steps Old homodyne');
   Sequences.items.add('T1 2 steps New homodyne');
   Sequences.items.add('T1 4 steps New homodyne');

end;

procedure TSeq16ChannelsForm.ModeAcquisition2pulsesClick(Sender: TObject);
begin
   if ModeAcquisition2pulses.State=cbChecked then
         begin
         if (drapeaumodeacquisition2pulses=false) then MessageDlg('Mode acquisition old dephasor : plug C1 to the rf pulse module 0, C2 to 180, C3 to blankin, C16 to gage trigger', mtWarning, [mbOk], 0);
         DrapeauModeAcquisition2pulses:=true;
         DrapeauModeAcquisition1pulse:=false;
         DrapeauModeAcquisition4pulses:=false;
         DrapeauSequenceur16VoiesRecognitionStep:=true;

         ModeAcquisitionStandard.State:=cbUnchecked;
         ModeAcquisition4pulses.state:=cbunchecked;

         GageRecognitionBox.state:=cbChecked;
         DrapeauModeAcquisition4pulses:=false;
         NombreStepsPourReception:=2;
         end
         else DrapeauModeAcquisition2pulses:=false;

end;


procedure TSeq16ChannelsForm.SansRafraichissementClick(Sender: TObject);
begin
   if SansRafraichissement.State=cbChecked then
         begin
         DrapeauSansRafraichissement:=true;
         end
   else DrapeauSansRafraichissement:=false;
end;

procedure TSeq16ChannelsForm.ModeAcquisitionStandardClick(Sender: TObject);
begin
  if ModeAcquisitionStandard.State=cbChecked then
         begin
         if (drapeaumodeacquisition1pulse=false) and (drapeaumodeacquisition2pulses=false) then MessageDlg('Mode acquisition standard : plug C1 to the rf pulse module, C3 to blankin, C16 to gage trigger', mtWarning, [mbOk], 0);
         DrapeauModeAcquisition2pulses:=false;
         DrapeauModeAcquisition1pulse:=true;
         DrapeauModeAcquisition4pulses:=false;
         DrapeauSequenceur16VoiesRecognitionStep:=false;

         ModeAcquisition4pulses.state:=cbunchecked;
         ModeAcquisition2pulses.State:=cbUnchecked;
         GageRecognitionBox.state:=cbUnChecked;


         NombreStepsPourReception:=1;
         EraseTableauSignesReception;
         TableauSignesReception.cells[1,1]:='+X';
         TableauSignesReception.cells[2,1]:='+Y';
         end
         else
         begin
         TableauSignesREception.Visible:=true;
         DrapeauSequenceurTimeCheck:=true;

         end;
end;

procedure TSeq16ChannelsForm.OpenSerialPort;
begin
  GetMem( FTempInBuffer2,10);
  CommPortDriverPulse1.connect;
  CommPortDriverPulse1.FlushBuffers(true,true);
end;

procedure TSeq16ChannelsForm.CloseSerialPort;
begin
  commportdriverPulse1.Disconnect;
  FreeMem( FTempInBuffer2,10);
end;

procedure TSeq16ChannelsForm.StartClick(Sender: TObject);
begin
{ne pas sauver le fichier  chaque fois qu'on relance, c'est
trs problematique car ca fait perdre du temps}
Seq16ChannelsForm.StartSequenceur;
end;

procedure TSeq16ChannelsForm.StartSequenceur;
{compilation et execution de la sequence si c'est le spectro sous RS232  16 voies
fait par J-P Cromieres en dec.2002}

type TMatrice = array[1..1000] of array[1..16] of boolean;
var TableauONOFF:TMatrice;
    Instructions:array[1..1000] of string;
    TableauDelay:array[1..1000] of extended;  {les differents temps}
    numero,AttentePourFinSequence,NumeroLettre,temps,err,err2,NbSteps,i,j,nb,nb2:integer;
    s,s2,s3,sTemps:string;
    DrapeauErreur,TimeOut,ChaineTraitee:boolean;
    Caractere:char;
    StartTime,TempsBis:extended;
    numero2:integer;chaine,chaine1,chaine2:string;
    temps1,temps2:extended;
    chainedepart,chaineinstruction,dureeS,phaseS:string;
    drapeauCalculerTempsRepetition:boolean;
    {1ere colonne : la duree en nanosecondes, puis les 16 colonnes qui suivent:
booleens qui disent si c'est ouvert (true) ou ferm (false)}

begin
TransfertSignesREceptionDansTableau;
{transfert et compilation de la sequence depuis editseqnoncompiled vers editseq}
j:=0;
editseq.Lines.Clear;
for i:=0 to (EditSeqNonCompiled.Lines.Count-1) do
   begin
    chainedepart:=EditSeqNonCompiled.Lines[i];
    if chainedepart<>'' then
    begin
    ChaineTraitee:=false;
    {transfo en majuscules, ajout point virgule}
    if (pos(';',chainedepart)=0) then chainedepart:=chainedepart+';';
    chainedepart:=AnsiUpperCase(chainedepart);
    chainedepart:=copy(chainedepart,1,pos(';',chainedepart));

    {instruction PULSE(duree,phase)
    si phase non specifiee, on met 0}
    phaseS:='';dureeS:='';
    if (pos('PULSE',chainedepart)>0) then
       begin
       ChaineTraitee:=true;
       chaine:=chainedepart;
       chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-8);
       if pos(',',chaine)>0 then
          begin
          dureeS:=copy(chaine,1,pos(',',chaine)-1);
          phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
          end
          else
          begin
          dureeS:=chaine;
          phaseS:='0';
          end;

       if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
       if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);

       if modeacquisitionstandard.state=cbChecked then
          begin
          chaineInstruction:='T0.003,C3; blanking';editseq.Lines.Add(ChaineInstruction);
          chaineInstruction:='T'+dureeS+',C1,C3; pulse rf 0';editseq.Lines.Add(ChaineInstruction);
          end
          else
          begin
          if modeacquisition2pulses.state=cbChecked then
            begin
            chaineInstruction:='T0.003,C3; blanking';editseq.Lines.Add(ChaineInstruction);
            if (phaseS<>'180') then chaineInstruction:='T'+dureeS+',C1,C3; pulse rf 0';
            if phaseS='180' then chaineInstruction:='T'+dureeS+',C2,C3; pulse rf 180';
            editseq.Lines.Add(ChaineInstruction);
            end
            else
            begin
               if modeacquisition4pulses.state=cbChecked then
               begin
               chaineInstruction:='T0.003,C3; blanking';editseq.Lines.Add(ChaineInstruction);
               if (phaseS='0') or (phaseS='') then chaineInstruction:='T'+dureeS+',C5,C3; pulse rf 0';
               if phaseS='90' then chaineInstruction:='T'+dureeS+',C5,C6,C3; pulse rf 90';
               if phaseS='180' then chaineInstruction:='T'+dureeS+',C5,C7,C3; pulse rf 180';
               if phaseS='270' then chaineInstruction:='T'+dureeS+',C5,C6,C7,C3; pulse rf 270';
               editseq.Lines.Add(ChaineInstruction);
               end;
            end;
          end;
       end;
      {instruction WAIT(duree);}
       if (chainetraitee=false) and (pos('WAIT',chainedepart)>0) then
            begin
            chainetraitee:=true;
            chaine:=chainedepart;
            chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-7);
            dureeS:=chaine;
            if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
            editseq.lines.Add('T'+dureeS+';');
            end;
      {instruction T0.005,C5,C3,TRIGACQ; alume differentes TTL pendant une duree T0.005 ou TA}
      {il faut juste transformer TRIGACQ en C16}
       if (pos('TRIGACQ',chainedepart)>0) then
            begin
            chaine:=copy(chainedepart,1,pos('TRIGACQ',chainedepart)-1);
            chaine:=chaine+'C16';
            chaine:=chaine+copy(chainedepart,pos('TRIGACQ',chainedepart)+7,length(chainedepart)-pos('TRIGACQ',chainedepart)+1);
            chainedepart:=chaine;
            end;
       if (chainetraitee=false) then  editseq.lines.Add(chainedepart);
     end;
   end;
   {fin du passage de editseqnoncompiled a editseq}


{on cree le tableau donnant les ON/OFF des 16 voies et les temps correspondants}
DrapeauErreur:=false;
{initialisation tableau}
NbSteps:=0;
for i:=1 to 1000 do
    begin
    TableauDelay[i]:=0;
    for j:=1 to 16 do
        begin
        TableauONOFF[i][j]:=false;
        end;
    end;

{on lit chaque instruction de EditSeq du type
T0.05,C1,C5,C7; (aprs le ; on ne regarde rien, c'est du commentaire)
(ici 0.05 est msec ainsi que TA,TB.. sont en msec)
ou
TA,C1,C5,C7; (ou TB, TC, TD...)}
DrapeauErreur:=false;
drapeauCalculerTempsRepetition:=false;
tempsrepetition:=0;
for i:=0 to (EditSeq.Lines.Count-1) do
    begin
    s:=EditSeq.Lines[i];
    {on vire les commentaires apres le ; mais on laisse le ;}
    if pos(';',s)>0 then s:=copy(s,1,pos(';',s));
    {traitement des instructions slt qd ligne commence par T}
    if copy(s,1,1)='T' then
       begin
       {si c'est un trigger, on repere pour evaluer TempsRepetition}
       if pos('C16',s)>0 then
          begin
          drapeauCalculerTempsRepetition:=true;
          if (tempsrepetition>0) then drapeauCalculerTempsRepetition:=false;
          end;

         NbSteps:=NbSteps+1;
         val(copy(s,2,1),tempsbis,err);
         {cas de T0.05}
         if err=0 then begin
                       if pos(',',s)>0 then  s2:=copy(s,2,pos(',',s)-2)
                                       else s2:=copy(s,2,pos(';',s)-2);
                       val(s2,tempsbis,err2);
                       if err2<>0 then DrapeauErreur:=true;
                       {on convertit la valeur de msec en nanosec}
                       if drapeaucalculerTempsRepetition=true then tempsrepetition:=tempsrepetition+tempsbis;
                       if err2=0 then TableauDelay[NbSteps]:=round(tempsbis*1e6);
                       end;

         {cas de TA,TB,TC...}
         if err<>0 then begin
                        s2:=copy(s,2,1);
                        if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                        if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                        if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                        if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                        if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                        if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                        if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                        if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                        val(listseqpar.Cells[1,nb],tempsBis,err2);
                       if drapeaucalculerTempsRepetition=true then tempsrepetition:=tempsrepetition+tempsbis;
                        if err2<>0 then DrapeauErreur:=true
                                   else TableauDelay[NbSteps]:=round(tempsBis*1e6);{on convertit la valeur des msec en nanosec}

                        end;
       end;
       {traitement des instructions de type C1,C2,C3... et C5;}
       for j:=1 to 16 do
             begin
             s2:='C'+inttostr(j)+',';
             if pos(s2,s)>0 then TableauONOFF[NbSteps][j]:=true;
             s2:='C'+inttostr(j)+';';
             if pos(s2,s)>0 then TableauONOFF[NbSteps][j]:=true;
             end;
    end;
    {fin boucle sur cq ligne d'instructions}

{conversion tableau-instructions pour sequenceur}
{syntaxe du sequenceur :}
{ 'A6E3R0B1' :  met la voie 1 ON pdt 6e3 nsec
  on met pour les voies 0 : tout est off
 et si on veut mettre plusieurs voies  ON, on les aditionne en puissance de 2.
 exple : voie 1 et 3 et 6 on : A6E3R0B  car 2^(1-1)+2^(3-1)+2^(6-1)=1+4+32=37}
  TempsTotalUneSequence:=0;
  for i:=1 to NbSteps do
      begin
      {on arrondit duree d au fait qu'on n'est pas meilleur en precision que 100nsec}
      TableauDelay[i]:=round(TableauDelay[i]/100)*100;
      {on convertit le temps : 1 sec = 1e9; 517.3 microsec= 5173e2}
      str(TableauDelay[i]:15:0,s);
      for j:=1 to 15 do if copy(s,1,1)=' ' then s:=copy(s,2,length(s)-1);
      nb:=0;
      for j:=1 to (length(s)-1) do
          if copy(s,length(s),1)='0' then begin nb:=nb+1;s:=copy(s,1,length(s)-1);end;
      {on decide quelles voies mettre  ON}
      nb2:=0;
      for j:=1 to 16 do
          begin
          if TableauONOFF[i][j]=true then nb2:=nb2+round(power(2,(j-1)));
          end;

      Instructions[i]:='A'+s+'E'+inttostr(nb)+'R0B'+inttostr(nb2)+#13;
      TempsTotalUneSequence:=TempsTotalUneSequence+TableauDelay[i];
      end;

  {envoi au RS232}
  if DrapeauErreur=false then
    begin {reset the previous sequence }
    Seq16ChannelsForm.openSerialPort;
    s:='ZR'+#13; {ordre de reset du sequenceur}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    Seq16ChannelsForm.closeSerialPort;

    {envoi des chaines}
    Seq16ChannelsForm.openSerialPort;
{    s:='C'+#13; stop sequence precedente
    CommPortDriverPulse1.SendData( pchar(s),length(s));}
    {avant de lancer l'ordre, il doit avoir finit la derniere etape de la
    sequence precedente donc on attend le temps de cette sequence + 50msec}
    {pas sur que je doive enlever la ligne suivante}
    {    AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
    startTime:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - startTime) > AttentePourFinSequence);
       UNTIL timeout;
 }   {lancement des differents ordres}
    for j:=1 to NbSteps do
        begin
        CommPortDriverPulse1.SendData( pchar(Instructions[j]),length(Instructions[j]));
        label1.caption:=instructions[j];
        end;
    {ordre de bouclage  la fin de la squence}
    s:='A1E1R1B0'+#13; {le temps n'est pas pris en compte, juste le R1}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    {start the sequence}
    s:='B'+#13;
    CommPortDriverPulse1.SendData( pchar(s),length(s));

    Seq16ChannelsForm.closeSerialPort;
    {Sauver ici la sequence !}

    end
    else
    MessageDlg('Error in the sequence writing - Not sent to the sequenceur', mtWarning, [mbOk], 0);

    if DrapeauErreur=true then MessageDlg('error in the writing of your sequence', mtWarning, [mbOk], 0);

end;


procedure TSeq16ChannelsForm.LitBuffer0123(var Caractere:char);
{va lire au buffer si caractere est '0' '1' '2' ou '3'}
var
u:integer;s1:char;
u1:double;s:string[1];
begin
  { lecture du caractere recu }
  u1:=time; { 0.00001 = 1 sec est le timeout }
  s:=' ';
  repeat
     u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then s:=strpas(Ftempinbuffer2);
until (u1+0.00001>time) or (s='0') or (s='1') or (s='2') or (s='3')
  or (s='4') or (s='5') or (s='6') or (s='7') or (s='8') or (s='9') or (s=':')
  or (s=';') or (s='<') or (s='=') or (s='>') or (s='?');
 Caractere:=s[1];
 CommPortDriverPulse1.FlushBuffers(true,true);
 {on vire ce qu'il y a dans le buffer
 pour la lecture suivante : essentiel si on laisse le port serie ouvert}

end;


procedure TSeq16ChannelsForm.ButtonPulseRecep2Click(Sender: TObject);
begin
{pi/2-pi}
Seq16ChannelsForm.NomSequenceRMN.caption:='pi/2 - pi Turning reception';

   editseqnoncompiled.Lines.Add('NOT POSSIBLE WITH THIS 16 CHANNELS SETUP');

end;

procedure TSeq16ChannelsForm.Button3Click(Sender: TObject);
begin
{pi/2-pi}
Seq16ChannelsForm.NomSequenceRMN.caption:='pi/2 - pi Recognition With RS232';
   editseqnoncompiled.Lines.Clear;
   editseqnoncompiled.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   editseqnoncompiled.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   editseqnoncompiled.Lines.Add('TA,C1,C3; pulse pi/2 on channel 1 during TA (blanking still open)');
   editseqnoncompiled.Lines.Add('TC; wait during TC');
   editseqnoncompiled.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   editseqnoncompiled.Lines.Add('TB,C1,C3; pulse pi on channel 1 during TB (blanking still open)');
   editseqnoncompiled.Lines.Add('TR; wait during TR, no pulse = repetition time');
   editseqnoncompiled.Lines.Add('T0.005,C16; trigger for GAGE card (chanel 16) of 5 microsec');
   editseqnoncompiled.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   editseqnoncompiled.Lines.Add('TA,C2,C3; pulse pi/2 on channel 2 (you have to inverse it with a gate)');
   editseqnoncompiled.Lines.Add('TC;');
   editseqnoncompiled.Lines.Add('T0.003,C3;');
   editseqnoncompiled.Lines.Add('TB,C1,C3; pulse pi on channel 1');
   editseqnoncompiled.Lines.Add('TR; reception will be substracted from previous one');
end;



procedure TSeq16ChannelsForm.GAGErecognitionBoxClick(Sender: TObject);
begin
if gagerecognitionbox.State=cbChecked then GageRecognition16channels:=true
                                      else GageRecognition16channels:=false;
end;

procedure TSeq16ChannelsForm.Button4Click(Sender: TObject);
var s:string;
begin
    Seq16ChannelsForm.openSerialPort;
    s:='ZR'+#13; {ordre de reset du sequenceur}
    CommPortDriverPulse1.SendData( pchar(s),length(s));
    Seq16ChannelsForm.closeSerialPort;
    {Sauver ici la sequence !}

end;

procedure TSeq16ChannelsForm.sauverSimpleClick(Sender: TObject);
var nomFichier:string; filepara:string;
    fich2:textfile;i:integer;
begin
    nomFichier:=nomsequencermn.Caption;
    if not(fexis(nomFichier)) then
       begin
       nomFichier:=SaveDialog1.Filename;
       if (copy(nomFichier,length(nomFichier)-3,4)<>'.seq') then nomFichier:=nomFichier+'.seq';
       end;

      TransfertSignesREceptionDansTableau;
      assignfile(fich2,nomfichier);
      rewrite(fich2);
      writeln(fich2,'Sequenceur16Channels');
      writeln(fich2,'DELAYS');
      for i:=1 to ntemps do
          begin
          if Seq16ChannelsForm.listseqpar.cells[1,i]='' then
          Seq16ChannelsForm.listseqpar.cells[1,i]:='0';
          writeln(fich2,Seq16ChannelsForm.listseqpar.cells[1,i]);
          end;
      writeln(fich2,'SEQUENCE');
      for i:=0 to editseqnoncompiled.Lines.Count-1 do
          writeln(fich2,editseqnoncompiled.lines[i]);

      writeln(fich2,'NUMBER OF STEPS FOR ACQUISITION :');
      writeln(fich2,inttostr(NombreStepsPourReception));
      if (NombreStepsPourReception>0) then
            begin
            for i:=1 to NombreStepsPourReception do
                       begin
                       writeln(fich2,'step '+inttostr(i));
                       writeln(fich2,TableauSignesReception.cells[1,i]);
                       writeln(fich2,TableauSignesReception.cells[2,i]);
                       end;
            end;

      writeln(fich2,'MODE ACQUISITION :');
      if ModeACquisitionStandard.State=cbChecked then writeln(fich2,'1 step')
         else
         begin
         if modeacquisition2pulses.state=cbchecked then
                                                   begin
                                                   writeln(fich2,'2 steps Old Dephaseur');
                                                   end
                                                   else
                                                   begin
                                                   if modeacquisition4pulses.state=cbchecked then writeln(fich2,'multi steps New Dephaseur')
                                                   else writeln(fich2,'unknown');
                                                   end;
         end;
    if SansRafraichissement.state=cbChecked then writeln(fich2,'no refreshing during acquisition');
    closefile(fich2);
    Seq16ChannelsForm.NomSequenceRMN.caption:=nomFichier;
    {sauve le nom de la sequence dans Parametres RMN.txt}
    EcritDansParametresRMN('Last Pulse Sequence',nomFichier)


end;

procedure TSeq16channelsForm.erasetableauSignesREception;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   TableauSignesReception.cells[1,i]:='';
   TableauSignesReception.cells[2,i]:='';
   end;
end;

procedure TSeq16channelsForm.TransfertSignesREceptionDansTableau;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   if (TableauSignesReception.cells[1,i]='+X') or (TableauSignesReception.cells[1,i]='X')
                                               then TableauSignesReceptionNMR[1][i]:=1;
   if (TableauSignesReception.cells[1,i]='+Y') or (TableauSignesReception.cells[1,i]='Y')
                                               then TableauSignesReceptionNMR[1][i]:=2;
   if (TableauSignesReception.cells[1,i]='-X') then TableauSignesReceptionNMR[1][i]:=3;
   if (TableauSignesReception.cells[1,i]='-Y') then TableauSignesReceptionNMR[1][i]:=4;

   if (TableauSignesReception.cells[2,i]='+X') or (TableauSignesReception.cells[2,i]='X')
                                               then TableauSignesReceptionNMR[2][i]:=1;
   if (TableauSignesReception.cells[2,i]='+Y') or (TableauSignesReception.cells[2,i]='Y')
                                               then TableauSignesReceptionNMR[2][i]:=2;
   if (TableauSignesReception.cells[2,i]='-X') then TableauSignesReceptionNMR[2][i]:=3;
   if (TableauSignesReception.cells[2,i]='-Y') then TableauSignesReceptionNMR[2][i]:=4;

   if (TableauSignesReceptionNMR[1][i]<>0) and (TableauSignesReceptionNMR[2][i]<>0)
               then  NombreStepsPourReception:=NombreStepsPourReception+1;
   end;
end;



{SAUVE SEQUENCE
charge fichier sequence (faire un erasesigne)
 }
procedure TSeq16ChannelsForm.ModeAcquisition4pulsesClick(Sender: TObject);
begin
   if ModeAcquisition4pulses.State=cbChecked then
         begin
         if (drapeaumodeacquisition4pulses=false) then MessageDlg('Mode with dephasor : plug C5 to COMMAND, C6 to PHASE 0, C7 to PHASE 1, C3 to blankin, C16 to gage trigger', mtWarning, [mbOk], 0);
         DrapeauModeAcquisition2pulses:=false;
         DrapeauModeAcquisition1pulse:=false;
         DrapeauModeAcquisition4pulses:=true;
         DrapeauSequenceur16VoiesRecognitionStep:=true;


         ModeAcquisitionStandard.State:=cbUnchecked;
         ModeAcquisition2pulses.state:=cbunchecked;
         GageRecognitionBox.state:=cbChecked;
         end
         else DrapeauModeAcquisition4pulses:=false;

end;

procedure Tseq16ChannelsForm.InitialiseSequence;
var i:integer;
begin
editseq.Lines.Clear;
editseqnoncompiled.Lines.Clear;
for i:=1 to listseqpar.rowcount do
    begin
    listseqpar.cells[1,i]:='0';
    listseqpar.cells[2,i]:='0';
    end;
erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
{ModeAcquisitionStandard.State:=cbChecked;}
SansRafraichissement.State:=cbUnChecked;
end;


procedure TSeq16ChannelsForm.SequencesChange(Sender: TObject);
begin
   if Sequences.Text='pi/2' then piSur2Simple;
   if Sequences.Text='pi/2-pi simple' then piSur2PiSimple;
   if Sequences.Text='pi/2-pi 2 steps Old Dephaseur homodyne' then piSur2Pi2StepsOldPhase;
   if Sequences.Text='pi/2-pi 2 steps New Dephaseur homodyne' then piSur2Pi2StepsNewPhase;
   if Sequences.Text='pi/2-pi 4 steps New Dephaseur homodyne' then piSur2Pi4StepsNewPhase;
      if Sequences.Text='pi/2-pi 16 steps New Dephaseur homodyne' then piSur2Pi16StepsNewPhase;
end;
{*********************************************************}
procedure TSeq16ChannelsForm.piSur2Simple;
var i:integer;
begin
InitialiseSequence;
ModeAcquisitionStandard.State:=cbChecked;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=false;
pulsedialogue.piSur2PiDialogue.tau.visible:=false;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;

listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2 simple';
end;
{*********************************************************}
procedure TSeq16ChannelsForm.piSur2PiSimple;
var i:integer;
begin
InitialiseSequence;
ModeAcquisitionStandard.State:=cbChecked;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple';
end;
{*********************************************************}
procedure TSeq16ChannelsForm.piSur2Pi2StepsOldPhase;
var i:integer;
begin
InitialiseSequence;
ModeAcquisition2Pulses.State:=cbChecked;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');

erasetableauSignesREception;
NombreStepsPourReception:=2;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-X';
TableauSignesReception.cells[2,2]:='-Y';

SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple';
end;

{*********************************************************}
procedure TSeq16ChannelsForm.piSur2Pi2StepsNewPhase;
var i:integer;
begin
InitialiseSequence;
ModeAcquisition4Pulses.State:=cbChecked;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
 pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');

erasetableauSignesREception;
NombreStepsPourReception:=2;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-X';
TableauSignesReception.cells[2,2]:='-Y';

SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple';
end;

{*********************************************************}
procedure TSeq16ChannelsForm.piSur2Pi4StepsNewPhase;
var i:integer;
begin
InitialiseSequence;
ModeAcquisition4Pulses.State:=cbChecked;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,90); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,270); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');

erasetableauSignesREception;
NombreStepsPourReception:=4;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-Y';
TableauSignesReception.cells[2,2]:='+X';
TableauSignesReception.cells[1,3]:='-X';
TableauSignesReception.cells[2,3]:='-Y';
TableauSignesReception.cells[1,4]:='+Y';
TableauSignesReception.cells[2,4]:='-X';

SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps';
end;
{*********************************************************}
procedure TSeq16ChannelsForm.piSur2Pi16StepsNewPhase;
var i:integer;
begin
InitialiseSequence;
ModeAcquisition4Pulses.State:=cbChecked;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.amplitude.visible:=false;
pulsedialogue.piSur2PiDialogue.label6.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;

editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,90); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,180); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,0); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,270); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,0); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,90); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,180); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,180); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,90); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,270); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,90); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,90); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,90); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,180); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,270); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,270); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,270); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,90); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL on 4 for scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,270); rf pulse of length TA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,180); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
editseqNoncompiled.Lines.Add(' ');
editseqNoncompiled.Lines.Add('T0.005,C4,TRIGACQ; TTL scope and gage trigger');
editseqNoncompiled.Lines.Add('PULSE(TA,270); rf pulse of length TA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC); wait for TC');
editseqNoncompiled.Lines.Add('PULSE(TB,270); rf pulse of length TB, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR); wait for TR');
erasetableauSignesREception;
NombreStepsPourReception:=16;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-X';
TableauSignesReception.cells[2,2]:='-Y';
TableauSignesReception.cells[1,3]:='+X';
TableauSignesReception.cells[2,3]:='+Y';
TableauSignesReception.cells[1,4]:='-X';
TableauSignesReception.cells[2,4]:='-Y';

TableauSignesReception.cells[1,5]:='-X';
TableauSignesReception.cells[2,5]:='-Y';
TableauSignesReception.cells[1,6]:='+X';
TableauSignesReception.cells[2,6]:='+Y';
TableauSignesReception.cells[1,7]:='-X';
TableauSignesReception.cells[2,7]:='-Y';
TableauSignesReception.cells[1,8]:='+X';
TableauSignesReception.cells[2,8]:='+Y';

TableauSignesReception.cells[1,9]:='-Y';
TableauSignesReception.cells[2,9]:='+X';
TableauSignesReception.cells[1,10]:='+Y';
TableauSignesReception.cells[2,10]:='-X';
TableauSignesReception.cells[1,11]:='-Y';
TableauSignesReception.cells[2,11]:='+X';
TableauSignesReception.cells[1,12]:='+Y';
TableauSignesReception.cells[2,12]:='-X';

TableauSignesReception.cells[1,13]:='+Y';
TableauSignesReception.cells[2,13]:='-X';
TableauSignesReception.cells[1,14]:='-Y';
TableauSignesReception.cells[2,14]:='+X';
TableauSignesReception.cells[1,15]:='+Y';
TableauSignesReception.cells[2,15]:='-X';
TableauSignesReception.cells[1,16]:='-Y';
TableauSignesReception.cells[2,16]:='+X';



SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 16 steps';
end;



end.
