unit conductus;
{modif juillet 2005 : SOSEN2 au lieu de SOSEN1 et SETP2 au lieu de SETP1
pour utiliser le heater en sortir du conductus

For using a GPIB IEEE interface : install first the gpib
programs from the disk. Then, go to the program cbconf.exe
choose Edit GPIB1 Board Options,
then chang Board is installed to Board is not installed
Then specify an adress at Primary GPIB adress,
the same that you will specify in the device which will be interfaced.
Finally, fo to DEV1 or DEV2 or... menu, and
specify in one of them the name of the device (for example : GENERF)
Then go back to main menu, and Save Current Configuration. Then quit CBCONF32.

Then, in this delphi unit, put in the definition of the constants
at the begining a lien which specifies the name again : like
const
    DEV_NAME = 'CONDUCTUS';

Finally, make sure that the unit you use for your interface has in 'uses' the
unit 'gpib' specified

*******************************************************************
*******************************************************************
IMPORTANT : BE SURE WHEN YOU CHANGE OF COMPUTER TO CHECK AGAIN THE OPTIONS
OF THE CBCONF.EXE AND THAT ALL THE NAMES OF THE DEVICE TO BE USED ARE
WELL SPECIFIED !!!
*************************************************************************
*************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gpib, StdCtrls, ExtCtrls,DrapeauAlloulUnit;

type
  TconductusForm = class(TForm)
    Label4: TLabel;
    Label7: TLabel;
    GPIBStatusBox: TLabel;
    ErrBox: TMemo;
    ReadTempButton: TButton;
    temperaturebox1: TLabel;
    unitebox1: TLabel;
    Label1: TLabel;
    SetTemperatureBox1: TEdit;
    LastAskedTemperatureLabel1: TLabel;
    temperaturebox2: TLabel;
    unitebox2: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    LastAskedTemperatureLabel2: TLabel;
    SetTemperatureBox2: TEdit;
    Label6: TLabel;
    Label8: TLabel;
    Button1: TButton;
    Label9: TLabel;
    Label10: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpenDevice;
    procedure ouverture;
    procedure WriteCommand (CommandStr:string);
    procedure ReadIDString ;
    procedure ReadValue (var ReadStr:string);
    procedure PrntErrs (ErrMsg:string);
    procedure Connect;
    procedure StopConnection;
    procedure Commande(Commande:string);
    procedure ReadTempButtonClick(Sender: TObject); {change la freq en MHz}
    procedure readtemperature(Senseur:integer;var valeur:extended;var unite:string);
    procedure settemperature(valeur:string;senseur:integer);
    procedure readsenseur(senseur:integer;var valeur:extended;var unite:string);
    procedure ReadAllTemperatures;
    procedure SetTemperatureBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SetTemperatureBox2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
    MaxLen = 80;                 { Size of IBRD/IBWRT strings  }
    DEV_NAME = 'CONDUCTUS';      { Name for device as specified in CBCONF }
    RESET_CMD = '*RST';          { "Reset" command }
    ID_CMD = '*IDN?';            { "Identify Myself" command }

var
  conductusForm: TconductusForm;
  DevHandle:Integer;
  GPIBCallInProgress:Boolean;

implementation

{$R *.DFM}

procedure TconductusForm.FormCreate(Sender: TObject);
var valeur:extended;err:integer;reponse:string;
begin

   DrapeauGPIBconnection:=false; {dit si GPIB marche ou pas}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   if (DrapeauGPIBconnection=true) then
     begin
     WriteCommand (ID_CMD);
     ReadValue (REPONSE);
     ErrBox.lines.add (reponse);
     readsenseur(1,valeur,reponse);
     end;
end;


procedure TconductusForm.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
conductusform.WindowState:=WsMinimized;
conductusform.WindowState:=WsNormal;
end;
{************************************************************************}
{                                                                        }
{  Name:         OpenDevice                                            }
{  Returns:      Handle of opened GPIB device                }
{  Description:  Opens the GPIB device (Fluke45) and resets it
{                                                                        }
{************************************************************************}

procedure TconductusForm.OpenDevice;
var
  DevName:PChar;IDString:string;

begin
   If (DevHandle > 0) then Exit;
   DevName := StrAlloc (length (DEV_NAME) + 1);
   StrPCopy (DevName, DEV_NAME);

   DevHandle := ibfind (DevName);        { Open the device }
   if (DevHandle < 0) and (iberr=EDVR) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      ErrBox.lines.add ('IBFIND Couldn''t find device ' +dev_name);
      ErrBox.lines.add ('   Make sure that you have assigned the name '+ dev_name);
      ErrBox.lines.add ('   to the meter with the CBCONF.EXE program.  Make sure that');
      ErrBox.lines.add ('   the meter is configured for the address that you specified');
      ErrBox.lines.add ('   with CBCONF.EXE.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end

   else if (DevHandle < 0) and (iberr=ECFG) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'   ;
      ErrBox.lines.add ('Board type is incorrect');
      ErrBox.lines.add ('   The board type specified in GPIB.CFG does not match the installed');
      ErrBox.lines.add ('   board.  Run CBCONF.EXE and check the board type that is set there.');
      ErrBox.lines.add ('   Make sure that it matches the type of board that is installed in');
      ErrBox.lines.add ('   your system.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end
   else
       begin
       GPIBStatusBox.caption:='WORKING OK';
       ibtmo (DevHandle,T3s);         { Set timeout to 3 seconds }
       DrapeauGPIBconnection:=true;
       {       WriteCommand (RESET_CMD);      { Reset the device }
       end;

end;

{************************************************************************}
{                                                                        }
{  Name:         WriteCommand                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                CommandStr - command string to write to device          }
{  Description:  Writes a string to a GPIB device and checks for errors  }
{                                                                        }
{************************************************************************}

procedure TconductusForm.WriteCommand (CommandStr:string);

var
  StrLen,i:integer;
  CommandP:PChar;

begin

   CommandP := StrAlloc (length (CommandStr) + 1);
   StrPCopy (CommandP, CommandStr);

 StrLen := length (CommandStr);              { Copy from string to buffer }
 ibwrt (DevHandle, CommandP, StrLen);          { Write to GPIB }
   if (ibcnt<>StrLen) or (ibsta and ERR <> 0) then  { Check for errors }
      PrntErrs ('IBWRT failed while writing ' +CommandStr);
end;





{************************************************************************}
{                                                                        }
{  Name:         ReadValue                                               }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                buffer - buffer to read data into                       }
{                bufsize - size of buffer                                }
{  Description:  Reads from a GPIB device                                }
{                                                                        }
{************************************************************************}


procedure TconductusForm.ReadValue (var ReadStr:string);

const
     READ_BUF_SIZE = 200;
var
  ReadBuf: array[0..READ_BUF_SIZE] of Char;

begin
   if (DevHandle = 0) then
      begin
      ErrBox.lines.add('---');
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      end
   else
       begin;
       ibrd (DevHandle, ReadBuf, READ_BUF_SIZE);     { Read from GPIB }
       if (ibcnt = 0) or (ibsta and ERR <> 0) then { Check for errors }
          begin;
          ErrBox.lines.add('---');
          PrntErrs ('IBRD failed');
          GPIBStatusBox.caption:='NOT WORKING WELL'  ;
          {timer1.Enabled := False;}
          end
       else
           ReadBuf[ibcnt] := #0;
           ReadStr := StrPas (ReadBuf);
           ErrBox.lines.add ( 'ANSWER = '+readStr);
       end;

end;



{************************************************************************}
{                                                                        }
{  Name:         ReadIDString                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{  Description:  This procedure asks the voltmeter for it's ID string.   }
{                It reads the string that is returned and prints it.     }
{                                                                        }
{************************************************************************}

procedure TconductusForm.ReadIDString;

var
   IDString:string;

begin
   WriteCommand (ID_CMD);
   ReadValue (IDString);
   ErrBox.lines.Add ('Device Identification = ' +IDString);
end;


{************************************************************************}
{                                                                        }
{  Name:         PrintErrors                                             }
{  Description:  This procedure prints an error message followed by the  }
{                values of the global staus variables - IBSTA, IBERR,    }
{                and IBCNT.  For IBSTA it prints the name of every bit   }
{                that is set.  For IBERR it prints the mnemonic for the  }
{                error code.                                             }
{                                                                        }
{************************************************************************}

procedure TconductusForm.PrntErrs (ErrMsg:string);

var
   ErrStr: String;
   HexStr: String;

begin
   ErrBox.lines.Add (ErrMsg);

   ErrStr := '   IBSTA=';              { Print IBSTA value }

   if ibsta and ERR  <> 0 then ErrStr := ErrStr + ' ERR';
   if ibsta and TIMO <> 0 then ErrStr := ErrStr + ' TMO';
   if ibsta and EEND <> 0 then ErrStr := ErrStr + ' END';
   if ibsta and SRQI <> 0 then ErrStr := ErrStr + ' SRQI';
   if ibsta and RQS  <> 0 then ErrStr := ErrStr + ' RQS';;
   if ibsta and SPOLL <> 0 then ErrStr := ErrStr + ' SPOLL';
   if ibsta and EVENT <> 0 then ErrStr := ErrStr + ' EVENT';
   if ibsta and CMPL <> 0 then ErrStr := ErrStr + ' CMPL';
   if ibsta and LOK  <> 0 then ErrStr := ErrStr + ' LOK';
   if ibsta and REM  <> 0 then ErrStr := ErrStr + ' REM';
   if ibsta and CIC  <> 0 then ErrStr := ErrStr + ' CIC';
   if ibsta and ATN  <> 0 then ErrStr := ErrStr + ' ATN';
   if ibsta and TACS <> 0 then ErrStr := ErrStr + ' TACS';
   if ibsta and LACS <> 0 then ErrStr := ErrStr + ' LACS';
   if ibsta and DTAS <> 0 then ErrStr := ErrStr + ' DTAS';
   if ibsta and DCAS <> 0 then ErrStr := ErrStr + ' DCAS';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBERR=';
   if iberr = EDVR then ErrStr := ErrStr + ' EDVR <DOS Error>';
   if iberr = ECIC then ErrStr := ErrStr + ' ECIC <Not CIC>';
   if iberr = ENOL then ErrStr := ErrStr + ' ENOL <No Listener>';
   if iberr = EADR then ErrStr := ErrStr + ' EADR <Address Error>';
   if iberr = EARG then ErrStr := ErrStr + ' EARG <Invalid Arguments>';
   if iberr = ESAC then ErrStr := ErrStr + ' ESAC <Not System Controller>';
   if iberr = EABO then ErrStr := ErrStr + ' EABO <Operation aborted>';
   if iberr = ENEB then ErrStr := ErrStr + ' ENEB <No GPIB board>';
   if iberr = EOIP then ErrStr := ErrStr + ' EOIP <Async I/I in progress>';
   if iberr = ECAP then ErrStr := ErrStr + ' ECAP <No Capability>';
   if iberr = EFSO then ErrStr := ErrStr + ' EFSO <File Error>';
   if iberr = EBUS then ErrStr := ErrStr + ' EBUS <Command error>';
   if iberr = ESTB then ErrStr := ErrStr + ' ESTB <Status byte lost>';
   if iberr = ESRQ then ErrStr := ErrStr + ' ESRQ <SRQ Stuck On>';
   if iberr = ETAB then ErrStr := ErrStr + ' ETAB <Table Overflow>';
   if iberr = ECFG then ErrStr := ErrStr + ' ECFG <Incorrect board>';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBCNT=';
   ErrBox.lines.add (ErrStr);
end;

procedure TconductusForm.Connect;
begin
   OpenDevice;                         { Open the GPIB device }
{   timer1.Enabled := True;}
end;

procedure TconductusForm.Commande(Commande:string);

var
   CmdStr: string;
   i,start: Integer;

begin
{   if DevHandle<>0 then StopConnection;}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;

   {if DevHandle = 0 Then OpenDevice;}

   CmdStr:=Commande;
    {exple : '*IDN?' 'CFRQ:VALUE 15MHZ' 'RFLV:VALUE 9DBM'}

    if GPIBCallInProgress = FALSE then
       begin;
       GPIBCallInProgress := TRUE;
       {temps d'attente de 100 msec avant de passer la commande}
{       start:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - start) > 100);
       UNTIL timeout;}
       WriteCommand (CmdStr);
       GPIBCallInProgress := FALSE;
       ErrBox.lines.Add(Commande); {on affiche la commande}
       end;

{   StopConnection;}
end;

procedure TconductusForm.StopConnection;
begin
{ timer1.Enabled := False;}
{ ErrBox.Clear;}
 If GPIBCallInProgress = FALSE Then
    begin;
    GPIBCallInProgress := TRUE;
    ibclr(DevHandle);
    ibloc(DevHandle);
    GPIBCallInProgress := FALSE;
    end;

end;



procedure TconductusForm.ReadTempButtonClick(Sender: TObject);
begin
   readAllTemperatures;
end;

procedure TconductusForm.ReadAllTemperatures;
var valeur:extended;unite,chaine:string;
begin
   readtemperature(1,valeur,unite);
   conductus1LastReadTemperature:=valeur;
   str(valeur:8:3,chaine);
   temperaturebox1.caption:=chaine;
   unitebox1.caption:=unite;
   readtemperature(2,valeur,unite);
   conductus2LastReadTemperature:=valeur;
   str(valeur:8:3,chaine);
   temperaturebox2.caption:=chaine;
   unitebox2.caption:=unite;
end;

procedure Tconductusform.readtemperature(Senseur:integer;var valeur:extended;var unite:string);
var valeur2:extended;chaine:string;
begin
   if senseur=2 then readsenseur(2,valeur,unite)
      else readsenseur(1,valeur,unite);
end;

procedure Tconductusform.settemperature(valeur:string;senseur:integer);
var chaine,chaine2:string;err:integer;nombre:extended;
begin
  if pos(',',valeur)>0 then
     begin
     valeur:=copy(valeur,1,pos(',',valeur)-1)+'.'+
             copy(valeur,pos(',',valeur)+1,length(valeur)-pos(',',valeur));
     end;
  val(valeur,nombre,err);
  if (err=0) and (nombre>0) and (nombre<700) and (senseur<=2) and (senseur>=1) then
    begin
     if senseur=1 then
                  begin
                  WriteCommand('SOSEN2,1;'); {on regle la tete en Analog}
                  chaine2:='SETP2,'+valeur+';';
                  WriteCommand(chaine2);
                  end;
     if senseur=2 then
                  begin
                  WriteCommand('SOSEN1,2;'); {on regle le bloc en Heater}
                  chaine2:='SETP1,'+valeur+';';
                  WriteCommand(chaine2);
                  end;
     WriteCommand('SCONT;');
     if senseur=1 then LastAskedTemperatureLabel1.caption:=chaine+' K at '+TimeToStr(Time)+','+DateToStr(Date);
     if senseur=2 then LastAskedTemperatureLabel2.caption:=chaine+' K at '+TimeToStr(Time)+','+DateToStr(Date);
     LastAskedTemperatureLabel1.refresh;
     LastAskedTemperatureLabel2.refresh;
    end;
end;

procedure Tconductusform.readSenseur(senseur:integer;var valeur:extended;var unite:string);
var err:integer;chaine,reponse:string;nombre:extended;
begin
     if senseur=1 then WriteCommand ('QSAMP?<1=Sensor 1>;');
     if senseur=2 then WriteCommand ('QSAMP?<2=Sensor 2>;');
     ReadValue(REPONSE);
     ErrBox.lines.add (reponse);
     chaine:=reponse;
     if pos('K',reponse)>0 then unite:='K';
     if pos('O',reponse)>0 then unite:='O';
     err:=2;
     nombre:=0;
     repeat
       val(chaine,nombre,err);
       chaine:=copy(chaine,1,length(chaine)-1);
     until (err=0) or (length(chaine)=0);
     valeur:=nombre;
end;

procedure TconductusForm.SetTemperatureBox1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var valeur,valeur2:extended;err,err2:integer;
begin
if key=13 then
   begin
  valeur2:=1;
  val(SettemperatureBox1.text,valeur,err);
   if (err=0) and (valeur>0) and (valeur<700)  then SetTemperature(SettemperatureBox1.text,round(valeur2))
      else MessageDlg('error in the typing of temperature or sensor box', mtInformation, [mbOk], 0);
   SettemperatureBox1.text:='';
   end;

end;

procedure TconductusForm.SetTemperatureBox2KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var valeur,valeur2:extended;err,err2:integer;
begin
if key=13 then
   begin
  valeur2:=2;
  val(SettemperatureBox2.text,valeur,err);
   if (err=0) and (valeur>0) and (valeur<700)  then SetTemperature(SettemperatureBox2.text,round(valeur2))
      else MessageDlg('error in the typing of temperature or sensor box', mtInformation, [mbOk], 0);
   SettemperatureBox2.text:='';
   end;

end;

procedure TconductusForm.Button1Click(Sender: TObject);
var fich:textfile;nomFichier,directory_NMR:string;
    i,j:integer;chaine:string;drapeau:boolean;nombre:extended;err:integer;
  timeout:boolean;start:integer;
begin

{initialisation des tables pour la cernox}
{on detruit la table precedente si elle existe deja en connaissant son index...}
{ commande ('DCALT3');  {mettre nom cernox}
 {commande ('DCALT2');  {mettre nom cernox}
 {commande ('DCALT1');  {mettre nom cernox}
{on la reecrit}


 {on envoie Kelvin,ohms with increasing order in ohms}
    {mettre avant nom fichier ascii contenant table dans le format :
297.4443,33.5172
289.702,34.13813
264.0216,36.3597

voir tables en fin de programme ci dessous}

 commande ('SCALT2,0,1,PtBloc,1.0,');  {mettre nom cernox}
    NomFichier:='c:\newspectro\ptbloc.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');

 commande ('SCALT2,0,1,PtTete,1.0,');  {mettre nom cernox}
    NomFichier:='c:\newspectro\qb45\pttete.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');

    commande ('SCALT4,0,1,CernE,-1.0,');
    NomFichier:='c:\newspectro\qb45\cerne.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');
 commande ('SCALT4,0,1,CernD,-1.0,');
    NomFichier:='c:\newspectro\qb45\cernd.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');

    commande ('SCALT4,0,1,CernB,-1.0,');
    NomFichier:='c:\newspectro\qb45\cernb.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');

    commande ('SCALT4,0,1,LogCernE,-1.0,');
    NomFichier:='c:\newspectro\qb45\logcerne.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');


    commande ('SCALT4,0,1,LogCernD,-1.0,');
    NomFichier:='c:\newspectro\qb45\logcernd.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');
    commande ('SCALT4,0,1,LogCernB,-1.0,');
    NomFichier:='c:\newspectro\qb45\logcernb.dat';
   button1.caption:='Table '+NomFichier+' En cours';
    assignfile(fich,nomFichier);
    reset(fich);
    while not eof(fich) do
           begin
           i:=i+1;
           readln(Fich,chaine);
           chaine:=chaine+',';
           commande(chaine);
           start:= GetTickCount;
           REPEAT
               timeout:= ((GetTickCount - start) > 2000);
           UNTIL timeout;
           end;
         closefile(fich);
         commande('$;');

end;

{table cernox E :
cerne.dat

297.4443,33.5172
289.702,34.13813
264.0216,36.3597
234.921,39.43395
219.2227,41.40836
192.087,45.50358
159.538,51.97807
146.8434,55.16323
120.7862,63.30254
105.4752,69.5874
98.8911,72.71927
89.8123,77.66122
88.0827,78.70121
79.724,84.1512
78.7136,84.85778
70.9359,90.93136
70.595,91.23172
61.8399,99.51039
61.1018,100.3031
51.9833,111.3501
45.0071,122.111
40.9119,129.6508
33.846,145.8603
25.9846,171.1254
22.9948,183.9613
20.9974,194.0192
19.0161,205.5175
14.9543,236.1023
13.953,245.7628
11.9688,268.619
10.9846,282.4093
9.969,299.0697
8.9813,318.3353
7.9902,341.7819
7.0029,370.858
6.9986,371.115
6.0051,409.3418
4.9867,463.2365
4.4938,497.5632
4.2913,514.0978
4.1917,522.6814
4.1914,522.8594
4.0917,532.0097
3.9893,541.584
3.8896,551.8637
3.786,562.8106
3.6867,574.1224
3.584,586.2066
3.4858,598.7773
3.3838,612.3071
3.2848,626.5568
3.1834,641.8444
3.0846,658.1363
2.9892,674.6425
2.8892,693.3602
2.6888,735.288
2.5883,759.1269
2.4905,784.2713
2.3928,811.9054
2.2961,841.6515
2.1986,874.7448
2.1014,911.4948
1.9705,967.1848
1.8734,1015.219
1.7755,1069.329
1.6878,1123.821
1.5948,1190.774

table cernox B :
cernb.dat

150,75.679
140,79.78
130,84.441
120,89.78
110,95.973
100,103.223
95,107.319
90,111.779
85,116.653
80,122.008
75,127.931
70,134.534
65,141.967
60,150.419
57,156.077
54,162.25
51,169.009
48,176.453
45,184.702
42,194.011
40,200.915
38,208.438
36,216.64
34,225.6
32,235.43
30,246.286
28,258.383
26,272.006
24,287.525
22,305.404
20,326.143
19,337.87
18,350.7
17,364.845
16,380.502
15,397.878
14,417.264
13,439.173
12,464.537
11,494.963
10.8,501.862
10.6,509.091
10.4,516.676
10.2,524.651
10,533.493
9.8,541.904
9.6,550.535
9.4,559.406
9.2,568.542
9,577.967
8.8,587.709
8.6,597.799
8.4,608.271
8.2,619.169
8,630.539
7.8,642.439
7.6,654.931
7.4,668.093
7.2,682.008
7,696.775
6.8,712.505
6.6,729.322
6.4,747.369
6.2,766.801
6,787.793
5.8,810.54
5.6,835.254
5.4,862.171
5.2,891.546
5,923.662
4.8,958.822
4.7,977.646
4.6,997.358
4.5,1018.002
4.4,1039.627
4.3,1062.282
4.2,1086.017
4.1,1110.885
4.0,1136.94

Cernox D :
cernd.dat

300.04805,33.84
295.67176,34.159
280.05486,35.371
260.26154,37.097
239.65149,39.169
219.91113,41.479
199.76337,44.244
190.12042,45.741
179.9772,47.456
170.2768,49.247
160.07832,51.31
149.79913,53.603
140.46415,55.9
129.93796,58.777
120.05287,61.808
110.10089,65.266
100.31766,69.28
95.13159,71.61
90.1918,73.978
84.98688,76.667
79.87947,79.54
74.97112,82.564
69.59319,86.23
64.56297,90.051
60.33357,93.602
57.21423,96.445
53.94792,99.653
50.78992,103.015
47.78453,106.502
44.55967,110.637
41.50507,115.024
38.31699,120.066
36.23969,123.735
34.14273,127.698
32.16433,131.719
30.13642,136.179
27.98657,141.358
26.15771,146.206
24.14322,152.121
22.03074,159.12
20.09504,166.42
18.20458,174.559
17.19219,179.404
16.108,185.028
15.13473,190.512
14.19063,196.288
13.22406,202.761
12.26359,209.911
11.34594,217.679
10.89266,222
10.50553,226.047
10.04863,231.405
9.65467,235.82
9.0647,242.933
8.4145,251.39
7.84809,259.5
7.30285,268.2
6.83941,276.5
6.46182,284.04
6.17186,290.4
5.89448,297.02
5.50367,307.37
5.37264,311.14
5.20425,316.23
5.05682,320.93
4.81604,329.15
4.64019,335.64
4.55379,339
4.39987,345.3
4.18812,354.7
4.00236,363.66
3.73944,376.88

PtBloc:
ptbloc.dat

4.2,0.0987
13.15,0.16997
14.15,0.19367
16.15,0.25907
18.15,0.35336
20.15,0.48245
22.15,0.65142
24.15,0.86438
26.15,1.12411
28.15,1.43193
30.15,1.78828
32.15,2.19287
34.15,2.64453
36.15,3.14123
38.15,3.68027
40.15,4.25866
42.15,4.87334
46.15,6.19916
52.15,8.38483
58.15,10.74229
65.15,13.63128
75.15,17.89682
85.15,22.22677
105.15,30.8821
140.15,45.75886
180.15,62.37523
210.15,74.64518
240.15,86.78311
270.15,98.80402
315.15,116.62846
355.15,132.26718
398.15,148.86628
443.15,166.00414
488.15,182.90536
533.15,199.57117
583.15,217.81335
628.15,233.98334
673.15,249.91768
713.15,263.8827
758.15,279.36808
798.15,292.93091

Pt Tete
pttete.dat

4.2,0.124
13.15,0.19525
14.15,0.21894
16.15,0.28433
18.15,0.37859
20.15,0.50765
22.15,0.67658
24.15,0.88949
26.15,1.14915
28.15,1.45689
30.15,1.81315
32.15,2.21764
34.15,2.66919
36.15,3.16575
38.15,3.70466
40.15,4.28291
42.15,4.89743
46.15,6.22292
52.15,8.40804
58.15,10.76489
65.15,13.65316
75.15,17.91761
85.15,22.24647
105.15,30.89961
140.15,45.77259
180.15,62.38476
210.15,74.65161
240.15,86.78646
270.15,98.80433
315.15,116.62425
355.15,132.25901
398.15,148.85391
443.15,165.98743
488.15,182.88436
533.15,199.54596
583.15,217.78352
628.15,233.94941
673.15,249.87971
713.15,263.8412
758.15,279.32265
798.15,292.88205

LogcernE.dat

297.4443,3.51206
289.702,3.53041
264.0216,3.59346
234.921,3.67463
219.2227,3.72348
192.087,3.81779
159.538,3.95082
146.8434,4.0103
120.7862,4.14793
105.4752,4.24258
98.8911,4.28661
89.8123,4.35236
88.0827,4.36566
79.724,4.43262
78.7136,4.44098
70.9359,4.5101
70.595,4.5134
61.8399,4.60026
61.1018,4.6082
51.9833,4.71268
45.0071,4.80493
40.9119,4.86484
33.846,4.98265
25.9846,5.1424
22.9948,5.21473
20.9974,5.26796
19.0161,5.32553
14.9543,5.46427
13.953,5.50437
11.9688,5.59329
10.9846,5.64336
9.969,5.70068
8.9813,5.76311
7.9902,5.83417
7.0029,5.91582
6.9986,5.91651
6.0051,6.01455
4.9867,6.13824
4.4938,6.20972
4.2913,6.24241
4.1917,6.25897
4.1914,6.25931
4.0917,6.27666
3.9893,6.2945
3.8896,6.3133
3.786,6.33294
3.6867,6.35284
3.584,6.37367
3.4858,6.39489
3.3838,6.41723
3.2848,6.44024
3.1834,6.46435
3.0846,6.48941
2.9892,6.51418
2.8892,6.54155
2.6888,6.60026
2.5883,6.63217
2.4905,6.66476
2.3928,6.69938
2.2961,6.73537
2.1986,6.77393
2.1014,6.81509
1.9705,6.87439
1.8734,6.92286
1.7755,6.97479
1.6878,7.02449
1.5948,7.08236

LogCernB.dat

150,1.87898
140,1.90189
130,1.92655
120,1.95318
110,1.98215
100,2.01378
95,2.03068
90,2.04836
85,2.0669
80,2.08639
75,2.10698
70,2.12883
65,2.15219
60,2.1773
57,2.19334
54,2.21018
51,2.22791
48,2.24663
45,2.26647
42,2.28783
40,2.30301
38,2.31898
36,2.33574
34,2.35334
32,2.37186
30,2.39144
28,2.41226
26,2.43458
24,2.45868
22,2.48487
20,2.51341
19,2.52875
18,2.54494
17,2.56211
16,2.58036
15,2.59975
14,2.62041
13,2.64264
12,2.66702
11,2.69457
10.8,2.70058
10.6,2.7068
10.4,2.71322
10.2,2.71987
10,2.72713
9.8,2.73392
9.6,2.74078
9.4,2.74773
9.2,2.75476
9,2.7619
8.8,2.76916
8.6,2.77656
8.4,2.7841
8.2,2.79181
8,2.79971
7.8,2.80783
7.6,2.8162
7.4,2.82484
7.2,2.83379
7,2.84309
6.8,2.85279
6.6,2.86292
6.4,2.87354
6.2,2.88468
6,2.89641
5.8,2.90877
5.6,2.92182
5.4,2.93559
5.2,2.95014
5,2.96551
4.8,2.98174
4.7,2.99018
4.6,2.99885
4.5,3.00775
4.4,3.01688
4.3,3.02624
4.2,3.03584
4.1,3.04567
4.0,3.05574

LogCernD.dat

300.04805,1.52943
295.67176,1.53351
280.05486,1.54865
260.26154,1.56934
239.65149,1.59294
219.91113,1.61783
199.76337,1.64585
190.12042,1.66031
179.9772,1.67629
170.2768,1.69238
160.07832,1.7102
149.79913,1.72919
140.46415,1.74741
129.93796,1.76921
120.05287,1.79104
110.10089,1.81469
100.31766,1.84061
95.13159,1.85497
90.1918,1.8691
84.98688,1.88461
79.87947,1.90059
74.97112,1.91679
69.59319,1.93566
64.56297,1.95449
60.33357,1.97129
57.21423,1.98428
53.94792,1.99849
50.78992,2.0129
47.78453,2.02736
44.55967,2.0439
41.50507,2.06079
38.31699,2.07942
36.23969,2.09249
34.14273,2.10618
32.16433,2.11965
30.13642,2.13411
27.98657,2.15032
26.15771,2.16497
24.14322,2.18219
22.03074,2.20172
20.09504,2.22121
18.20458,2.24194
17.19219,2.25383
16.108,2.26724
15.13473,2.27992
14.19063,2.29289
13.22406,2.30698
12.26359,2.32204
11.34594,2.33782
10.89266,2.34635
10.50553,2.3542
10.04863,2.36437
9.65467,2.37258
9.0647,2.38549
8.4145,2.40035
7.84809,2.41414
7.30285,2.42846
6.83941,2.4417
6.46182,2.45338
6.17186,2.463
5.89448,2.47279
5.50367,2.48766
5.37264,2.49296
5.20425,2.5
5.05682,2.50641
4.81604,2.51739
4.64019,2.52587
4.55379,2.5302
4.39987,2.5382
4.18812,2.54986
4.00236,2.5607
3.73944,2.5762
}
end.

