unit ITC5drv;
 {
ITC503 Temperature controller (not ITC4 which is on RS232)
programmed by J. Bobroff  nov 2005
unit : ITC5drv.pas
DEV_NAME = 'ITC5'
ADRESS = 24

 For using a GPIB IEEE interface : install first the gpib
programs from the disk. Then, go to the program cbconf.exe
choose Edit GPIB1 Board Options,
then chang Board is installed to Board is not installed
Then specify an adress at Primary GPIB adress,
the same that you will specify in the device which will be interfaced.
Finally, fo to DEV1 or DEV2 or... menu, and
specify in one of them the name of the device (for example : GENERF)
Then go back to main menu, and Save Current Configuration. Then quit CBCONF32.

Then, in this delphi unit, put in the definition of the constants
at the begining a lien which specifies the name again : like
const
    DEV_NAME = 'ITC5';

Finally, make sure that the unit you use for your interface has in 'uses' the
unit 'gpib' specified

*******************************************************************
*******************************************************************
IMPORTANT : BE SURE WHEN YOU CHANGE OF COMPUTER TO CHECK AGAIN THE OPTIONS
OF THE CBCONF.EXE AND THAT ALL THE NAMES OF THE DEVICE TO BE USED ARE
WELL SPECIFIED !!!
*************************************************************************
*************************************************************}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gpib, StdCtrls, ExtCtrls,DrapeauAlloulUnit, Spin, EditReal;

type
  TITC5 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    HeaterStatus: TLabel;
    GazFlowStatus: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    TempBox: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PropValue: TLabel;
    IntValue: TLabel;
    Label9: TLabel;
    DerivValue: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    heatervalue: TLabel;
    gazflowvalue: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    SetTemperature: TLabel;
    Label14: TLabel;
    StringToSend: TEdit;
    SendButton: TButton;
    memo1: TMemo;
    SetTempBox: TEditReal;
    GainPbox: TEditReal;
    GazFlowLevelBox: TEdit;
    GainIntBox: TEditReal;
    ReadITC5ValuesButton: TButton;
    ChannelBox: TSpinEdit;
    ChangeHeaterStatus: TButton;
    ChangeGazFlowStatus: TButton;
    GainDerivBox: TEditReal;
    maxheater: TEditReal;
    ChangeToLocal: TButton;
    ChangeToRemote: TButton;
    HeaterLevelBox: TEdit;
    Label15: TLabel;
    ErrBox: TMemo;
    GPIBStatusBox: TLabel;
    Label16: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpenDevice;
    procedure ouverture;
    procedure WriteCommand (CommandStr:string);
    procedure ReadIDString ;
    procedure ReadValue (var ReadStr:string);
    procedure PrntErrs (ErrMsg:string);
    procedure Connect;
    procedure StopConnection;
    procedure Commande(Commande:string);
    procedure ReadITC5ValuesButtonClick(Sender: TObject);
    procedure RafraichirITC5;
    procedure SendButtonClick(Sender: TObject);
    procedure SetTempBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ChangeToRemoteClick(Sender: TObject);
    procedure ChangeToLocalClick(Sender: TObject);
    procedure ChangeHeaterStatusClick(Sender: TObject);
    procedure ChangeGazFlowStatusClick(Sender: TObject);
    procedure HeaterLevelBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SetHeaterValue(d:real);
    procedure SetGazFlowValue(d:real);
    procedure GazFlowLevelBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainIntBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainDerivBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure maxheaterKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainPboxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    { passage en rgulation automatique (pour le heater) }
    procedure SetHeaterAutoGasManual;
    procedure SetHeaterManualGasAuto;
    procedure SetHeaterManualGasManual;
    procedure SetHeaterAutoGasAuto;

    { passage en rgulation automatique (pour la NV) }
    { passage en rgulation automatique (pour la NV) }
    { definition du gain P en pourcents }
    procedure SetProportionnal_ITC5(d:real);
    { definition du gain I en pourcents }
    procedure SetIntegral_ITC5(d:real);
    { definition du gain P en pourcents }
    procedure SetDerivative_ITC5(d:real);
    procedure SetMaxHeater_ITC5(d:real);

    { lecture de la temprature sur le channel "channel", OUTPUT en kelvin }
    function readTemperature_ITC5(channel:byte):real; { ok }
    { change le display de l'affichage sur un des toris canaux de lecture }
{    procedure DisplayTemperature_ITC5(channel:byte); { ok }
    { choix du channel pour la regulation }
    {procedure SetRegulationChannel_ITC5(channel:byte);
    { definition d'un SetPoint }
    procedure setTemperature_ITC5(Tempera:real);
    { ouverture de la needle valve }
  {  procedure setGazFlow_ITC5(opening:integer);
    {changement du heater}
 {   procedure setHeater_ITC5(value:real);
}

  end;

  const
    MaxLen = 80;                 { Size of IBRD/IBWRT strings  }
    DEV_NAME = 'ITC5';      { Name for device as specified in CBCONF }
    RESET_CMD = '*RST';          { "Reset" command }
    ID_CMD = '*IDN?';            { "Identify Myself" command }

var
  ITC5: TITC5;
  GPIBCallInProgress:Boolean;
  DevHandle:Integer;

implementation

uses BoiteNoire;

{$R *.DFM}

procedure TITC5.FormCreate(Sender: TObject);
var valeur:extended;err:integer;reponse:string;
begin

   DrapeauGPIBconnection:=false; {dit si GPIB marche ou pas}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   if (DrapeauGPIBconnection=true) then
     begin
     {lire les valeurs de temperature ICI    xxxx}

     end;
end;


procedure TITC5.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
ITC5.WindowState:=WsMinimized;
ITC5.WindowState:=WsNormal;
end;
{************************************************************************}
{                                                                        }
{  Name:         OpenDevice                                            }
{  Returns:      Handle of opened GPIB device                }
{  Description:  Opens the GPIB device (Fluke45) and resets it
{                                                                        }
{************************************************************************}

procedure TITC5.OpenDevice;
var
  DevName:PChar;IDString:string;

begin
   If (DevHandle > 0) then Exit;
   DevName := StrAlloc (length (DEV_NAME) + 1);
   StrPCopy (DevName, DEV_NAME);

   DevHandle := ibfind (DevName);        { Open the device }
   if (DevHandle < 0) and (iberr=EDVR) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      ErrBox.lines.add ('IBFIND Couldn''t find device ' +dev_name);
      ErrBox.lines.add ('   Make sure that you have assigned the name '+ dev_name);
      ErrBox.lines.add ('   to the meter with the CBCONF.EXE program.  Make sure that');
      ErrBox.lines.add ('   the meter is configured for the address that you specified');
      ErrBox.lines.add ('   with CBCONF.EXE.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end

   else if (DevHandle < 0) and (iberr=ECFG) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'   ;
      ErrBox.lines.add ('Board type is incorrect');
      ErrBox.lines.add ('   The board type specified in GPIB.CFG does not match the installed');
      ErrBox.lines.add ('   board.  Run CBCONF.EXE and check the board type that is set there.');
      ErrBox.lines.add ('   Make sure that it matches the type of board that is installed in');
      ErrBox.lines.add ('   your system.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end
   else
       begin
       GPIBStatusBox.caption:='WORKING OK';
       ibtmo (DevHandle,T3s);         { Set timeout to 3 seconds }
       DrapeauGPIBconnection:=true;
       {       WriteCommand (RESET_CMD);      { Reset the device }
       end;

end;

{************************************************************************}
{                                                                        }
{  Name:         WriteCommand                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                CommandStr - command string to write to device          }
{  Description:  Writes a string to a GPIB device and checks for errors  }
{                                                                        }
{************************************************************************}

procedure TITC5.WriteCommand (CommandStr:string);

var
  StrLen,i:integer;
  CommandP:PChar;

begin

   CommandP := StrAlloc (length (CommandStr) + 1);
   StrPCopy (CommandP, CommandStr);

 StrLen := length (CommandStr);              { Copy from string to buffer }
 ibwrt (DevHandle, CommandP, StrLen);          { Write to GPIB }
   if (ibcnt<>StrLen) or (ibsta and ERR <> 0) then  { Check for errors }
      PrntErrs ('IBWRT failed while writing ' +CommandStr);
end;





{************************************************************************}
{                                                                        }
{  Name:         ReadValue                                               }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                buffer - buffer to read data into                       }
{                bufsize - size of buffer                                }
{  Description:  Reads from a GPIB device                                }
{                                                                        }
{************************************************************************}


procedure TITC5.ReadValue (var ReadStr:string);

const
     READ_BUF_SIZE = 200;
var
  ReadBuf: array[0..READ_BUF_SIZE] of Char;

begin
   if (DevHandle = 0) then
      begin
      ErrBox.lines.add('---');
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      end
   else
       begin;
       ibrd (DevHandle, ReadBuf, READ_BUF_SIZE);     { Read from GPIB }
       if (ibcnt = 0) or (ibsta and ERR <> 0) then { Check for errors }
          begin;
          ErrBox.lines.add('---');
          PrntErrs ('IBRD failed');
          GPIBStatusBox.caption:='NOT WORKING WELL'  ;
          {timer1.Enabled := False;}
          end
       else
           ReadBuf[ibcnt] := #0;
           ReadStr := StrPas (ReadBuf);
           ErrBox.lines.add ( 'ANSWER = '+readStr);
       end;

end;



{************************************************************************}
{                                                                        }
{  Name:         ReadIDString                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{  Description:  This procedure asks the voltmeter for it's ID string.   }
{                It reads the string that is returned and prints it.     }
{                                                                        }
{************************************************************************}

procedure TITC5.ReadIDString;

var
   IDString:string;

begin
   WriteCommand (ID_CMD);
   ReadValue (IDString);
   ErrBox.lines.Add ('Device Identification = ' +IDString);
end;


{************************************************************************}
{                                                                        }
{  Name:         PrintErrors                                             }
{  Description:  This procedure prints an error message followed by the  }
{                values of the global staus variables - IBSTA, IBERR,    }
{                and IBCNT.  For IBSTA it prints the name of every bit   }
{                that is set.  For IBERR it prints the mnemonic for the  }
{                error code.                                             }
{                                                                        }
{************************************************************************}

procedure TITC5.PrntErrs (ErrMsg:string);

var
   ErrStr: String;
   HexStr: String;

begin
   ErrBox.lines.Add (ErrMsg);

end;

procedure TITC5.Connect;
begin
   OpenDevice;                         { Open the GPIB device }
{   timer1.Enabled := True;}
end;

procedure TITC5.Commande(Commande:string);

var
   CmdStr: string;
   i,start: Integer;

begin
{   if DevHandle<>0 then StopConnection;}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;

   {if DevHandle = 0 Then OpenDevice;}

   CmdStr:=Commande;
    {exple : '*IDN?' 'CFRQ:VALUE 15MHZ' 'RFLV:VALUE 9DBM'}

    if GPIBCallInProgress = FALSE then
       begin;
       GPIBCallInProgress := TRUE;
       WriteCommand (CmdStr);
       GPIBCallInProgress := FALSE;
       ErrBox.lines.Add(Commande); {on affiche la commande}
       end;

{   StopConnection;}
end;

procedure TITC5.StopConnection;
begin
 If GPIBCallInProgress = FALSE Then
    begin;
    GPIBCallInProgress := TRUE;
    ibclr(DevHandle);
    ibloc(DevHandle);
    GPIBCallInProgress := FALSE;
    end;

end;





procedure TITC5.ReadITC5ValuesButtonClick(Sender: TObject);
begin
RafraichirITC5;
end;

procedure TITC5.RafraichirITC5;

{
read temperature Sensor 1,2,3: R1, R2, R3
Heater : R5 (%) R6 (in Volts)
Gaz Flow : R7
P : R8
I : R9
D : R10
}
var s:string;
    An:byte;
    nombre:extended;err:integer;
    reponse,chaine:string;
begin
   HeaterStatus.caption:='NOT KNOWN';
   GazFlowStatus.caption:='NOT KNOWN';
   ChangeHeaterStatus.caption:='Change not possible';
   ChangeGazFlowStatus.caption:='Change not possible';
{lecture status}
   Commande('X'+#13); {Faut il plutot mettre R0; ?}

   ReadValue(REPONSE);
   ErrBox.lines.add (reponse);
   chaine:=reponse;
   if pos('A0',reponse)>0 then begin
                          heaterstatus.Caption:='MANUAL';
                          gazflowstatus.Caption:='MANUAL';
                          ChangeHeaterStatus.caption:='Change to AUTO';
                          ChangeGazFlowStatus.caption:='Change to AUTO';
                          end;
   if pos('A1',reponse)>0 then begin
                          heaterstatus.Caption:='AUTO';
                          gazflowstatus.Caption:='MANUAL';
                          ChangeHeaterStatus.caption:='Change to MANUAL';
                          ChangeGazFlowStatus.caption:='Change to AUTO';
                          end;
   if pos('A2',reponse)>0 then begin
                          heaterstatus.Caption:='MANUAL';
                          gazflowstatus.Caption:='AUTO';
                          ChangeHeaterStatus.caption:='Change to AUTO';
                          ChangeGazFlowStatus.caption:='Change to MANUAL';
                          end;
   if pos('A3',reponse)>0 then begin
                          heaterstatus.Caption:='AUTO';
                          gazflowstatus.Caption:='AUTO';
                          ChangeHeaterStatus.caption:='Change to MANUAL';
                          ChangeGazFlowStatus.caption:='Change to MANUAL';
                          end;
   if pos('H1',reponse)>0 then channelbox.Value:=1;
   if pos('H2',reponse)>0 then channelbox.Value:=2;
   if pos('H3',reponse)>0 then channelbox.Value:=3;

{lecture temperature}
   Commande('R1'+#13); {Faut il plutot mettre R0; ?}
   ReadValue(REPONSE);
   ErrBox.lines.add (reponse);
   chaine:=reponse;
   chaine:=copy(chaine,2,length(chaine)-1);
   TempBox.caption:=chaine; {a reformater en nombre}

   heaterstatus.refresh;
   gazflowstatus.refresh;

   {LECTURE DU Gaz Flow}
 {  s:=sendread('R7'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 gazflowvalue.Caption:=floattostr(nombre)+'%';
                 gazflowvalue.refresh;
                 end;
   {LECTURE DU heater en Volts}
  { s:=sendread('R6'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 heaterValue.Caption:=floattostr(nombre)+' Volts';
                 heaterValue.refresh;
                 end;
   {LECTURE DU Prop}
{   s:=sendread('R8'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 propvalue.Caption:=floattostr(nombre);
                 propvalue.refresh;
                 end;
   {LECTURE DU Int}
{   s:=sendread('R9'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 intvalue.Caption:=floattostr(nombre);
                 intvalue.refresh;
                 end;
  {LECTURE DU Deriv}
 {  s:=sendread('R10'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 derivvalue.Caption:=floattostr(nombre);
                 derivvalue.refresh;
                 end;

                 end;
}
end;
procedure TITC5.SendButtonClick(Sender: TObject);
var reponse:string;
begin

   Commande (stringtosend.text+#13); {Faut il plutot mettre R0; ?}
   ReadValue(REPONSE);
   ErrBox.lines.add (reponse);


end;

function TITC5.readTemperature_ITC5(channel:byte):real; { ok }
var
   ca:string;
   temp1:real;
   s:string;
   var reponse,chaine:string;err:integer;nombre:extended;
begin
   if (channel>=1) and (channel<=3) then
   begin
   str(channel,ca);
   {lecture temperature}
   commande('R'+ca+#13) {;memo1.lines.add('rat'); };
   readvalue(reponse);
   ErrBox.lines.add (reponse);
   chaine:=reponse;
   chaine:=copy(chaine,2,length(chaine)-2);
   TempBox.caption:=chaine; {a reformater en nombre}
   val(TempBox.caption,nombre,err);
   if err=0 then result:=nombre else result:=9999;
   end
   else begin result:=9999;messagebox(handle,'Channel non disponible sur ITC4','Attention!',mb_ok) end;
   TempBox.caption:=floattostr(result);
   ITC5LastReadTemperature:=result;

end;


procedure TITC5.setTemperature_ITC5(Tempera:real);
var
   ca:string; indice:integer;
   tempera1,tempera2:real;
   s:string;
begin
{ajout Alloul : limite en temperature  5K-400K}
   if (tempera>0) and (tempera<400) then
   begin
    commande('C3'+#13); {passage en remote}
    str(tempera:8:8,ca);
    s:='T'+ca+#13;
    commande(s);
    {on relit sur l'ITC5le parametre TSet qu'on vient d'envoyer}

   end
                       else
    boitnoir.receivetext('ATTENTION, LIMITE EN TEMPERATURE DEPASSEE, CONSIGNE NON EXECUTEE');

end;


procedure TITC5.SetTempBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then
          begin
        SetTemperature_ITC5(SetTempBox.value);
        settempbox.Text:='';
        end;
end;

procedure TITC5.ChangeToRemoteClick(Sender: TObject);
begin
 commande('C3'+#13);
end;

procedure TITC5.SetHeaterManualGasManual;
begin
 commande('A0'+#13);
end;

procedure TITC5.SetHeaterManualGasAuto;
begin
 commande('A2'+#13);
end;

procedure TITC5.SetHeaterAutoGasAuto;
begin
 commande('A3'+#13);
end;

procedure TITC5.SetHeaterAutoGasManual;
begin
 commande('A1'+#13);
 commande('A1'+#13);
end;

procedure TITC5.ChangeToLocalClick(Sender: TObject);
begin
 commande('C2'+#13);
end;

procedure TITC5.ChangeHeaterStatusClick(Sender: TObject);
begin
RafraichirITC5;
{xxx ca ne marche pas du tout ce qui suit... Et pas non plus la lecture du status
des Auto et Manual via le X de}
if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='AUTO')
         then SetHeaterManualGasAuto;
if (heaterstatus.caption='MANUAL') and (gazflowstatus.caption='AUTO')
         then SetHeaterAutoGasAuto;
if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='MANUAL')
         then SetHeaterManualGasManual;
if (heaterstatus.caption='MANUAL') and (gazflowstatus.caption='MANUAL')
         then SetHeaterAutoGasManual;
RafraichirITC5;

         end;

procedure TITC5.ChangeGazFlowStatusClick(Sender: TObject);
begin
RafraichirITC5;
if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='AUTO')
         then SetHeaterAutoGasManual;
if (heaterstatus.caption='MANUAL') and (gazflowstatus.caption='AUTO')
         then SetHeaterManualGasManual;
if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='MANUAL')
         then SetHeaterAutoGasAuto;
if (heaterstatus.caption='MANUAL') and (gazflowstatus.caption='MANUAL')
         then SetHeaterManualGasAuto;
RafraichirITC5;
end;

procedure TITC5.HeaterLevelBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x:real;err:integer;y:integer;
begin
  if  Key=13 then
  begin
     val(HeaterLevelBox.text,x,err);
     x:=round(x*10)/10;
     if err=0 then
       begin
       RafraichirITC5;
       {passage en manuel}
       if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='AUTO')
         then SetHeaterManualGasAuto;
       if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='MANUAL')
         then SetHeaterManualGasManual;
       {demande de la valeur}
       if (x>=0) and (x<=99.9) then setHeatervalue(x);
       end;
       heaterlevelbox.text:='';
  end;
end;


procedure TITC5.GazFlowLevelBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x:real;err:integer;
begin
      if  Key=13 then
  begin
     val(GazFlowLevelBox.text,x,err);
     x:=round(x*10)/10;
     if err=0 then
       begin
       RafraichirITC5;
       {passage en manuel}
if (heaterstatus.caption='AUTO') and (gazflowstatus.caption='AUTO')
         then SetHeaterAutoGasManual;
if (heaterstatus.caption='MANUAL') and (gazflowstatus.caption='AUTO')
         then SetHeaterManualGasManual;
       {demande de la valeur}
       if (x>=0) and (x<=99.9) then setGazFlowvalue(x);
       end;
       gazflowlevelbox.text:='';
  end;

end;

procedure TITC5.SetHeaterValue(d:real);
{d : % du max heater}
var chaine:string;
begin
    commande('C3'+#13); {passage en remote}
     str(d:3:1,chaine);
     commande('O'+chaine+#13);
end;

procedure TITC5.SetGazFlowValue(d:real);
{d : % }
var chaine:string;
begin
     commande('C3'+#13); {passage en remote}
     str(d:3:1,chaine);
     commande('G'+chaine+#13);
end;


procedure TITC5.GainIntBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then   begin
          SetIntegral_ITC5(gainIntbox.Value);
          gainintbox.text:='';end;
end;

procedure TITC5.GainDerivBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then  begin
           SetDerivative_ITC5(gainDerivbox.Value);
           gainderivbox.text:='';
           end;
end;

procedure TITC5.maxheaterKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then begin
          SetMaxHeater_ITC5(MaxHeater.Value);
          maxheater.text:='';
          end;
end;

procedure TITC5.GainPboxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then  begin
          SetProportionnal_ITC5(gainPbox.Value);
          gainPbox.Text:='';
        end;

end;

procedure TITC5.SetMaxHeater_ITC5(d:real);
var chaine:string;
begin
     commande('C3'+#13); {passage en remote}
     d:=round(d*10)/10;
     str(d:3:1,chaine);
     commande('M'+chaine+#13);
end;

procedure TITC5.SetProportionnal_ITC5(d:real);
var chaine:string;
begin
 commande('C3'+#13);     {passage en remote}
     str(d:5:5,chaine);
     commande('P'+chaine+#13);
end;
procedure TITC5.SetIntegral_ITC5(d:real);
var chaine:string;
begin
      commande('C3'+#13); {passage en remote}
     str(d:5:5,chaine);
     commande('I'+chaine+#13);
end;
procedure TITC5.SetDerivative_ITC5(d:real);
var chaine:string;
begin
     commande('C3'+#13); {passage en remote}
     str(d:5:5,chaine);
     commande('D'+chaine+#13);
end;

end.
