unit ParSeq;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, Buttons,compilRMN, ExtCtrls, xyGraph,  ComCtrls, Spin,  ToolWin,
  math, EditReal,editdata,DrapeauAlloulUnit, Comrs232, pulsedialogue;


const
  ntemps=20;
  nampli=10;
  nphase=10;

type
  TSeqpar = class(TForm)
    listseqpar: TStringGrid;
    EditSeq: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Stop: TBitBtn;
    Start: TButton;
    Status: TLabel;
    FenetreTest: TEdit;
    SansRafraichissement: TCheckBox;
    ModeAcquisitionStandard: TCheckBox;
    NomSequenceRMN: TLabel;
    openbutton: TButton;
    saveButton: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    PositionMarkerBox: TEdit;
    MarkerLengthBox: TEdit;
    CommPortDriverPulse1: TCommPortDriver;
    Timer1: TTimer;
    TableauSignesReception: TStringGrid;
    Label7: TLabel;
    Label8: TLabel;
    editSeqNew: TMemo;
    Button2: TButton;
    Sequences: TComboBox;
    editseqnoncompiled: TMemo;
    Memo1: TMemo;
    procedure ouverture;
    procedure initialisation;
    procedure affiche_parametre;
    procedure lit_parametre;
    procedure Sauver1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure StartSequenceur;
    procedure StartSequenceSpectroHetero;
    procedure Close(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SansRafraichissementClick(Sender: TObject);
    procedure ModeAcquisitionStandardClick(Sender: TObject);
    procedure OpenSerialPort;
    procedure CloseSerialPort;
    procedure StartClick(Sender: TObject);
    procedure LitBuffer0123(var Caractere:char);
    procedure listseqparEnter(Sender: TObject);
    procedure EditSeqEnter(Sender: TObject);
    procedure EditSeqNonCompiledVerEditSeqNew;
    procedure TransfertSignesREceptionDansTableau;
    procedure EditSeqNewVersEditSeq;
    procedure SauveSequence(nomfichier:string);
    procedure ChargeFichier(nomfichier:string);
    procedure Button2Click(Sender: TObject);
    procedure piSur2Simple;
    procedure piSur2PiSimple;
    procedure SequencesClick(Sender: TObject);
    procedure InitialiseSequence;
    procedure erasetableauSignesREception;
    procedure piSur2Pi2StepsPhaseRecombination;
    procedure piSur2Pi2StepsSoftRecombination;
    procedure piSur2Pi4StepsPhaseRecombination;
    procedure piSur2Pi4StepsSoftRecombination;
    procedure piSur2Pi4StepsPhaseRecombinationT1;
{    procedure piSur2Pi4StepsSoftRecombinationT1;}
{    procedure cyclop;}
    procedure piSur2PiSimpleT1;

    {procedure ecriture(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure autorisation(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);}


  private
      FTempInBuffer2              : pointer;

    { Dclarations prives}
  public
    procedure ChangeParametreSequence(nomParam:string;Valeur:real);
    procedure LitParamSeq(nomFichier:string);
    { Dclarations publiques}
end;

var
  Seqpar: TSeqpar;
  sequenceur:ptypseq;
  gain_emission:pgain_emission;

implementation

{$R *.DFM}

procedure TSeqpar.ouverture;
var result:boolean;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
SeqPar.WindowState:=WsMinimized;
SeqPar.WindowState:=WsNormal;

end;

procedure Tseqpar.initialisation;
var i:integer;
    s:string;
begin
if DrapeauSpectroHomodyne=true then
      begin
      DrapeauSequenceur16VoiesRecognitionStep:=false;
      listseqpar.Cells[0,0]:='Variable';
      listseqpar.Cells[1,0]:='Delay (msec)';
      listseqpar.ColCount:=2;
      listseqpar.ColWidths[1]:=100;
      editseq.left:=200;
      for i:=1 to ntemps do seqpar.listseqpar.cells[0,i]:=chr(64+i);
      {on interdit la ligne de TF car instruction utilise pour la TF}
      SeqPar.listseqpar.cells[0,6]:='--';

      listseqpar.Width:=185;

      {initialisation de la connexion RS232 necessaire ensuite}
      CommPortDriverPulse1.ComPort:=pnCOM1; // Choose pnCOM1 or pnCOM2
      CommPortDriverPulse1.ComPortSpeed:= br57600; //9600 Bauds
      CommPortDriverPulse1.ComPortDataBits           := db8BITS; // 8 data bits
      CommPortDriverPulse1.ComPortStopBits           := sb1BITS; // 1 stop bit
      CommPortDriverPulse1.ComPortParity             := ptNONE;  // no parity
      CommPortDriverPulse1.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
      CommPortDriverPulse1.ComPortSwHandshaking      := shNONE;
      label3.visible:=false;label4.visible:=false;label5.visible:=false;
      MarkerLengthBox.visible:=false;PositionMarkerBox.visible:=false;
      end;
if DrapeauSpectroOldHetero=true then
      begin
      listseqpar.ColCount:=3;
      editseq.left:= 288;
      {Initialisation de la Fentre Paramtre}
      listseqpar.Cells[0,0]:='Variable';
      seqpar.listseqpar.cells[1,0]:='Delay';
      seqpar.listseqpar.cells[2,0]:='Ampli';
      seqpar.listseqpar.cells[3,0]:='Phase';
      label3.visible:=true;label4.visible:=true;label5.visible:=true;
      MarkerLengthBox.visible:=true;PositionMarkerBox.visible:=true;
      for i:=1 to ntemps do seqpar.listseqpar.cells[0,i]:=chr(64+i);
      {Initialisation des gains pour l'emission (utiliss dans compilRMN.Pas}
      new(gain_emission);
      gain_emission^[0]:=0;
      for i:=1 to 2000 do gain_emission^[i]:=round(sqrt(i*100.00)*4095.0/sqrt(2000.00*100));
      end;

end;



procedure Tseqpar.affiche_parametre;
var i:integer;
    s:string;
    temps_ms:real;
begin
for i:=1 to ntemps do
    begin
         temps_ms:=sequenceur^.temps[i].val/10000;
         {On ne veut pas afficher de zros inutiles}
         if frac(temps_ms*1000)>=0.1 then
            str(temps_ms:9:4,s)
            else
            if frac(temps_ms*100)>=0.1 then
            str(temps_ms:9:3,s)
                else
                if frac(temps_ms*10)>=0.1 then
                str(temps_ms:9:2,s)
                    else
                    if frac(temps_ms)>=0.1 then
                          str(temps_ms:9:1,s)
                          else str(temps_ms:9:0,s);
          {str(sequenceur^.temps[i].val,s);}
          seqpar.listseqpar.cells[1,i]:=s;
    end;
for i:=1 to nampli do
    begin
         str(sequenceur^.ampli[i].val,s);
         seqpar.listseqpar.cells[2,i]:=s;
    end;

for i:=1 to nphase do
    begin
         str(sequenceur^.phase[i].val,s);
         seqpar.listseqpar.cells[3,i]:=s;
    end;

end;

procedure Tseqpar.EditSeqNonCompiledVerEditSeqNew;
{convertit l'instruction PULSE, WAIT,  et l'instruction WAIT}

var Instructions,chaines:array[1..1000] of string;
    BitA,BitB:array[0..15] of integer;
    Duree:extended;
    numero,NumeroLettre,temps,err,err2,NbSteps,i,j,nb,nb2:integer;
    s,s2,s3,sTemps,chaine,previousinstruction:string;
    DrapeauPhase,drapeau,DrapeauErreur,TimeOut,DrapeauSingleInstruction:boolean;
    Caractere:char;
    nombre,nombre2,StartTime,TempsBis:extended;
    nombrez,errZ,numinstruction,BitsPoidsFaibleVoieA,BitsPoidsFaibleVoieB:integer;
    numero2:integer;chaine1,chaine2:string;
    ProduitTempsParAmplitude,temps1,temps2:extended;
    ChainePrecedente,chainedepart,phaseS,amplitudeS,dureeS:string;
    DrapeauPhaseP,DrapeauMettreGainAZero,drapeauCalculerTempsRepetition:boolean;

begin
j:=0;
editseqnew.Lines.Clear;
DrapeauMettreGainAZero:=false;
drapeauPhaseP:=false;
for i:=0 to (EditSeqNonCompiled.Lines.Count-1) do
   begin
   {si deux instructions de phase se suivent, on met un delai entre les deux de 100 nsec}
    
    chainedepart:=EditSeqNonCompiled.Lines[i];
    {on remplace TRIGACQ par CA : on supp trigger sur canal A}
    if pos('TRIGACQ',chainedepart)>0 then
       begin
       {si pas de delai avant TRIGACQ, on en ajoute un de 1 microsec}
       if copy(chainedepart,1,1)<>'T' then
          chainedepart:='T0.001'+chainedepart;
       chainedepart:=copy(chainedepart,1,pos('TRIGACQ',chainedepart)-1)+
              'CA'+copy(chainedepart,pos('TRIGACQ',chainedepart)+7,length(chainedepart)-pos('TRIGACQ',chainedepart)-7+1);
       end;
    {on remplace TTLA, TTLB,... par CA, CB...}
    if pos('TTLA',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLA',chainedepart)-1)+
              'CA'+copy(chainedepart,pos('TTLA',chainedepart)+4,length(chainedepart)-pos('TTLA',chainedepart)-4+1);
       end;
    if pos('TTLB',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLB',chainedepart)-1)+
              'CB'+copy(chainedepart,pos('TTLB',chainedepart)+4,length(chainedepart)-pos('TTLB',chainedepart)-4+1);
       end;
    if pos('TTLC',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLC',chainedepart)-1)+
              'CC'+copy(chainedepart,pos('TTLC',chainedepart)+4,length(chainedepart)-pos('TTLC',chainedepart)-4+1);
       end;
    if pos('TTLD',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLD',chainedepart)-1)+
              'CD'+copy(chainedepart,pos('TTLD',chainedepart)+4,length(chainedepart)-pos('TTLD',chainedepart)-4+1);
       end;
    if pos('TTLE',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLE',chainedepart)-1)+
              'CE'+copy(chainedepart,pos('TTLE',chainedepart)+4,length(chainedepart)-pos('TTLE',chainedepart)-4+1);
       end;
    if pos('TTLF',chainedepart)>0 then
       begin
       chainedepart:=copy(chainedepart,1,pos('TTLF',chainedepart)-1)+
              'CF'+copy(chainedepart,pos('TTLF',chainedepart)+4,length(chainedepart)-pos('TTLF',chainedepart)-4+1);
       end;

    if chainedepart<>'' then
    begin
    {transfo en majuscules, ajout point virgule}
    if (pos(';',chainedepart)=0) then chainedepart:=chainedepart+';';
    chainedepart:=AnsiUpperCase(chainedepart);
    chainedepart:=copy(chainedepart,1,pos(';',chainedepart));
    {instruction PULSE(duree,amplitude,phase) ou PULSE2(duree,amplitude,phase)
    si phase non specifiee, on met 0
    Fait un pulse avec duree,amplitude,phase sur voie principale ou secondaire}

    if (pos('PULSE',chainedepart)>0) then
       begin
       chaine:=chainedepart;
       chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-8);
       dureeS:=copy(chaine,1,pos(',',chaine)-1);
       chaine:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
       if pos(',',chaine)=0 then begin amplitudeS:=chaine;phaseS:='0';end
                            else
                            begin
                            amplitudeS:=copy(chaine,1,pos(',',chaine)-1);
                            phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                            end;
         if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then
                               begin dureeS:=copy(dureeS,2,1);end
                               else
                               begin
                               {on convertit en 1/10 de microsec le delai}
                               val(dureeS,nombre,errZ);
                               if (errZ=0) then
                               begin nombreZ:=round(nombre*10000);
                            {         dureeS:=inttostr(nombreZ);}
                               end;
                               end;



         if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
         {if (length(amplitudeS)=2) and (copy(amplitudeS,1,1)='A') then amplitudeS:=copy(amplitudeS,2,2);
          }
       if (drapeauPhaseP=true) then  editseqnew.lines.add('T0.0001;');
       editseqnew.lines.Add('T0.003,CE,GA0,PB'+PhaseS+';');
       editseqnew.lines.Add('T'+dureeS+',CE,GA'+amplitudeS+';');
       drapeauPhaseP:=false;
       DrapeauMettreGainAZero:=true;
       end
         else
       begin
         if (pos('WAIT',chainedepart)>0) then
            {instruction WAIT(duree,phase) or WAIT(duree) and phase=0}
            begin
            chaine:=chainedepart;
            chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-7);
            if pos(',',chaine)=0 then begin dureeS:=chaine;
                                            phaseS:='xx';
                                      end
                                      else
                                      begin
                                      dureeS:=copy(chaine,1,pos(',',chaine)-1);
                                      phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                                      end;
         if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then begin dureeS:=copy(dureeS,2,1);end
                               else
                               begin
                               {on convertit en 1/10 de microsec le delai}
                               val(dureeS,nombre,errZ);
                               if (errZ=0) then
                               begin nombreZ:=round(nombre*10000);
                          {           dureeS:=inttostr(nombreZ);}
                               end;
                               end;

         if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
         if (length(amplitudeS)=2) and (copy(amplitudeS,1,1)='A') then amplitudeS:=copy(amplitudeS,2,1);

            if DrapeauMettreGainAZero=true then
                    begin
                    if phaseS='xx' then begin editseqnew.lines.Add('T'+dureeS+',GA0;');drapeauPhaseP:=false;end;
                    if phaseS<>'xx' then
                          begin
                                 if (drapeauPhaseP=true) then  editseqnew.lines.add('T0.0001;');
                                 editseqnew.lines.Add('T'+dureeS+',PB'+phaseS+',GA0;');drapeauPhaseP:=true;
                          end;
                    DrapeauMettreGainAZero:=false;
                    end
                    else
                    begin
                    if phaseS='xx' then  begin editseqnew.lines.Add('T'+dureeS+';');drapeauPhaseP:=false;end;
                    if phaseS<>'xx' then
                        begin
                               if (drapeauPhaseP=true) then  editseqnew.lines.add('T0.0001;');
                                editseqnew.lines.Add('T'+dureeS+',PB'+phaseS+';');drapeauPhaseP:=true;
                        end;
                    end;
            end
            else
            begin
            if drapeauMettreGainAZero=true then
               begin
               chainedepart:=copy(chainedepart,1,pos(';',chainedepart)-1)+',GA0;';
               editseqnew.lines.add(chainedepart);
                  ChainePrecedente:=chainedepart;
               DrapeauMettreGainAZero:=false
               end
               else
               begin
               editseqnew.lines.add(chainedepart);
               ChainePrecedente:=chainedepart;
               end;
            end;
         end;
   end;


   end;
   editseqnew.lines.add('J.'); {ordre de bouclage}
end;



procedure Tseqpar.EditSeqNewVersEditSeq;
{transforme editseqnew vers editseq pour etre dans le
format Fermon precedent}
var drapeauPhase,i,j,nombre2,err:integer;
    chaine,chaine2,chaine3:string;
    nombre:extended;


begin
drapeauPhase:=-10;
if editseq.lines.count<editseqnew.lines.count then
   begin
   for i:=editseq.lines.count to (editseqnew.lines.count-1) do
         editseq.lines.add(';');
   end;

if editseq.lines.count>editseqnew.lines.count then
   begin
   j:=editseq.lines.count-1;
   for i:=editseqnew.lines.count to (j) do
         editseq.lines.Delete(j-i+editseqnew.lines.count);
   end;

for i:=0 to (editseqnew.lines.count-1) do
  begin
  chaine:=editseqnew.lines[i];
  if pos(';',chaine)>0 then chaine:=copy(chaine,1,pos(';',chaine));
  editseq.lines[i]:=chaine;
  {conversion de toute instruction du type T0.04
  o 0.04 msec est converti en 1/10 de microsec}
  if (pos('T',chaine)=1) then
        begin
        val(copy(chaine,2,1),nombre,err);
        if (err=0) then
              begin
              {on extrait le nombre de la chaine}
              chaine2:=copy(chaine,2,length(chaine)-1);
              repeat
                val(chaine2,nombre,err);
                chaine2:=copy(chaine2,1,length(chaine2)-1);
              until (err=0) or (length(chaine2)<=1);

              nombre2:=round(nombre*10000);
              if (nombre=round(nombre)) then
                    chaine:='T'+inttostr(nombre2)+copy(chaine,length(chaine2)+3,length(chaine)-length(chaine2)-1)
                                        else
                    chaine:='T'+inttostr(nombre2)+copy(chaine,length(chaine2)+3,length(chaine)-length(chaine2));
              editseq.lines[i]:=chaine;
              {verification si pulse trop long vis  vis de duree  faire ici}


              end;
        end;
  {conversion d'instructions de phase du type PB180 en PB1801}
  if (pos('P',chaine)>0) then
        begin
        val(copy(chaine,pos('P',chaine)+2,1),nombre,err);
        if err=0 then
             begin
             if (drapeauPhase=(i-1)) then
                begin
                MessageDlg('Error : two consecutive lines contain a phase instruction', mtWarning, [mbOk], 0);
                exit;
                end;
             drapeauPhase:=i;
             {on extrait le nombre de la chaine}
              chaine2:=copy(chaine,pos('P',chaine)+2,length(chaine)-pos('P',chaine)-1);
              chaine3:=chaine2;
              repeat
                val(chaine2,nombre,err);
                chaine2:=copy(chaine2,1,length(chaine2)-1);
              until (err=0) or (length(chaine2)<=1);
              nombre2:=round(nombre);
              chaine:=copy(chaine,1,pos('P',chaine)+1)+inttostr(nombre2)+'1'+
                  copy(chaine3,length(inttostr(nombre2))+1,length(chaine3)-length(inttostr(nombre2)));
              editseq.lines[i]:=chaine;
              end;
        end;
  end;

end;

procedure TSeqPar.ChangeParametreSequence(nomParam:string;Valeur:real);
    { mets Valeur dans la case de nomParam : appel
    depuis interpreteur}
var i,numColonne,numLigne:integer;

begin
   numLigne:=0;   numColonne:=0;
   {on repere la colonne}
   {on repere le numero de ligne correspondant a la lettre : A,B,C...}
   for i:=1 to 26 do if chr(64+i)=copy(nomParam,2,1) then numLigne:=i;
   {on change seulement si c'est bien crit}
   if numLigne<>0 then
   begin
     if copy(nomParam,1,1)='T' then sequenceur^.temps[numligne].val:=round(valeur*1e4);
     if copy(nomParam,1,1)='A' then sequenceur^.ampli[numligne].val:=round(valeur);
     if copy(nomParam,1,1)='P' then sequenceur^.phase[numligne].val:=round(valeur);
     affiche_parametre;
   end;

   if (numLigne=0) then MessageDlg('Erreur in the command of type TA, PA...', mtWarning, [mbOk], 0);
  if (copy(nomParam,1,1)<>'T' ) and (copy(nomParam,1,1)<>'A' ) and (copy(nomParam,1,1)<>'P' )
      then MessageDlg('Erreur in the command of type TA, PA...', mtWarning, [mbOk], 0);
end;

procedure Tseqpar.lit_parametre;
var i,j,err:integer;
    s:string;
    temps_ms:real;
begin
for i := 1 to ntemps do
    begin
      if seqpar.listseqpar.cells[1,i]='' then
              begin
              sequenceur^.temps[i].val:=0;
              err:=0;
              end
         else
              begin
              val(seqpar.listseqpar.cells[1,i],temps_ms,err);
              sequenceur^.temps[i].val:=round(temps_ms*10000);
              {val(seqpar.listseqpar.cells[1,i],sequenceur^.temps[i].val,err);}
              end;
      if err<>0 then MessageDlg('Erreur in the time parameters', mtWarning, [mbOk], 0);
    end;
for i := 1 to nampli do
    begin
      if seqpar.listseqpar.cells[2,i]='' then sequenceur^.ampli[i].val:=0
         else val(seqpar.listseqpar.cells[2,i],sequenceur^.ampli[i].val,err);
      if err<>0 then MessageDlg('Erreur in the amplitude parameter', mtWarning, [mbOk], 0);
    end;
for i := 1 to nphase do
    begin
      if seqpar.listseqpar.cells[3,i]='' then sequenceur^.phase[i].val:=0
         else val(seqpar.listseqpar.cells[3,i],sequenceur^.phase[i].val,err);
      if err<>0 then MessageDlg('Erreur in the phase parameters', mtWarning, [mbOk], 0);
    end;
end;

procedure Sauvegarde(filename:string);
{sauve la sequence de pulses, en sauvant a la fois fichier.txt et fichier.seq
ici, filename est le fichier.txt}
var filepara:string;
     fich2:textfile;i:integer;
    fich:file of typseq;
    chaine:string;

begin
       dispose(sequenceur);
       sequenceur:=new(ptypseq);
       {sauvegarde du sequenceName.txt}
       {format de sauvegarde du type :

OldHeteroSpectrometer
T0.001,CF;
T0.005,CA;
T0.003,CE;
TA,CE,GAAA;
TC,GA0;
TR,GA0,PB0;

J.
NUMBER OF STEPS FOR ACQUISITION :
1
step 1
+X
+Y}
      seqpar.EditSeqNonCompiledVerEditSeqNew;
      seqpar.EditSeqNewVersEditSeq;

      if (copy(filename,length(filename)-3,4)<>'.txt') then filename:=filename+'.txt';
      assignfile(fich2,filename);
      rewrite(fich2);
      writeln(fich2,'OldHeteroSpectrometer');
      for i:=0 to seqpar.editseqNonCompiled.Lines.Count-1 do
          writeln(fich2,seqpar.editseqNonCompiled.lines[i]);
      writeln(fich2,'NUMBER OF STEPS FOR ACQUISITION :');
      writeln(fich2,inttostr(NombreStepsPourReception));
      if (NombreStepsPourReception>0) then
            begin
            for i:=1 to NombreStepsPourReception do
                       begin
                       writeln(fich2,'step '+inttostr(i));
                       writeln(fich2,seqpar.TableauSignesReception.cells[1,i]);
                       writeln(fich2,seqpar.TableauSignesReception.cells[2,i]);
                       end;
            end;
      if SeqPar.SansRafraichissement.state=cbChecked then writeln(fich2,'no refreshing during acquisition');
      closefile(fich2);
      SeqPar.NomSequenceRMN.caption:=filename;
      {sauve le nom de la sequence dans Parametres RMN.txt}
      EcritDansParametresRMN('Last Pulse Sequence',filename);

       {sauvegarde du fichier.seq}
       filename:=copy(filename,1,length(filename)-4)+'.seq';
       seqpar.EditSeq.Lines.SaveToFile(Filename);
       filepara:=copy(Filename,1,length(Filename)-4);
       for i:=1 to 50 do sequenceur^.NomSeq[i]:=' ';
       strpcopy(sequenceur^.NomSeq,filepara);{sequenceur^.NomSeq est le nom de la squence sans extension}
       filepara:=filepara+'.par';
       seqpar.lit_parametre;{Lit les parametres de la fentre}
       {Sauvegarde des parametres sequence dans *.par}
       assignfile(fich,filepara);
       rewrite(fich);
       write(fich,sequenceur^);
       closefile(fich);
end;

procedure TSeqpar.Sauver1Click(Sender: TObject);
var nomFichier:string;
begin
    If Savedialog1.execute then
    begin
      sauvegarde(SaveDialog1.Filename);
      compilo(sequenceur,gain_emission);
    end;
end;

procedure TSeqPar.SauveSequence(nomfichier:string);
{sauve le fichier nomfichier qui est du type sequence.txt}
var  filepara:string;
    fich2:textfile;i:integer;
begin
{format de sauvegarde du type :

OldHeteroSpectrometer
T0.001,CF;
T0.005,CA;
T0.003,CE;
TA,CE,GAAA;
TC,GA0;
TR,GA0,PB0;

J.
NUMBER OF STEPS FOR ACQUISITION :
1
step 1
+X
+Y}
{sauvegarde de la sequence.txt}
      if (copy(nomFichier,length(nomFichier)-3,4)<>'.txt') then nomFichier:=nomFichier+'.txt';
      assignfile(fich2,nomfichier);
      rewrite(fich2);
      writeln(fich2,'OldHeteroSpectrometer');
      for i:=0 to editseqNew.Lines.Count-1 do
          writeln(fich2,editseqNew.lines[i]);
      writeln(fich2,'NUMBER OF STEPS FOR ACQUISITION :');
      writeln(fich2,inttostr(NombreStepsPourReception));
      if (NombreStepsPourReception>0) then
            begin
            for i:=1 to NombreStepsPourReception do
                       begin
                       writeln(fich2,'step '+inttostr(i));
                       writeln(fich2,TableauSignesReception.cells[1,i]);
                       writeln(fich2,TableauSignesReception.cells[2,i]);
                       end;
            end;
      closefile(fich2);
      SeqPar.NomSequenceRMN.caption:=nomFichier;
      {sauve le nom de la sequence dans Parametres RMN.txt}
      EcritDansParametresRMN('Last Pulse Sequence',nomFichier);

end;



procedure TSeqpar.Ouvrir1Click(Sender: TObject);
{ouvre une sequence.txt}
var filepara:string;
    fich:file of typseq;fich2:textfile;
    i:integer;nomFichier,chaine:string;
       chaineTableau:array[0..100] of string;
begin
  if OpenDialog1.execute then
    begin
    if FileExists(OpenDialog1.Filename) then
       begin
       if DrapeauSpectroOldHetero=true then
          begin
            {lit le fichier}
            chaine:=copy(OpenDialog1.Filename,1,length(OpenDialog1.Filename)-4)+'.bin';
            if fexis(chaine) then LitParamSeq(OpenDialog1.Filename);
            {sauve le nom de la sequence dans Parametres RMN.txt}
            EcritDansParametresRMN('Last Pulse Sequence',OpenDialog1.Filename)
          end;
       end;
    end;
    DrapeauSeqParHasBeenChanged:=true;
end;

procedure Tseqpar.chargefichier(nomfichier:string);
{ici nomfichier de la forme sequence.txt}
var filepara:string;
    fich2:textfile;
    err,i:integer;
    chaine:string;nombre:extended;
    drapeau:boolean;
   chaineTableau:array[0..100] of string;
begin

    if FExis(nomfichier) then
       begin

           {verifie si bon format}

           assignfile(fich2,nomfichier);
           reset(fich2);
           drapeau:=false;
           readln(fich2,chaine);

           if (chaine='OldHeteroSpectrometer') then
           begin
           {lit le fichier}
            seqpar.editseqnew.Clear;
           {lecture des instructions}
            while not eof(fich2) and (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') do
                 begin
                 readln(Fich2,chaine);
                 if (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') then editseqnoncompiled.lines.Add(chaine);
                 end;

           {lecture des aiguillages du mode d'acquisition}
           readln(fich2,chaine);{nombre d'aiguillages}
           nombre:=0;
           val(chaine,nombre,err);
           if nombre>0 then
              begin
              NombreStepsPourReception:=round(nombre);
              for i:=1 to round(Nombre) do
                       begin
                       readln(fich2,chaine);
                       readln(fich2,chaine);
                       TableauSignesReception.cells[1,i]:=chaine;
                       readln(fich2,chaine);
                       TableauSignesReception.cells[2,i]:=chaine;
                       end;
              for i:=round(Nombre+1) to 16 do
                       begin
                       TableauSignesReception.cells[1,i]:='';
                       TableauSignesReception.cells[2,i]:='';
                       end;
              TableauSignesREception.Visible:=true;
              DrapeauSequenceurTimeCheck:=true;
              modeacquisitionstandard.State:=cbunchecked;
              end
              else
              begin
              TableauSignesREception.Visible:=false;
              DrapeauSequenceurTimeCheck:=false;
              modeacquisitionstandard.State:=cbchecked;
              end;
              while not eof(fich2) do
                 begin
                 readln(fich2,chaine);
                 if pos('no refresh',chaine)>0 then
                                               begin
                                               SeqPar.SansRafraichissement.state:=cbChecked;
                                               DrapeauSansRafraichissement:=true;
                                               end;
                 end;


            closefile(fich2);
            SeqPar.NomSequenceRMN.caption:=nomFichier;
            seqpar.EditSeqNonCompiledVerEditSeqNew;
            seqpar.EditSeqNewVersEditSeq;
            {sauve le nom de la sequence dans Parametres RMN.txt}
            EcritDansParametresRMN('Last Pulse Sequence',nomfichier);
            end;
       end;
end;


procedure TSeqpar.LitParamSeq(nomFichier:string);
{Lecture parametre sequenceur contenus dans .txt,.seq,.bin,.par
ici, nomFichier est de la fome sequence.txt}
var filepara:string;
    fich:file of typseq;
    i:integer;
begin
         NombreStepsPourReception:=0;
         for i:=1 to 16 do
            begin
               TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
               TableauSignesReception.cells[1,i]:='';
               TableauSignesReception.cells[2,i]:='';
            end;

         Seqpar.ChargeFichier(nomfichier); {charge en face avant tous les
         parametres et tableau de signe et sequence elle meme}
{        EditSeqNew.Lines.LoadFromFile(nomFichier);}
         NomSequenceRMN.caption:=nomFichier;
         nomFichier:=copy(nomFichier,1,length(nomFichier)-4)+'.seq';
         dispose(sequenceur);
         sequenceur:=new(ptypseq);
         filepara:=copy(nomFichier,1,length(nomFichier)-4);
         for i:=1 to 50 do sequenceur^.NomSeq[i]:=' ';
         strpcopy(sequenceur^.NomSeq,filepara);{sequenceur^.NomSeq est le nom de la squence sans extension}
         filepara:=filepara+'.par';

         if FileExists(filepara) then
                  begin
                       assignfile(fich,filepara);{par is the parameters saving}
                       reset(fich);
                       read(fich,sequenceur^);
                       closefile(fich);
                  end;
                  affiche_parametre; {affiche les parametres dans fenetre sequenceur}
end;



procedure TSeqpar.StopClick(Sender: TObject);
var s:string;
begin
if DrapeauSpectroOldHetero=true then
      begin
      {On s'arrete}
        stopseqo;
        Status.caption:='Sequence stopped';
      end;
if DrapeauSpectroHomodyne=true  then
     begin
      {On s'arrete}
       SeqPar.openSerialPort;
       s:='C'+#13;
       CommPortDriverPulse1.SendData( pchar(s),length(s));
       SeqPar.closeSerialPort;
       Status.caption:='Sequence stopped';
      end;

end;

procedure TSeqpar.StartSequenceur;

begin
if DrapeauSpectroOldHetero=true then StartSequenceSpectroHetero;
end;


procedure TSeqpar.StartSequenceSpectroHetero;
var nb,numero2,i,j,err2,numero,err:integer;chaine,chaine1,chaine2,s,s2:string;
    tempsbis,temps1,nombre,temps2:extended;
        drapeauCalculerTempsRepetition:boolean;
begin

    {on arrondit toutes les durees dans le tableau d au fait qu'on n'est pas meilleur en precision que 100nsec}
     for i:=1 to ntemps do
         begin
         val(listseqpar.Cells[1,i],nombre,err);
         if err=0 then
                  begin
                  nombre:=round(nombre*10000)/10000;
                  str(nombre:8:8,chaine);
                  for j:=1 to 8 do
                    if copy(chaine,length(chaine),1)='0' then
                     chaine:=copy(chaine,1,length(chaine)-1);
                  if copy(chaine,length(chaine),1)='.' then chaine:=
                  copy(chaine,1,length(chaine)-1);;

                  listseqpar.cells[1,i]:=chaine;
                  end;
         end;

    TransfertSignesREceptionDansTableau;

    {calcul du temps de repetition entre deux triggers gage}
    drapeauCalculerTempsRepetition:=false;
    TempsRepetition:=0;
    {on lit chaque instruction de EditSeqNew}
    for i:=0 to (EditSeqNew.Lines.Count-1) do
     begin
      s:=EditSeqNew.Lines[i];
      {si c'est un trigger, on repere pour evaluer TempsRepetition}
      if (pos('CA',s)>0) or (pos('TRIGACQ',s)>0) then
          begin
          drapeauCalculerTempsRepetition:=true;
          if (tempsrepetition>0) then drapeauCalculerTempsRepetition:=false;
          end;
      if DrapeauCalculerTempsRepetition=true then
          begin
          if copy(s,1,1)='T' then
            begin
            val(copy(s,2,1),tempsbis,err);
            {cas de T0.05}
            if err=0 then begin
                       if pos(',',s)>0 then  s2:=copy(s,2,pos(',',s)-2)
                                       else s2:=copy(s,2,pos(';',s)-2);
                       val(s2,tempsbis,err2);
                       end;
            {cas de TA,TB,TC...}
            if err<>0 then begin
                        s2:=copy(s,2,1);
                        if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                        if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                        if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                        if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                        if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                        if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                        if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                        if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                        val(listseqpar.Cells[1,nb],tempsBis,err2);
                        end;
            tempsrepetition:=tempsrepetition+tempsbis;
            end;
          end;
     end;


    {ICI, JE SUPPOSE QUE DES QUE NB DE STEPS POUR RECEPTION EST >1,
    J'ACTIVE LE TIMECHECK, mais pas si evident si on veut repeter
    tres tres vite et qu'on ne fait pas de soustraction soft}
    if (DrapeauModeAcquisition16pulses=true) or (DrapeauModeAcquisition4pulses=true)
       or (DrapeauModeAcquisition2pulses=true) or (DrapeauModeAcquisitionCyclop=true)
       or (NombreStepsPourReception>1) then
      begin
      DrapeauSequenceurTimeCheck:=true;
      if tempsrepetition=0 then MessageDlg('PROBLEM with the delay between 2 trigger box: check that you put TRIGACQ instruction in sequence', mtWarning, [mbOk], 0);
      end
      else DrapeauSequenceurTimeCheck:=false;

   {On compile et lance la sequence  partir de compilRMN.pas
   Attention : compilo ne renvoie pas de valeurs boolennes}
   lit_parametre;
   {on ne demarre la sequence que si il y a qq chose dedans}
   if fexis(sequenceur^.Nomseq+'.seq') then
     begin
     if (DrapeauSeqParHasBeenChanged=true) then
        begin
        sauvegarde(sequenceur^.Nomseq+'.txt'); {sauve les parametres de la sequence et la sequence}
        compilo(sequenceur,gain_emission);
        end;
     Status.caption:='Sequence running';
     chargeseqo(sequenceur);deparseqo;
     DrapeauSeqParHasBeenChanged:=false;
     end
        else
     MessageDlg('No selected sequence - Try to first do SAVE AS and start again', mtWarning, [mbOk], 0);

   positionmarkerSeq:=0;markerLengthSeq:=0;
   val(positionmarkerBox.text,PositionMarkerSeq,err);
   val(markerLengthBox.text,markerLengthSeq,err);
   if (positionmarkerSeq>0) and (markerLengthSeq>0) then
                         DrapeauIterationMarkerSeq:=true
                             else
                         DrapeauIterationMarkerSeq:=false;

end;


procedure TSeqpar.Close(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caNone;
  SeqPar.WindowState:=wsMinimized;
{On ne ferme pas la fentre sequenceur pour viter de slectionner par erreur deux sequences
mais on la reduit. On peut la reafficher via le menu}
end;

procedure TSeqpar.FormCreate(Sender: TObject);
var nomFichier:string;chaineTableau:array[0..100] of string;fich2:textfile;
    chaine:string;
i:integer;
begin
   DrapeauSeqParHasBeenChanged:=true;
   Initialisation;

   {TableauSigne : initialisation du tableau des signes de reception}
   TableauSignesReception.cells[1,0]:='0';
   TableauSignesReception.cells[2,0]:='90';
   TableauSignesReception.cells[0,0]:='step';
   for i:=1 to 16 do TableauSignesReception.cells[0,i]:=inttostr(i);
   TableauSignesReception.cells[1,1]:='+X';
   TableauSignesReception.cells[2,1]:='+Y';
   TransfertSignesREceptionDansTableau;
   PiSur2Pidialogue.label6.caption:='pulse amplitude (0-2000)';
   Sequences.items.clear;
   Sequences.items.add('pi/2');
   Sequences.items.add('pi/2-pi simple');
   Sequences.items.add('pi/2-pi 2 steps phase recombination');
   Sequences.items.add('pi/2-pi 2 steps soft recombination');
   Sequences.items.add('pi/2-pi 4 steps phase recombination');
   Sequences.items.add('pi/2-pi 4 steps soft recombination');
   Sequences.items.add('pi/2-pi 4 steps phase recombination T1');
   Sequences.items.add('pi/2-pi 4 steps soft recombination T1');
   Sequences.items.add('cyclop');
   Sequences.items.add('pi/2-pi T1');


  {relit la derniere sequence sauve dont le nom est dans Parametres RMN.txt}
   nomfichier:=LitDansParametresRMN('Last Pulse Sequence');

   if fexis(nomfichier) then
               begin
               chaine:=copy(nomfichier,1,length(nomfichier)-4)+'.bin';
               if fexis(nomfichier) then LitParamSeq(nomFichier)
                                    else piSur2PiSimple; {si le fichier n'existe pas on fait pi/2 pi}
               end
               else piSur2PiSimple; {si le fichier n'existe pas on fait pi/2 pi}

end;

procedure TSeqpar.TransfertSignesREceptionDansTableau;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   if (TableauSignesReception.cells[1,i]='+X') or (TableauSignesReception.cells[1,i]='X')
                                               then TableauSignesReceptionNMR[1][i]:=1;
   if (TableauSignesReception.cells[1,i]='+Y') or (TableauSignesReception.cells[1,i]='Y')
                                               then TableauSignesReceptionNMR[1][i]:=2;
   if (TableauSignesReception.cells[1,i]='-X') then TableauSignesReceptionNMR[1][i]:=3;
   if (TableauSignesReception.cells[1,i]='-Y') then TableauSignesReceptionNMR[1][i]:=4;

   if (TableauSignesReception.cells[2,i]='+X') or (TableauSignesReception.cells[2,i]='X')
                                               then TableauSignesReceptionNMR[2][i]:=1;
   if (TableauSignesReception.cells[2,i]='+Y') or (TableauSignesReception.cells[2,i]='Y')
                                               then TableauSignesReceptionNMR[2][i]:=2;
   if (TableauSignesReception.cells[2,i]='-X') then TableauSignesReceptionNMR[2][i]:=3;
   if (TableauSignesReception.cells[2,i]='-Y') then TableauSignesReceptionNMR[2][i]:=4;

   if (TableauSignesReceptionNMR[1][i]<>0) and (TableauSignesReceptionNMR[2][i]<>0)
               then  NombreStepsPourReception:=NombreStepsPourReception+1;
   end;
end;

procedure TSeqpar.SansRafraichissementClick(Sender: TObject);
begin
   if SansRafraichissement.State=cbChecked then
         begin
         DrapeauSansRafraichissement:=true;
         end
   else DrapeauSansRafraichissement:=false;
end;

procedure TSeqpar.ModeAcquisitionStandardClick(Sender: TObject);
begin
  if ModeAcquisitionStandard.State=cbChecked then
         begin
         TableauSignesREception.Visible:=false;
         DrapeauSequenceurTimeCheck:=false;
         end
         else
         begin
         TableauSignesREception.Visible:=true;
         DrapeauSequenceurTimeCheck:=true;
         end;

end;


procedure TSeqpar.OpenSerialPort;
begin
  GetMem( FTempInBuffer2,10);
  CommPortDriverPulse1.connect;
  CommPortDriverPulse1.FlushBuffers(true,true);
end;

procedure TSeqPar.CloseSerialPort;
begin
  commportdriverPulse1.Disconnect;
  FreeMem( FTempInBuffer2,10);
end;

procedure TSeqpar.StartClick(Sender: TObject);
begin
Seqpar.EditSeqNonCompiledVerEditSeqNew;
Seqpar.EditSeqNewVersEditSeq;
Seqpar.StartSequenceur;
end;

procedure TSeqpar.LitBuffer0123(var Caractere:char);
{va lire au buffer si caractere est '0' '1' '2' ou '3'}
var
u:integer;s1:char;
u1:double;s:string[1];
begin
  { lecture du caractere recu }
  u1:=time; { 0.00001 = 1 sec est le timeout }
  s:=' ';
  repeat
     u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then s:=strpas(Ftempinbuffer2);
  until (u1+0.00001>time) or (s='0') or (s='1') or (s='2') or (s='3');
  Caractere:=s[1];
end;

procedure TSeqpar.listseqparEnter(Sender: TObject);
begin
DrapeauSeqParHasBeenChanged:=true;
end;

procedure TSeqpar.EditSeqEnter(Sender: TObject);
begin
     DrapeauSeqParHasBeenChanged:=true;
end;




procedure TSeqpar.Button2Click(Sender: TObject);
begin
      sauvegarde(nomsequencermn.Caption);
      compilo(sequenceur,gain_emission);
end;

procedure TSeqpar.erasetableauSignesREception;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   TableauSignesReception.cells[1,i]:='';
   TableauSignesReception.cells[2,i]:='';
   end;
end;


procedure Tseqpar.InitialiseSequence;
var i:integer;
begin
editseqNonCompiled.Lines.Clear;
editseqNew.Lines.Clear;
for i:=1 to listseqpar.rowcount do
    begin
    listseqpar.cells[1,i]:='0';
    listseqpar.cells[2,i]:='0';
    listseqpar.cells[3,i]:='0';
    end;
for i:=1 to 16 do
         begin
         TableauSignesReception.cells[1,i]:='';
         TableauSignesReception.cells[2,i]:='';
         end;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
end;

procedure Tseqpar.piSur2Simple;
{sequence pi/2 simple}
var i:integer;
begin
InitialiseSequence;
pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;

pulsedialogue.piSur2PiDialogue.label2.visible:=false;
pulsedialogue.piSur2PiDialogue.label3.visible:=false;
pulsedialogue.piSur2PiDialogue.pi.visible:=false;
pulsedialogue.piSur2PiDialogue.tau.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TC, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2 simple';

end;

procedure Tseqpar.piSur2PiSimple;
{sequence pi/2 pi simple}
var i:integer;
begin
InitialiseSequence;


pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple';

end;

procedure Tseqpar.piSur2Pi2StepsPhaseREcombination;
var i:integer;
begin
InitialiseSequence;
pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;



pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';

listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
 pulsedialogue.PiSur2PiDialogue.showmodal;
editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse  phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,180); wait for TR, the repetition time, at phase 180');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple 2 steps phase recombination';

end;


procedure Tseqpar.piSur2Pi2StepsSoftREcombination;
var i:integer;
begin
InitialiseSequence;
          pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;



pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;


editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse  phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=2;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-X';
TableauSignesReception.cells[2,2]:='-Y';
ModeAcquisitionStandard.State:=cbUnChecked;
SansRafraichissement.State:=cbChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 2 steps soft recombination';

end;

procedure Tseqpar.piSur2Pi4StepsPhaseREcombination;
var i:integer;
begin
InitialiseSequence;
    
  pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,270); phase 270');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,180); phase 180');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,90); phase 90');


erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps phase recombination';
end;


procedure Tseqpar.piSur2Pi4StepsSoftREcombination;
var i:integer;
begin
InitialiseSequence;
     
pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='+Y'; {corrig par rapport  premiere version}
TableauSignesReception.cells[2,2]:='-X';
TableauSignesReception.cells[1,3]:='-X';
TableauSignesReception.cells[2,3]:='-Y';
TableauSignesReception.cells[1,4]:='-Y';
TableauSignesReception.cells[2,4]:='+X';
ModeAcquisitionStandard.State:=cbUnChecked;
SansRafraichissement.State:=cbChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps soft recombination';
end;

procedure Tseqpar.piSur2Pi4StepsPhaseREcombinationT1;
var i:integer;
begin
InitialiseSequence;
   
pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,270); phase 270');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,180); phase 180');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,90); phase 90');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps phase recombination for T1';
end;

procedure Tseqpar.piSur2PiSimpleT1;
var i:integer;
begin
InitialiseSequence;
pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';



pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLF,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple for T1';
end;

procedure Tseqpar.SequencesClick(Sender: TObject);
begin

   if Sequences.Text='pi/2' then piSur2Simple;
   if Sequences.Text='pi/2-pi simple' then piSur2PiSimple;
   if Sequences.Text='pi/2-pi 2 steps phase recombination' then piSur2Pi2StepsPhaseRecombination;
   if Sequences.Text='pi/2-pi 2 steps soft recombination' then piSur2Pi2StepsSoftRecombination;
   if Sequences.Text='pi/2-pi 4 steps phase recombination' then piSur2Pi4StepsPhaseRecombination;
   if Sequences.Text='pi/2-pi 4 steps soft recombination' then piSur2Pi4StepsSoftRecombination;
{   if Sequences.Text='pi/2-pi T1' then piSur2PiSimpleT1; }
   if Sequences.Text='pi/2-pi simple for T1' then piSur2PiSimpleT1;
   if Sequences.Text='pi/2-pi 4 steps phase recombination for T1' then piSur2Pi4StepsPhaseRecombinationT1;
 {  if Sequences.Text='pi/2-pi 4 steps soft recombination T1' then piSur2Pi4StepsSoftRecombinationT1;
   if Sequences.Text='cyclop' then cyclop;
 }
end;


end.
