unit compilRMN;

interface

uses  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,ExtCtrls;

const
  ntemps=20;
  nampli=10;
  nphase=10;


type parametre = record
     val:integer;
     valmin:integer;
     valmax:integer;
     end;

  type
{Definition du type des parmtres sequenceur}
  ptypseq=^typseq;
     typseq=record
        Temps:array[1..ntemps] of parametre;
        Ampli:array[1..nampli] of parametre;
        Phase:array[1..nphase] of parametre;
        NomSeq:array[0..50] of char;{Nom entier avec tout le chemin}{String ne marche pas}
      end;

   type pgain_emission=^tgain_emission;
        tgain_emission=array[0..2000] of integer;


 const
{adresses des cartes
ABCDEF
000001:compteur temps (lsb)
100001:compteur temps
010001:compteur temps
110001:compteur temps (msb)
001001:mmoire des controles b0:mem2,b1:mem1 (entre ext)
       b2:blocage compteur,b3..b7:sortie face avant.
101001:memsaut (15 bits bas +saut gnral)
011001:memsaut (bit du haut)
000xx0:amplitude (lsb)
100xx0:amplitude (msb)+2 sorties face avant
010xx0:dephaseur (lsb)
110xx0:dephaseur (msb (4 bits)+Phld($10)+frsel($20)+frld($40))
001xx0:port sup (PA)
101xx0:port sup (PB)
011xx0:port sup (PC)
         DE
on a xx:=00 pour la reception
       :=10 pour le canal A
       :=01 pour le canal B
       :=11 pour le canal C}

memga1=$8;{lsb}memga2=$9;memgb1=$10;memgb2=$11;memgc1=$18;memgc2=$19;
mempa1=$A;mempa2=$B;mempb1=$12;mempb2=$13;mempc1=$1A;mempc2=$1B;
memsa1=$C;memsa2=$D;memsa3=$E;
memsb1=$14;memsb2=$15;memsb3=$16;
memsc1=$1C;memsc2=$1D;memsc3=$1E;
memtem1=$20;{lsb}memtem2=$21;memtem3=$22;memtem4=$23;
memsaut1=$25;memsaut2=$26;memcont=$24;
omemga=$18;omemgb=$1C;
omempa=$19;omempb=$1D;
omemsa=$0B;
omemtem1=$8;{16 bits bas}omemtem2=$9;{16 bits haut}
omemtem3=$0A{8 bit restants+controle};
lowup=$80; {pio8 en B7}
readwr=$10;{pio9 en co}
bitsaut=$1;
valext=$2;
bloc=$4;
bf1=$8;
bf2=$10;
bf3=$20;
bf4=$40;
ca1=$40;{octet de poid fort du gain}
ca2=$80;{octet de poid fort du gain}
pa1seq=$308;
pb1seq=pa1seq+1;
pc1seq=pb1seq+1;
pco1seq=pc1seq+1;
pa2seq=$30C;
pb2seq=pa2seq+1;
pc2seq=pb2seq+1;
pco2seq=pc2seq+1;
pafreq=$300;
pbfreq=pafreq+1;
pcfreq=pbfreq+1;
pcofreq=pcfreq+1;
padeph=$304;
pbdeph=padeph+1;
pcdeph=pbdeph+1;
pcodeph=pcdeph+1;
{pco :port commande format :1(MSB),0,0
(1:portA in,0:port A out),(1:portB in,0:port B out)
(1:portC up in,0:port C up out),(1:portC down in,0:port C down out),0
exemple :out pco,$80 : tout en sortie}

const {sequenceur olivier}
data_pfaible = $30C;       {D0..D7}
data_pfort = $30D;         {D8..D15}
decodage = $30E;           {X-X-F-E-D-C-B-A}
ctrl_pia_data = $30F;      {Port de ctrl PIA 1}
addr_pfaible = $304;       {Add0..Add7}
addr_pfort = $305;         {Add8..Add15}
ctrl_sequenceur = $306;    {PC/SE-PS/DSP-PIO3-PIO2-P2-P1-A2-A1}
ctrl_pia_addr = $307;      {Port de ctrl PIA 2}
addr_dsp_pfaible = $308;   {AddDSP0..AddDSP7}
addr_dsp_pfort = $309;     {AddDSP8..AddDSP15}
ctrl_dsp = $30A;           {MARK-PRESET-MR-W-nc-Flg3-Flg2-Flg1}

ctrl_pia_dsp = $30B;       {Port de ctrl PIA 3}



function compilo(sequenceur:ptypseq;gain_emission:pgain_emission):boolean;{compile la sequence pour sequenceur olivier}
procedure deparseqo;
procedure chargeseqo(sequenceur:ptypseq);
procedure stopseqo;
procedure redemarreseqo;

implementation

type
bin=array[1..26,1..2] of byte;

type
bin1=array[1..12,1..2] of word;

type
psau=^sau;
sau=array[0..4095] of longint;

{*****************************************************************************}

function prepga(a:word):word;
label
bou1;
var
b:word;
begin
asm
mov ax,a
xor bx,bx
shl ax,3
rcr bx,1
mov ecx,13

{il se bloque longtemps dans la boucle suivante quand on change un gain de pulse:}
bou1: shl ax,1
rcr bx,1
loop bou1

shr bx,2
mov b,bx
end;
prepga:=b;
end;

function compilo(sequenceur:ptypseq;gain_emission:pgain_emission):boolean;
{Compilation conue pour trois voies parrallles d'emission A, B et C}
var
binb,cbin:bin1;         {binaire 12x2 pour la mmoire}
fich2:file of longint;
fich1:file of bin1;
fich:file of byte;
fich3:file of typseq;
name : string;
s:array[1..20] of string[20];
s1,s2,s3:string;
GA,GB,GC,temga:word;
PA,PB,PC:integer;
oldPA,oldPB,oldPC:integer;
temp,jump,wjump,util,jumps:longint;
temlo,temhi:word;
ac,fi,de,w,sp:boolean;
bou:integer;
C:array[1..26] of boolean;  {flag pour les sorties switch}
l:array[1..26,1..2] of longint; {flag + adresse label}
F1t,F2t,F3t:boolean;
oldF1t,oldF2t,oldF3t:boolean;
GR,PR:integer;
b1,b2,b3,b4,b5,b6:integer;
oct:byte;
fin,fint:boolean;
vallong:longint;
valreal:real;
valint:integer;
lll,numlign:longint;
nummax:integer;
numvalid:boolean;
err,i,erreur:integer;
j:byte;
k,adsaut,adsau1:integer;
mt:array[0..15] of char;
sa:psau; {pointeur vers table fifo}

begin
dispose(sa);
sa:=new(psau);     {initialisation tableau fifo}
ga:=0;gb:=0;gc:=0;pa:=0;pb:=0;pc:=0;temp:=100;
oldpa:=pa;oldpb:=pb;oldpc:=pc; {gestion handshake de la phase rapide}
f1t:=false;f2t:=false;f3t:=false;
oldf1t:=false;oldf2t:=false;oldf3t:=false;
for i:=1 to 26 do c[i]:=false;   {switch a zero}
for i:=1 to 26 do l[i,1]:=0;l[i,2]:=0;  {labels non actifs}
adsaut:=0;  {fifo initialis}

{bin is main memory data}
name:=copy(Sequenceur^.NomSeq,1,length(Sequenceur^.NomSeq))+'.bin';
assign(fich1,name);
rewrite(fich1);

{sau is jump memory data}
name:=copy(Sequenceur^.NomSeq,1,length(Sequenceur^.NomSeq))+'.sau';
assign(fich2,name);
rewrite(fich2);

{------placement binaire-------}
for i:=1 to 8 do binb[i,1]:=0;
binb[1,2]:=omempa;binb[2,2]:=omemga;
binb[3,2]:=omempb;binb[4,2]:=omemgb;
binb[5,2]:=omemtem1;binb[6,2]:=omemtem2;
binb[7,2]:=omemtem3;binb[8,2]:=omemsa;
{------placement binaire fin-------}

{seq is the text file of the sequence}
name:=copy(Sequenceur^.NomSeq,1,length(Sequenceur^.NomSeq))+'.seq';
assign(fich,name);
if FileExists(name) then begin
reset(fich);
numlign:=0;fint:=false;numvalid:=false;wjump:=0;
while (not eof(fich)) and (not fint) do {traitement de chaque ligne}
begin
for i:=1 to 20 do s[i]:='';
fin:=false;
bou:=0;
de:=false;fi:=false;sp:=false;ac:=false;w:=false;jump:=-1;
for i:=1 to 26 do c[i]:=false; {switch descendus par defaut a zero}
i:=1;{premiere sous-chaine}
while not fin do begin
read(fich,oct); {lecture chaine caractere par caractere}
if (oct>=$61{a}) and (oct<=$7A{z}) then oct:=oct-$20;{passage majuscule}
if ((oct>=$30) and (oct<=$39)) or ((oct>=$41) and (oct<=$5A)) then
s[i]:=s[i]+chr(oct);
if length(s[i])=19 then fin:=true;
if (oct=ord(';')) then fin:=true; {fin de la chaine}
if (oct=ord(',')) then i:=i+1; {passage sous-chaine suivante}
if (oct=ord('.')) then begin fin:=true;fint:=true;end;{fin de la sequence}
if i>20 then fin:=true;
end;
nummax:=i; {nombre de sous-chaines a traiter}
{------traitement--------}
for i:=1 to nummax do begin {boucle traitement des sous-chaines}
s1:=copy(s[i],1,1);s2:=copy(s[i],1,2);
{si ga affecte la nouvelle valeur du gain 'permanente'}
if s2='GA' then  {test gain A}
 if copy(s[i],3,1)='A' then
        begin  {gain preprogramm}
            strpcopy(mt,copy(s[i],4,1));
            j:=ord(mt[0])-$40; {rang du caractere pre-programm}
            if (j>=1) and (j<=10) then ga:=gain_emission^[sequenceur^.ampli[j].val];{lecture valeur gain}
        {VB: J'enlve la possibilite de gain preprogramm divers (voir aussi GB et GC)
        end else
            if copy(s[i],3,1)='D' then
               begin
                   strpcopy(mt,copy(s[i],4,1));
                   j:=ord(mt[0])-$40;
                   if (j>=1) and (j<=10) then ga:=gain_emission^[curpa^.diver[j].val];}
        end else
            begin {valeur numerique}
                val(copy(s[i],3,length(s[i])-2),valint,err);
                if (err=0) and (valint<=2000) and (valint>=0) then ga:=gain_emission^[valint];
        end;
if s2='GB' then
 if copy(s[i],3,1)='A' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then gb:=gain_emission^[sequenceur^.ampli[j].val];
   {end else
    if copy(s[i],3,1)='D' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then gb:=gain_emission^[curpa^.diver[j].val];}
    end else begin
    val(copy(s[i],3,length(s[i])-2),valint,err);
    if (err=0) and (valint>=0) and (valint<=2000) then gb:=gain_emission^[valint];
    end;
if s2='GC' then
 if copy(s[i],3,1)='A' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then gc:=gain_emission^[sequenceur^.ampli[j].val];
   {end else
    if copy(s[i],3,1)='D' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then gc:=gain_emission^[curpa^.diver[j].val];}
    end else begin
    val(copy(s[i],3,length(s[i])-2),valint,err);
    if err=0 then gc:=gain_emission^[valint];
    end;
    {lecture phase}
if s2='PA' then
 if copy(s[i],3,1)='P' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pa:=round(4096.0*sequenceur^.phase[j].val/3600) mod 4096;
   {end else
    if copy(s[i],3,1)='D' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pa:=round(4096.0*curpa^.diver[j].val/3600) mod 4096;}
    end else begin
    val(copy(s[i],3,length(s[i])-2),valint,err);
    if err=0 then pa:=round(4096.0*valint/3600) mod 4096;
    end;
if s2='PB' then
 if copy(s[i],3,1)='P' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pb:=round(4096.0*sequenceur^.phase[j].val/3600) mod 4096;
   {end else
    if copy(s[i],3,1)='D' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pb:=round(4096.0*curpa^.diver[j].val/3600) mod 4096;}
    end else begin
    val(copy(s[i],3,length(s[i])-2),valint,err);
    if err=0 then pb:=round(4096.0*valint/3600) mod 4096;
    end;
if s2='PC' then
 if copy(s[i],3,1)='P' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pc:=round(4096.0*sequenceur^.phase[j].val/3600) mod 4096;
   {end else
    if copy(s[i],3,1)='D' then begin
    strpcopy(mt,copy(s[i],4,1));
    j:=ord(mt[0])-$40;
    if (j>=1) and (j<=10) then pc:=round(4096.0*curpa^.diver[j].val/3600) mod 4096;}
    end else begin
    val(copy(s[i],3,length(s[i])-2),valint,err);
    if err=0 then pc:=round(4096.0*valint/3600) mod 4096;
    end;
    {lecture temps}
if s1='T' then begin
 numvalid:=true;
 if (copy(s[i],2,1)>='A') and (copy(s[i],2,1)<='Z') then begin
    strpcopy(mt,copy(s[i],2,1));
    j:=ord(mt[0])-$40;
    temp:=sequenceur^.temps[j].val*5;
    end else begin
    val(copy(s[i],2,length(s[i])-1),valreal,err);
    if err=0 then temp:=round(valreal *5)else temp:=100;
    end;
    if temp<=0 then temp:=1;
end;
{mise en place label efface le precedent}
if s1='L' then
 if (copy(s[i],2,1)>='A') and (copy(s[i],2,1)<='Z') then begin
    strpcopy(mt,copy(s[i],2,1));
    j:=ord(mt[0])-$40;
    l[j,1]:=numlign;l[j,2]:=adsaut;
    end;
{declenchement d'un flag quelconque non permanent}
if s1='C' then
 if (copy(s[i],2,1)>='A') and (copy(s[i],2,1)<='Z') then begin
    strpcopy(mt,copy(s[i],2,1));
    j:=ord(mt[0])-$40;
    c[j]:=true;
    end;
{jump vers label}
if s1='J' then jump:=1;
if s2='AC' then ac:=true;{acquisition on non permanent}
if s2='SP' then sp:=true;{sampling acquisition on non permanent}
if s2='DE' then de:=true; {stop sequence conditionnel}
if s2='FI' then fi:=true;{stop sequence}
{jump total marker+retransmit}
if s1='W' then begin
    w:=true;
    wjump:=numlign+$80000;
    end;
{boucles}
if s1='B' then
 if (copy(s[i],2,1)>='A') and (copy(s[i],2,1)<='Z') then begin
     strpcopy(mt,copy(s[i],2,1));
     j:=ord(mt[0])-$40;
     if l[j,1]>0 then begin
      jump:=l[j,1];jumps:=l[j,2];{adresse ligne de saut+adresse saut}
      val(copy(s[i],3,length(s[i])-2),valint,err);
      if err=0 then bou:=valint;{nombre de boucles}
     end;
 end;
if s2='FA' then f1t:=true;{stop the sequence at the end}
if s2='FB' then f2t:=true;
if s2='FC' then f3t:=true;
end;
{------ fin traitement--------}
{-------compilation de la ligne-----------}
erreur:=1; {put the data in the .bin file}
    cbin:=binb;{transfert des ,2}
    temga:=prepga(ga);cbin[2,1]:=temga;
    temga:=prepga(gb);cbin[4,1]:=temga;
    if ga<>0 then cbin[2,1]:=cbin[2,1] or 3;
    if gb<>0 then cbin[4,1]:=cbin[4,1] or 3;
    if c[1] then cbin[2,1]:=cbin[2,1] or $4000;{CA}
    if c[2] then cbin[2,1]:=cbin[2,1] or $8000;{CB}
    if c[3] then cbin[4,1]:=cbin[4,1] or $4000;{CC}
    if c[4] then cbin[4,1]:=cbin[4,1] or $8000;{CD}
    if c[5] then cbin[7,1]:=cbin[7,1] or $200;{CE}
    if c[6] then cbin[7,1]:=cbin[7,1] or $800;{CF}
    cbin[1,1]:=((pa div 16)and 255)+(pa and 15)*256;
    cbin[3,1]:=((pb div 16)and 255)+(pb and 15)*256;
    if not f1t then begin
    cbin[1,1]:=cbin[1,1]+$2000; {f1t faux 2eme frequence vrai 1ere frequence}
    end else begin
    cbin[1,1]:=cbin[1,1]+$2001;
    end;
    if (pa=oldpa) then cbin[1,1]:=$1000+cbin[1,1];
    if (f1t=oldf1t) then cbin[1,1]:=$4000+cbin[1,1];{gere frload dds}
    if not f2t then cbin[3,1]:=cbin[3,1]+$2000;
    if (pb=oldpb) then cbin[3,1]:=$1000+cbin[3,1];
    if (f2t=oldf2t) then cbin[3,1]:=$4000+cbin[3,1];
    temlo:=temp and $FFFF;temhi:=temp div $FFFF;
    cbin[5,1]:=temlo;cbin[6,1]:=temhi;
    if fi then cbin[7,1]:=cbin[7,1] or $400;
    if de then cbin[7,1]:=cbin[7,1] or $100;
    if (jump=-1) then cbin[7,1]:=cbin[7,1] or $F000;
    if bou>1 then begin
     adsau1:=adsaut;
     for k:=1 to bou-1 do
     begin
      for lll:=jumps to adsau1-1 do begin
      write(fich2,sa^[lll]);sa^[adsaut]:=sa^[lll];adsaut:=adsaut+1;
      end;
     end;
     numvalid:=false;
    end;
    if w then write(fich2,wjump);
    if numvalid then begin
    write(fich1,cbin);{numero de ligne memoire}
    sa^[adsaut]:=numlign;adsaut:=adsaut+1; {numero de ligne memoire}
    if (not w) then write(fich2,numlign);{ecriture fifo case memoire}
    numlign:=numlign+1;{numero de ligne ecrit}
    end;
    oldpa:=pa;oldpb:=pb;oldpc:=pc;numvalid:=true;
    oldf1t:=f1t;oldf2t:=f2t;oldf3t:=f3t;
    end;
    close(fich);
    end;
    close(fich1);
    close(fich2);
    end;


procedure deparseqo;
    begin
    asm
    {Port[ctrl_sequenceur]:=$70;} {PC/SE=0 PC/DSP=1 PIO3=1 PIO2=1}
            mov dx,ctrl_sequenceur
            mov al,$70
            out dx,al

    {Port[ctrl_sequenceur]:=$60;} {PC/SE=0 PC/DSP=1 PIO3=1 PIO2=0}
            mov dx,ctrl_sequenceur
            mov al,$60
            out dx,al

    {Port[ctrl_sequenceur]:=$70;} {PC/SE=0 PC/DSP=1 PIO3=1 PIO2=1 P2=1 P1=0 A2=1 A1=0}
            mov dx,ctrl_sequenceur
            mov al,$70
            out dx,al
      end;

    end;



procedure chargeseqo(sequenceur:ptypseq);
    var
    cbin:bin1;
    fich2:file of longint;
    fich1:file of bin1;
    value:longint;
    val1,val2:word;
    i:integer;
    v1,v2,v3,v4:byte;
    addre:integer;
    int1_addre,int2_addre:shortint;
    name:string;

begin
    asm
    {Port[ctrl_pia_data]:=$80;}        {PIA data en sortie}
            mov dx,ctrl_pia_data
            mov al,$80
            out dx,al
    {Port[ctrl_pia_addr]:=$80;}        {PIA Add en sortie}
            mov dx,ctrl_pia_addr
            mov al,$80
            out dx,al
    {Port[ctrl_pia_dsp]:=$80;}         {PIA DSP sortie & entre}
            mov dx,ctrl_pia_dsp
            mov al,$80
            out dx,al
    {arret sequence, passage adressage PC}
     {Port[ctrl_sequenceur]:=$90;}   {le PC gere le bus Add de la RAM}
            mov dx,ctrl_sequenceur
            mov al,$90
            out dx,al
     {Port[ctrl_dsp]:=$F8;}                  {Aucun signal de ctrl de la FiFO actif}
            mov dx,ctrl_dsp
            mov al,$F8
            out dx,al
    end;
      {--------chargement donnes--------------}
    name:=copy(Sequenceur^.NomSeq,1,length(Sequenceur^.NomSeq))+'.bin';
    assign(fich1,name);
    if FileExists(name) then begin
    reset(fich1);
    addre:=0;
    while not eof(fich1) do begin
    read(fich1,cbin);

    {port[addr_pfaible]:=addre mod 256;
    port[addr_pfort]:=addre div 256;}
    int1_addre:=addre mod 256;
    int2_addre:=addre div 256;
    asm
    mov dx,addr_pfaible
    mov al,int1_addre
    out dx,al

    mov dx,addr_pfort
    mov al,int2_addre
    out dx,al
    end;

    for i:=1 to 8 do begin
    v1:=cbin[i,1] mod 256;v2:=cbin[i,1] div 256;
    v3:=cbin[i,2] mod 256;{v1 donne  crire,v2 adresse ABCDEF}
    {port[data_pfaible]:=v1;
    port[data_pfort]:=v2;
    Port[decodage]:=$07;
    Port[decodage]:=v3;
    Port[decodage]:=$07;}
    asm
    mov dx,data_pfaible
    mov al,v1
    out dx,al

    mov dx,data_pfort
    mov al,v2
    out dx,al

    mov dx,decodage
    mov al,$07
    out dx,al

    mov dx,decodage
    mov al,v3
    out dx,al

    mov dx,decodage
    mov al,$07
    out dx,al
    end;
    end;
    addre:=addre+1;
    end;
    close(fich1);
    asm
    {port[data_pfaible]:=0;
    port[data_pfort]:=0;}
    mov dx,data_pfaible
    mov al,0
    out dx,al

    mov dx,data_pfort
    mov al,0
    out dx,al
    end;
    end;

    {Raz fifo}
    {Port[ctrl_dsp]:=$F0;}     {W=1 Avant MR=0}
    {Port[ctrl_dsp]:=$F0;}     {W=1 Avant MR=0}
    {Port[ctrl_dsp]:=$D0;}     {MR=0}
    {Port[ctrl_dsp]:=$D0;}     {MR=0}
    {Port[ctrl_dsp]:=$F0;}
    {Port[ctrl_dsp]:=$F0;}
    asm
    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$D0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$D0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    end;

   {ecrit fifo}
   name:=copy(Sequenceur^.NomSeq,1,length(Sequenceur^.NomSeq))+'.sau';
    assign(fich2,name);
    if FileExists(name) then begin
    reset(fich2);
    while not eof(fich2) do begin
    read(fich2,value);
    val1:=value mod $10000;val2:=value div $FFFF;
    v1:=lo(val1);v2:=hi(val1);
    v3:=lo(val2);v4:=hi(val2);
    {Port[addr_dsp_pfort]:=v2;
    Port[addr_dsp_pfaible]:=v1;
    Port[ctrl_dsp]:=$F0;
    Port[ctrl_dsp]:=$E0;}     {w=0}
    {Port[ctrl_dsp]:=$F0;}
    asm
    mov dx,addr_dsp_pfort
    mov al,v2
    out dx,al

    mov dx,addr_dsp_pfaible
    mov al,v1
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$E0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al
    end;

    if v3=$8 then
    begin
    {Port[ctrl_dsp]:=$F0;
    Port[ctrl_dsp]:=$F0;
    Port[ctrl_dsp]:=$70;}     {MARK=0}
    {Port[ctrl_dsp]:=$70;}     {MARK=0}
    {Port[ctrl_dsp]:=$F0;
    Port[ctrl_dsp]:=$F0;}

    asm
    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$70
    out dx,al

    mov dx,ctrl_dsp
    mov al,$70
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al

    mov dx,ctrl_dsp
    mov al,$F0
    out dx,al
    end;


    end;
    end;
    close(fich2);
    end;
    end;

procedure stopseqo;
    begin
    {Port[ctrl_sequenceur]:=$50;} {PC/SE=0 PC/DSP=1 PIO3=1 PIO2=0}
    asm
    mov dx,ctrl_sequenceur
    mov al,$50
    out dx,al
    end;
    end;

procedure redemarreseqo;
    begin
    {Port[ctrl_sequenceur]:=$70;} {PC/SE=0 PC/DSP=1 PIO3=1 PIO2=0}
    asm
    mov dx,ctrl_sequenceur
    mov al,$70
    out dx,al
    end;
    end;



end.
