unit grilles;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,stdctrls,Menus,extctrls;

const
wm_jesors=wm_user+500;
wm_selection=wm_user+501;
wm_oldselect=wm_user+502;
wm_quitcombo=wm_user+503;
type
    tmycombobox = class(Tcombobox)
    private
    protected
    procedure doexit; override;
    procedure doenter; override;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
    procedure WMkillfocus(var Message: Tmessage); message WM_killfocus;
    public
    x,y:integer;
    newx,newy:integer;
    fleche:boolean;
    order:integer;
end;

type
  tgrille = class(TStringGrid)
  private
  FOnEnter:tnotifyevent;
  Fcoltype:array[0..50] of integer;
  Fcount:integer;
  Fcolcomment:tstringlist;
  Fcommentaire:boolean;
  fcolcolor:variant;
  { Dclarations prives }
  function GetColtype(Index: Integer): integer;
  procedure SetColtype(Index: Integer; Value: integer);
  function GetColcolor(Acol,Arow: Integer):integer;
  procedure SetColcolor(Acol,Arow: Integer; Value:integer);
  procedure SetCommentaire(Value: boolean);
  procedure wmjesors( var message:tmessage); message wm_jesors;
  protected
  function SelectCell(ACol, ARow: Longint): Boolean; override;
    { Dclarations protges }
  procedure DrawCell(ACol, ARow: Longint; ARect: TRect;
  AState: TGridDrawState);override;
  procedure SetLines(Value: TStringlist);
  public
  fbox:array[1..10] of tmycombobox;
    Fcomment:word;
      { Dclarations publiques }
  property Coltype[Index: Integer]: integer read GetColtype write SetColtype;
  property cellcolor[Acol,arow: Integer]:integer read GetColcolor write SetColcolor;
  property InplaceEditor;
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  published
  procedure loaded; override;
  property onenter;
  property count:integer read fcount write fcount;
  procedure doenter; override;
  property commentaire:boolean read fcommentaire write setcommentaire;
  property Colcomment: tstringlist read fColcomment write setlines;
      { Dclarations publies }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Claude', [tgrille]);
end;

procedure Tmycombobox.doenter;
begin
newx:=x;newy:=y;fleche:=false;
inherited;
end;

procedure Tmycombobox.doexit;
begin
sendmessage(parent.handle,wm_jesors,x+256*y,order);
visible:=false;
inherited;
end;

procedure Tmycombobox.WMkillfocus(var Message: Tmessage);
begin
visible:=false;
end;


procedure Tmycombobox.WMKeyDown(var Message: TWMKeyDown);
begin
if message.charcode=vk_tab then begin
newx:=x+1;newy:=y;fleche:=true;doexit;end;
if message.charcode=vk_left then begin
newx:=x-1;newy:=y;fleche:=true;doexit;end;
if message.charcode=vk_right then begin
newx:=x+1;newy:=y;fleche:=true;doexit;end;
inherited;
end;

constructor TGrille.Create(AOwner: TComponent);
var
i:integer;
begin
  inherited Create(AOwner);
  for i:=1 to 10 do begin
  fbox[i]:=tmycombobox.create(self);
  fbox[i].parent:=self;
  fbox[i].top:=300;
  fbox[i].order:=i;
  end;
  fcolcomment:=tstringlist.create;
  options:=[goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
    goRangeSelect, goDrawFocusSelected,goColSizing,
    goColMoving, goEditing, goTabs,goAlwaysShowEditor, goThumbTracking];
end;

procedure TGrille.loaded;
var
i,j:integer;
mt:array[0..100] of char;
s:string;
begin
inherited;
fcolcolor:=vararraycreate([0,colcount,0,rowcount],varinteger);
for i:=0 to colcount do begin
fcoltype[i]:=0;
for j:=0 to rowcount do fcolcolor[i,j]:=font.color;
end;
for i:=1 to 10 do fbox[i].visible:=false;
if fcolcomment.count>1 then
begin
strpcopy(mt,fcolcomment[1]);
sendmessage(fcomment,wm_settext,0,longint(@mt));
end;
for i:=1 to rowcount do
begin str(i:2,s);cells[0,i]:=s;end;
end;

procedure Tgrille.DoEnter;
var
i,j:integer;
rect:trect;
begin
  if not fcommentaire then begin
showwindow(fcomment,sw_hide);
  end;
  if Assigned(FOnEnter) then FOnEnter(Self);
for i:=1 to 10 do fbox[i].visible:=false;
  for i:=1 to colcount do begin
  if (fcoltype[i]>1) and (fcoltype[i]<11) then begin
  rect:=CellRect(i,1);
  j:=fcoltype[i]-1;
  with fbox[j] do begin
  width:=rect.right-rect.left;
  height:=100;
  left:=rect.left;
  top:=rect.top;
  refresh;
  style:=csDropDownList;
  order:=fcoltype[i]-1;
  end;
  end;
  end;
  end;

 procedure Tgrille.SetLines(Value: TStringlist);
begin
  Fcolcomment.Assign(Value);
end;


function Tgrille.SelectCell(ACol, ARow: Longint): Boolean;
const
numset=['0'..'9',' ','.',',','E','-','+'];
var
valid:boolean;
le,i,j:integer;
mt:array[0..20] of char;
rect:trect;
begin
result:=true;
if fcoltype [col]=1 then begin
        for i:=1 to 10 do fbox[i].visible:=false;
        valid:=true;
        strpcopy(mt,cells[col,row]);
        le:=strlen(mt);
        i:=0;
        while valid and (i<le) do
        begin
        valid:=(mt[i] in numset);
        inc(I);
        end;
        for i:=0 to le-1 do
        begin
        if (mt[i]=',') then mt[i]:='.';
        end;
        settextbuf(mt);
        j:=0;
        for i:=0 to le-1 do
        begin
        if (mt[i]='.') then j:=j+1;
        end;
        if j>=2 then valid:=false;
  if not valid then begin
     messagebox(handle,'nombre illgal','ERREUR!',mb_ok);
     result:=false;end else result:=true;
end;
if result=true then begin
   if (fcoltype[Acol]<=1) then
   begin
   if fcommentaire then begin
   if acol<fcolcomment.count then begin
   strpcopy(mt,colcomment[Acol]);
   sendmessage(fcomment,wm_settext,0,longint(@mt));end;
   end;
   result:=true;
   end;
   if (fcoltype[Acol]>1) and (fcoltype[Acol]<12) then begin
    rect:=CellRect(Acol,arow);
    j:=fcoltype[Acol]-1;
     with fbox[j] do begin
     width:=rect.right-rect.left;
     height:=100;
     left:=rect.left;
     top:=rect.top;
     refresh;
     visible:=true;
     setfocus;
     style:=csDropDownList;
     x:=Acol; y:=Arow;
     itemindex:=items.indexof(cells[Acol,Arow]);
     end;
    result:=false;
   if fcommentaire then begin
   if acol<fcolcomment.count then begin
   strpcopy(mt,colcomment[Acol]);
   sendmessage(fcomment,wm_settext,0,longint(@mt));end;
   end;
   end;
  if fcoltype[Acol]>=12 then  result:=false;
end;
if result=true then
sendmessage(parent.handle,wm_oldselect,col,row);
sendmessage(parent.handle,wm_selection,acol,arow);
end;

procedure Tgrille.wmjesors( var message:tmessage);
var
x,y:integer;
begin
sendmessage(parent.handle,wm_quitcombo,message.wparam,message.lparam+handle*256);
if fbox[message.lparam].itemindex<>-1 then begin
cells[integer(message.wparam) mod 256 ,integer(message.wparam) div 256]:=
fbox[message.lparam].items[fbox[message.lparam].itemindex];
end;
fbox[message.lparam].visible:=false;
setfocus;
if fbox[message.lparam].fleche then begin
x:=fbox[message.lparam].x;y:=fbox[message.lparam].y;
if (fbox[message.lparam].newx<>x) or (fbox[message.lparam].newy<>y) then begin
if (fbox[message.lparam].newx<=colcount) and (fbox[message.lparam].newx>=1) then
col:=fbox[message.lparam].newx;
if (fbox[message.lparam].newy<=rowcount) and (fbox[message.lparam].newy>=1) then
row:=fbox[message.lparam].newy;
end;
end;
end;

destructor TGrille.Destroy;
begin
inherited {destroy};
end;

function Tgrille.GetColtype(Index: Integer): integer;
begin
if (index<=50) and (index>=0) then getcoltype:=fcoltype[index] else getcoltype:=-1;
end;

procedure Tgrille.SetColtype(Index: Integer; Value: integer);
begin
if (index<=50)and (index>=0) then fcoltype[index]:=value;
end;

function Tgrille.GetColcolor(Acol,Arow: Integer):integer;
begin
if (Acol<=colcount) and (Arow<=rowcount) then getcolcolor:=fcolcolor[Acol,Arow] else getcolcolor:=color;
end;

procedure Tgrille.SetColcolor(Acol,Arow: Integer; Value:integer);
begin
if (Acol<=colcount) and (Arow<=rowcount) then fcolcolor[Acol,Arow]:=value;
end;


procedure Tgrille.Setcommentaire(Value: boolean);
begin
fcommentaire:=value;
if value then showwindow(fcomment,sw_show)
else showwindow(fcomment,sw_hide);;
end;

procedure TGrille.DrawCell(ACol, ARow: Longint; ARect: TRect;
  AState: TGridDrawState);

  procedure DrawCellText;
  var
    S: string;
  begin
    S := Cells[ACol, ARow];
    if vartype(fcolcolor) and $2000 <>0 then
    if (acol<=vararrayhighbound(fcolcolor,1)) and
    (arow<=vararrayhighbound(fcolcolor,2)) then
     canvas.font.color:=fcolcolor[acol,arow];
    ExtTextOut(Canvas.Handle, ARect.Left + 2, ARect.Top + 2, ETO_CLIPPED or
      ETO_OPAQUE, @ARect, PChar(S), Length(S), nil);
  end;

begin
  if DefaultDrawing then DrawCellText;
  inherited DrawCell(ACol, ARow, ARect, AState);
end;


end.
