{ copyright  Kestral Computing
  refer to xyGraph.pas for more information }

{!!}
{3.02.001  06 Jul 98 9:12    User : Grahame Grieve    
Comment: 
          Tidy-up documentation for 3.20 release}

unit XyReg;

interface

uses DsgnIntf;

type
  TxyGraphCompEditor = class (TComponentEditor)
  public
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
    procedure Copy; override;
  end;

procedure Register;

implementation

uses xydesign, xyDatWiz, xygraph, xyHolder, classes, dialogs;

function TxyGraphCompEditor.GetVerb(Index: Integer): string;
begin
  case Index of
   0:result := '&Designer...';
   1:result := 'Series &Wizard...';
   2:result := '&Print';
   3:result := 'Load from &Template';
  end;
end;

function TxyGraphCompEditor.GetVerbCount: Integer;
begin
  result := 4;
end;

procedure TxyGraphCompEditor.ExecuteVerb(Index: Integer);
var od:TOpenDialog;
begin
  case index of
   0: if editxyGraph(nil, component as txyGraph) then designer.modified;
   1: if ShowxyDataWizard(nil, component as txyGraph) then designer.modified;
   2: (component as txyGraph).Print;
   3: begin
       od := TOpenDialog.create(nil);
       if od.execute then
         begin
         (component as txyGraph).readfromfile(od.filename);
         designer.modified;
         end;
      end;
  end;
end;

procedure TxyGraphCompEditor.edit;
begin
  {editgraph;}
end;

procedure TxyGraphCompEditor.copy;
begin
  (component as txyGraph).CopytoClipboard;
end;

procedure Register;
begin
  RegisterComponents('TxyGraph', [TxyGraph]);
  RegisterComponents('TxyGraph', [TxyHolder]);
  RegisterComponentEditor(TxyGraph, TxyGraphCompEditor);
end;

end.

