unit Operations;
{ A NOTER }
{ * il faut que tous les champ des la database contiennent une valeur, sinon il y a risque d'erreur (pas grave) }
{   ex: il faut preciser un canal meme pour les TTI3510 meme s'il est non significatif                          }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Spin, PBSpinEdit, TTI3510, CLET183, PBNumEdit,
  ExtCtrls;

type
  Toperationform = class(TForm)
    IndexApp: TPBSpinEdit;
    Label1: TLabel;
    Button1: TButton;
    TableConfigManip: TTable;
    Edit1: TEdit;
    TableAppareils: TTable;
    Button2: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    Flipper1ON: TButton;
    Flipper1OFF: TButton;
    Flipper2ON: TButton;
    Flipper2OFF: TButton;
    Panel1: TPanel;
    FieldT: TPBNumEdit;
    Label3: TLabel;
    SetField: TButton;
    Button3: TButton;
    Courant: TPBNumEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Flipper2ONClick(Sender: TObject);
    procedure Flipper2OFFClick(Sender: TObject);
    procedure Flipper1ONClick(Sender: TObject);
    procedure Flipper1OFFClick(Sender: TObject);
    procedure SetFieldClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { functions a usage general }
    function GetIndex(fonction:string):longint;
    function GetTypeAppareil(index:longint):string;
    function GetAdresse(index:longint):longint;
    function GetCanal(index:longint):longint;
    function GetValMax(index:longint):real;
    function GetConvA(index:longint):real;
    { pilotage des flippers }
    function Flipper1_ON:integer;      { ok }
    function Flipper1_OFF:integer;     { ok }
    function Flipper2_ON:integer;      { ok }
    function Flipper2_OFF:integer;     { ok }
    function SetCourantFlipper1H(I:real):integer;
    function SetCourantFlipper1V(I:real):integer;
    function SetCourantFlipper2H(I:real):integer; { ok }
    function SetCourantFlipper2V(I:real):integer;
    { pilotage du champ }
    function SetChampL(value:real):integer;
    function SetFieldT(FieldValue:real):integer;
    function SetChampP(value:real):integer;
    function ReadChampL(value:real):integer;
    function ReadChampT(value:real):integer;
    function ReadChampP(value:real):integer;
    { pilotage temperature }
    function ReadTemperatureRegul:real; { lecture de la temperature sur le canal de regulation }
    { pilotage des alim de tension }
    function SetTension1(value:real):integer;
{    function SetCourant1(value:real):integer; }
    function SetTension2(value:real):integer;
{    function SetCourant2(value:real):integer; }
    { Dclarations publiques }
  end;

var
  operationform: Toperationform;

implementation
const
test=false;

{$R *.DFM}

{ fonction retournant l'index d'un appareil associe a une fonction donne }
{ INPUT: fonction : string                                                 }
{ OUTPUT: l'index de l'appareil                                            }
function Toperationform.GetIndex(fonction:string):longint;
var aux:longint;
begin
     TableConfigManip.Locate('Fonction',fonction,[loCaseInsensitive]);
     if test then Writeln(TableConfigManip.FieldValues['Indexappareil']);
     aux:=TableConfigManip.FieldValues['Indexappareil'];
     GetIndex:=aux;
end;

{ fonction retournant le type d'appareil associe a un index d'appareil    }
{ INPUT: index: longint                                                }
{ OUTPUT: type de l'appareil (trouv dans DB 'Appareils')              }
function Toperationform.GetTypeAppareil(index:longint):string;
var s:string;
begin
     TableAppareils.Locate('Index',index,[loCaseInsensitive]);
     if test then Writeln(TableAppareils.FieldValues['TypeAppareil']);
     s:=TableAppareils.FieldValues['TypeAppareil'];
     GetTypeAppareil:=s;
end;

{ fonction retournant l'adresse d'un appareil associe a un index d'appareil    }
{ INPUT: index : index de l'appareil dans la table Appareils }
{ OUTPUT: le champ adresse de l'appareil 'index'                          }
function Toperationform.GetAdresse(index:longint):longint;
var ad:longint;
begin
     TableAppareils.Locate('Index',index,[loCaseInsensitive]);
     if test then Writeln(TableAppareils.FieldValues['Adresse']);
     ad:=TableAppareils.FieldValues['Adresse'];
     GetAdresse:=ad;
end;

{ fonction retournant le canal d'un appareil associe a un index d'appareil    }
{ INPUT: index : index de l'appareil dans la table Appareils }
{ OUTPUT: le champ canal de l'appareil 'index'               }
function Toperationform.GetCanal(index:longint):longint;
var canal:longint;
begin
     TableAppareils.Locate('Index',index,[loCaseInsensitive]);
     if test then Writeln(TableAppareils.FieldValues['Canal']);
     canal:=TableAppareils.FieldValues['Canal'];
     GetCanal:=canal;
end;

{ fonction retournant l'adresse d'un appareil associe a un index d'appareil    }
{ INPUT: index : index de l'appareil dans la table Appareils }
{ OUTPUT: le champ adresse de l'appareil 'index'                          }
function Toperationform.GetValMax(index:longint):real;
var valMax:real;
begin
     TableAppareils.Locate('Index',index,[loCaseInsensitive]);
     if test then Writeln(TableAppareils.FieldValues['ValMax']);
     valMax:=TableAppareils.FieldValues['ValMax'];
     GetValMax:=valMax;
end;

{ fonction retournant l'adresse d'un appareil associe a un index d'appareil    }
{ INPUT: index : index de l'appareil dans la table Appareils }
{ OUTPUT: le champ adresse de l'appareil 'index'                          }
function Toperationform.GetConvA(index:longint):real;
var convA:real;
begin
     TableAppareils.Locate('Index',index,[loCaseInsensitive]);
     if test then Writeln(TableAppareils.FieldValues['ConvA']);
     convA:=TableAppareils.FieldValues['ConvA'];
     GetConvA:=convA;
end;

{==================================================}
{ pilotage des flippers                            }
{==================================================}

{ allumage inconditionnel du flipper 1 }
function Toperationform.Flipper1_ON:integer;
var indexH,indexV:longint; { index des appareils branchs sur les flippers H et V }
    taH,taV:string;        { type de l'appareil (bobine H et V)}
    adresseH,adresseV:longint;  { adresses des deux appareils }
begin
     indexH:=GetIndex('Flipper1H');
     indexV:=GetIndex('Flipper1V');
     taH:=GetTypeAppareil(indexH);
     taV:=GetTypeAppareil(indexV);
     adresseH:=GetAdresse(indexH);
     adresseV:=GetAdresse(indexV);
     If taH='TTI3510' then SwitchON_TTI3510(adresseH);
     If taH='CLET183' then SwitchON_CLET183(adresseH);
     If taV='TTI3510' then SwitchON_TTI3510(adresseV);
     If taV='CLET183' then SwitchON_CLET183(adresseV);
end;

function Toperationform.Flipper1_OFF:integer;
var indexH,indexV:longint; { index des appareils branchs sur les flippers H et V }
    taH,taV:string;        { type de l'appareil (bobine H et V)}
    adresseH,adresseV:longint;  { adresses des deux appareils }
begin
     indexH:=GetIndex('Flipper1H');
     indexV:=GetIndex('Flipper1V');
     taH:=GetTypeAppareil(indexH);
     taV:=GetTypeAppareil(indexV);
     adresseH:=GetAdresse(indexH);
     adresseV:=GetAdresse(indexV);
     If taH='TTI3510' then SwitchOFF_TTI3510(adresseH);
     If taH='CLET183' then SwitchOFF_CLET183(adresseH);
     If taV='TTI3510' then SwitchOFF_TTI3510(adresseV);
     If taV='CLET183' then SwitchOFF_CLET183(adresseV);
end;

function Toperationform.Flipper2_ON:integer;
var indexH,indexV:longint; { index des appareils branchs sur les flippers H et V }
    taH,taV:string;        { type de l'appareil (bobine H et V)}
    adresseH,adresseV:longint;  { adresses des deux appareils }
begin
     indexH:=GetIndex('Flipper2H');
     indexV:=GetIndex('Flipper2V');
     taH:=GetTypeAppareil(indexH);
     taV:=GetTypeAppareil(indexV);
     adresseH:=GetAdresse(indexH);
     adresseV:=GetAdresse(indexV);
     If taH='TTI3510' then SwitchON_TTI3510(adresseH);
     If taH='CLET183' then SwitchON_CLET183(adresseH);
     If taV='TTI3510' then SwitchON_TTI3510(adresseV);
     If taV='CLET183' then SwitchON_CLET183(adresseV);
end;

function Toperationform.Flipper2_OFF:integer;
var indexH,indexV:longint; { index des appareils branchs sur les flippers H et V }
    taH,taV:string;        { type de l'appareil (bobine H et V)}
    adresseH,adresseV:longint;  { adresses des deux appareils }
begin
     indexH:=GetIndex('Flipper2H');
     indexV:=GetIndex('Flipper2V');
     taH:=GetTypeAppareil(indexH);
     taV:=GetTypeAppareil(indexV);
     adresseH:=GetAdresse(indexH);
     adresseV:=GetAdresse(indexV);
     If taH='TTI3510' then SwitchOFF_TTI3510(adresseH);
     If taH='CLET183' then SwitchOFF_CLET183(adresseH);
     If taV='TTI3510' then SwitchOFF_TTI3510(adresseV);
     If taV='CLET183' then SwitchOFF_CLET183(adresseV);
end;

{ ajustement du courant dans la bobine horizontale du deuxime flipper }
{ INPUT: I, valeur du courant en amperes                               }
{ OUTPUT: l'alim du flipper delivre le courant                         }
{         si la valeur du courant est trop elevee, retour de la valeur -1 }
{         utile dans les scans en courant                              }
function Toperationform.SetCourantFlipper1H(I:real):integer;
var index:longint; { index des appareils branchs sur les flippers H et V }
    ta:string;        { type de l'appareil (bobine H et V)}
    adresse,canal:longint;  { adresses des deux appareils }
    Imax:real;        { valeur max du courant autoris dans la bobine }
begin
     index:=GetIndex('Flipper1H');
     ta:=GetTypeAppareil(index);
     adresse:=GetAdresse(index);
     canal:=GetCanal(index);
     Imax:=GetValMax(index);
     If I<=Imax then
     begin
          If ta='TTI3510' then SetCourant_TTI3510(adresse,I);
          If ta='CLET183' then SetCourant_CLET183(adresse,canal,I);
     end;
end;

{ ajustement du courant dans la bobine horizontale du deuxime flipper }
{ INPUT: I, valeur du courant en amperes                               }
{ OUTPUT: l'alim du flipper delivre le courant                         }
{         si la valeur du courant est trop elevee, retour de la valeur -1 }
{         utile dans les scans en courant                              }
function Toperationform.SetCourantFlipper1V(I:real):integer;
var index:longint; { index des appareils branchs sur les flippers H et V }
    ta:string;        { type de l'appareil (bobine H et V)}
    adresse,canal:longint;  { adresses des deux appareils }
    Imax:real;        { valeur max du courant autoris dans la bobine }
begin
     index:=GetIndex('Flipper1V');
     ta:=GetTypeAppareil(index);
     adresse:=GetAdresse(index);
     canal:=GetCanal(index);
     Imax:=GetValMax(index);
     If I<=Imax then
     begin
          If ta='TTI3510' then SetCourant_TTI3510(adresse,I);
          If ta='CLET183' then SetCourant_CLET183(adresse,canal,I);
     end;
end;


{ ajustement du courant dans la bobine horizontale du deuxime flipper }
{ INPUT: I, valeur du courant en amperes                               }
{ OUTPUT: l'alim du flipper delivre le courant                         }
{         si la valeur du courant est trop elevee, retour de la valeur -1 }
{         utile dans les scans en courant                              }
function Toperationform.SetCourantFlipper2H(I:real):integer;
var index:longint; { index des appareils branchs sur les flippers H et V }
    ta:string;        { type de l'appareil (bobine H et V)}
    adresse,canal:longint;  { adresses des deux appareils }
    Imax:real;        { valeur max du courant autoris dans la bobine }
begin
     index:=GetIndex('Flipper2H');
     ta:=GetTypeAppareil(index);
     adresse:=GetAdresse(index);
     canal:=GetCanal(index);
     Imax:=GetValMax(index);
     If I<=Imax then
     begin
          If ta='TTI3510' then SetCourant_TTI3510(adresse,I);
          If ta='CLET183' then SetCourant_CLET183(adresse,canal,I);
     end;
end;

{ ajustement du courant dans la bobine horizontale du deuxime flipper }
{ INPUT: I, valeur du courant en amperes                               }
{ OUTPUT: l'alim du flipper delivre le courant                         }
{         si la valeur du courant est trop elevee, retour de la valeur -1 }
{         utile dans les scans en courant                              }
function Toperationform.SetCourantFlipper2V(I:real):integer;
var index:longint; { index des appareils branchs sur les flippers H et V }
    ta:string;        { type de l'appareil (bobine H et V)}
    adresse,canal:longint;  { adresses des deux appareils }
    Imax:real;        { valeur max du courant autoris dans la bobine }
begin
     index:=GetIndex('Flipper2V');
     ta:=GetTypeAppareil(index);
     adresse:=GetAdresse(index);
     canal:=GetCanal(index);
     Imax:=GetValMax(index);
     If I<=Imax then
     begin
          If ta='TTI3510' then SetCourant_TTI3510(adresse,I);
          If ta='CLET183' then SetCourant_CLET183(adresse,canal,I);
     end;
end;


{==================================================}
{ pilotage du champ }
{==================================================}
function Toperationform.SetChampL(value:real):integer;
begin
end;

{ champ transverse }
{ INPUT: FieldValue: valeur du champ a atteindre en mT }
{ OUTPUT: integer: code d'erreur                       }
function Toperationform.SetFieldT(FieldValue:real):integer;
var index:longint; { index des appareils branchs sur les flippers H et V }
    ta:string;     { type de l'appareil }
    adresse:longint;  { adresse appareil }
    convA:real;    { facteur de conversion, ex. Courant(I) = convA * Champ(T) }
begin
     index:=GetIndex('MagneticFieldT');
     ta:=GetTypeAppareil(index);
     adresse:=GetAdresse(index);
     convA:=GetConvA(index);
     If ta='TTI3510'
     then begin
          SetCourant_TTI3510(adresse,convA*FieldValue);
          { SwitchON_TTI3510(adresse); }
          end;
end;

function Toperationform.SetChampP(value:real):integer;
begin
end;

function Toperationform.ReadChampL(value:real):integer;
begin
end;

function Toperationform.ReadChampT(value:real):integer;
begin
end;

function Toperationform.ReadChampP(value:real):integer;
begin
end;

{==================================================}
{ pilotage temperature }
{==================================================}
function Toperationform.ReadTemperatureRegul:real; { lecture de la temperature sur le canal de regulation }
begin
end;

{==================================================}
{ pilotage des alim de tension }
{==================================================}
function Toperationform.SetTension1(value:real):integer;
begin
end;

function Toperationform.SetTension2(value:real):integer;
begin
end;

procedure Toperationform.Button1Click(Sender: TObject);
begin
     Flipper2_ON;
end;

procedure Toperationform.Button2Click(Sender: TObject);
begin
     TableConfigManip.Locate('Fonction','magneticFieldL',[loCaseInsensitive]);
     Writeln(TableConfigManip.FieldValues['Indexappareil']);
end;

procedure Toperationform.Flipper2ONClick(Sender: TObject);
begin
     Flipper2_ON;
end;

procedure Toperationform.Flipper2OFFClick(Sender: TObject);
begin
     Flipper2_OFF;
end;

procedure Toperationform.Flipper1ONClick(Sender: TObject);
begin
     Flipper1_ON;
end;

procedure Toperationform.Flipper1OFFClick(Sender: TObject);
begin
     Flipper1_OFF;
end;

procedure Toperationform.SetFieldClick(Sender: TObject);
begin
     SetFieldT(FieldT.value);
end;

procedure Toperationform.Button3Click(Sender: TObject);
begin
     SetCourantFlipper2H(courant.value);
end;

end.
